/**
 * Analytics API
 * Analytics API.

 * OpenAPI spec version: 20190331
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Analytics Instance metadata.
 *
 */
export interface AnalyticsInstance {
    /**
     * The resource OCID.
     *
     */
    "id": string;
    /**
     * The name of the Analytics instance. This name must be unique in the tenancy and cannot be changed.
     *
     */
    "name": string;
    /**
     * Optional description.
     *
     */
    "description"?: string;
    /**
     * The OCID of the compartment.
     *
     */
    "compartmentId": string;
    /**
     * The current state of an instance.
     *
     */
    "lifecycleState": model.AnalyticsInstanceLifecycleState;
    /**
     * Analytics feature set.
     *
     */
    "featureSet": model.FeatureSet;
    "capacity": model.Capacity;
    /**
     * The license used for the service.
     *
     */
    "licenseType"?: model.LicenseType;
    /**
     * Email address receiving notifications.
     *
     */
    "emailNotification"?: string;
    "networkEndpointDetails": model.PrivateEndpointDetails | model.PublicEndpointDetails;
    /**
     * Map of PrivateAccessChannel unique identifier key as KEY and PrivateAccessChannel Object as VALUE.
     *
     */
    "privateAccessChannels"?: {
        [key: string]: model.PrivateAccessChannel;
    };
    /**
     * Map of VanityUrl unique identifier key as KEY and VanityUrl Object as VALUE.
     *
     */
    "vanityUrlDetails"?: {
        [key: string]: model.VanityUrlDetails;
    };
    /**
     * URL of the Analytics service.
     *
     */
    "serviceUrl"?: string;
    /**
      * Defined tags for this resource. Each key is predefined and scoped to a
  * namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm).
  * <p>
  Example: `{\"Operations\": {\"CostCenter\": \"42\"}}`
  *
      */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
    /**
      * Free-form tags for this resource. Each tag is a simple key-value pair with no
  * predefined name, type, or namespace. For more information, see [Resource Tags](https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm).
  * <p>
  Example: `{\"Department\": \"Finance\"}`
  *
      */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
      * The date and time the instance was created, in the format defined by RFC3339.
  * <p>
  Example: `2016-08-25T21:10:29.600Z`
  *
      */
    "timeCreated": Date;
    /**
     * The date and time the instance was last updated (in the format defined by RFC3339).
     * This timestamp represents updates made through this API. External events do not
     * influence it.
     *
     */
    "timeUpdated"?: Date;
}
export declare namespace AnalyticsInstance {
    function getJsonObj(obj: AnalyticsInstance): object;
}
