/**
 * API Gateway API
 * API for the API Gateway service. Use this API to manage gateways, deployments, and related items.
For more information, see
[Overview of API Gateway](/iaas/Content/APIGateway/Concepts/apigatewayoverview.htm).

 * OpenAPI spec version: 20190501
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * An individual JWT claim.
 */
export interface JsonWebTokenClaim {
    /**
     * Name of the claim.
     */
    "key": string;
    /**
     * The list of acceptable values for a given claim.
     * If this value is \"null\" or empty and \"isRequired\" set to \"true\", then
     * the presence of this claim in the JWT is validated.
     *
     */
    "values"?: Array<string>;
    /**
     * Whether the claim is required to be present in the JWT or not. If set
     * to \"false\", the claim values will be matched only if the claim is
     * present in the JWT.
     *
     */
    "isRequired"?: boolean;
}
export declare namespace JsonWebTokenClaim {
    function getJsonObj(obj: JsonWebTokenClaim): object;
}
