"use strict";
/**
 * Application Migration API
 * Application Migration simplifies the migration of applications from Oracle Cloud Infrastructure Classic to Oracle Cloud Infrastructure.
You can use Application Migration API to migrate applications, such as Oracle Java Cloud Service, SOA Cloud Service, and Integration Classic
instances, to Oracle Cloud Infrastructure. For more information, see
[Overview of Application Migration](/iaas/application-migration/appmigrationoverview.htm).

 * OpenAPI spec version: 20191031
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.MigrationStates = void 0;
/**
 * Migration process state
 **/
var MigrationStates;
(function (MigrationStates) {
    MigrationStates["DiscoveringApplication"] = "DISCOVERING_APPLICATION";
    MigrationStates["DiscoveryFailed"] = "DISCOVERY_FAILED";
    MigrationStates["MissingConfigValues"] = "MISSING_CONFIG_VALUES";
    MigrationStates["Ready"] = "READY";
    MigrationStates["Migrating"] = "MIGRATING";
    MigrationStates["MigrationFailed"] = "MIGRATION_FAILED";
    MigrationStates["MigrationSucceeded"] = "MIGRATION_SUCCEEDED";
    /**
     * This value is used if a service returns a value for this enum that is not recognized by this
     * version of the SDK.
     */
    MigrationStates["UnknownValue"] = "UNKNOWN_VALUE";
})(MigrationStates = exports.MigrationStates || (exports.MigrationStates = {}));
(function (MigrationStates) {
    function getJsonObj(obj) {
        return { obj };
    }
    MigrationStates.getJsonObj = getJsonObj;
})(MigrationStates = exports.MigrationStates || (exports.MigrationStates = {}));
//# sourceMappingURL=migration-states.js.map