/**
 *
 *
 * OpenAPI spec version: 20190901
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import common = require("oci-common");
/**
 * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/1.15.1/audit/ListEvents.ts.html |here} to see how to use ListEventsRequest.
 */
export interface ListEventsRequest extends common.BaseRequest {
    /**
     * The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the compartment.
     */
    "compartmentId": string;
    /**
   * Returns events that were processed at or after this start date and time, expressed in
  * [RFC 3339](https://tools.ietf.org/html/rfc3339) timestamp format.
  * <p>
  For example, a start value of `2017-01-15T11:30:00Z` will retrieve a list of all events processed
  * since 30 minutes after the 11th hour of January 15, 2017, in Coordinated Universal Time (UTC).
  * You can specify a value with granularity to the minute. Seconds (and milliseconds, if included) must
  * be set to `0`.
  *
   */
    "startTime": Date;
    /**
   * Returns events that were processed before this end date and time, expressed in
  * [RFC 3339](https://tools.ietf.org/html/rfc3339) timestamp format.
  * <p>
  For example, a start value of `2017-01-01T00:00:00Z` and an end value of `2017-01-02T00:00:00Z`
  * will retrieve a list of all events processed on January 1, 2017. Similarly, a start value of
  * `2017-01-01T00:00:00Z` and an end value of `2017-02-01T00:00:00Z` will result in a list of all
  * events processed between January 1, 2017 and January 31, 2017. You can specify a value with
  * granularity to the minute. Seconds (and milliseconds, if included) must be set to `0`.
  *
   */
    "endTime": Date;
    /**
     * For list pagination. The value of the `opc-next-page` response header from the previous \"List\" call.
     * For important details about how pagination works, see [List Pagination](https://docs.cloud.oracle.com/iaas/Content/API/Concepts/usingapi.htm#nine).
     *
     */
    "page"?: string;
    /**
     * Unique Oracle-assigned identifier for the request. If you need to contact Oracle about a
     * particular request, please provide the request ID.
     *
     */
    "opcRequestId"?: string;
}
