/**
 * Autoscaling API
 * APIs for dynamically scaling Compute resources to meet application requirements. For more information about
autoscaling, see [Autoscaling](/Content/Compute/Tasks/autoscalinginstancepools.htm). For information about the
Compute service, see [Overview of the Compute Service](/Content/Compute/Concepts/computeoverview.htm).

**Note:** Autoscaling is not available in US Government Cloud tenancies. For more information, see
[Oracle Cloud Infrastructure US Government Cloud](/Content/General/Concepts/govoverview.htm).

 * OpenAPI spec version: 20181001
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
* Autoscaling policies define the criteria that trigger autoscaling actions and the actions to take.
* <p>
An autoscaling policy is part of an autoscaling configuration. For more information, see
* [Autoscaling](https://docs.cloud.oracle.com/iaas/Content/Compute/Tasks/autoscalinginstancepools.htm).
*
*/
export interface AutoScalingPolicy {
    /**
     * The capacity requirements of the autoscaling policy.
     */
    "capacity": model.Capacity;
    /**
     * The ID of the autoscaling policy that is assigned after creation.
     */
    "id"?: string;
    /**
     * A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.
     *
     */
    "displayName"?: string;
    /**
      * The date and time the autoscaling configuration was created, in the format defined by RFC3339.
  * <p>
  Example: `2016-08-25T21:10:29.600Z`
  *
      */
    "timeCreated": Date;
    /**
     * Boolean field indicating whether this policy is enabled or not.
     */
    "isEnabled"?: boolean;
    "policyType": string;
}
export declare namespace AutoScalingPolicy {
    function getJsonObj(obj: AutoScalingPolicy): object;
}
