/**
 * Big Data Service API
 * API for the Big Data Service. Use this API to build, deploy, and manage fully elastic Big Data Service
build on Hadoop, Spark and Data Science distribution, which can be fully integrated with existing enterprise
data in Oracle Database and Oracle Applications..

 * OpenAPI spec version: 20190531
 * Contact: rahul.ra.arora@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Policy definitions for the autoscaling configuration
 */
export interface AutoScalePolicy {
    /**
     * Types of autoscaling policies. SCHEDULE-BASED or  THRESHOLD-BASED, current only supported THRESHOLD-BASED.
     */
    "policyType": AutoScalePolicy.PolicyType;
    /**
     * The list of rules for autoscaling. If an action have multiple rules, last rule in the array will be applied.
     */
    "rules": Array<model.AutoScalePolicyRule>;
}
export declare namespace AutoScalePolicy {
    enum PolicyType {
        ThresholdBased = "THRESHOLD_BASED",
        ScheduleBased = "SCHEDULE_BASED",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: AutoScalePolicy): object;
}
