/**
 * Big Data Service API
 * API for the Big Data Service. Use this API to build, deploy, and manage fully elastic Big Data Service
build on Hadoop, Spark and Data Science distribution, which can be fully integrated with existing enterprise
data in Oracle Database and Oracle Applications..

 * OpenAPI spec version: 20190531
 * Contact: rahul.ra.arora@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Specific info about a Hadoop cluster
 */
export interface ClusterDetails {
    /**
     * BDA version installed in the cluster
     */
    "bdaVersion"?: string;
    /**
     * Big Data Manager version installed in the cluster
     */
    "bdmVersion"?: string;
    /**
     * Big Data Service version installed in the cluster
     */
    "bdsVersion"?: string;
    /**
     * Oracle Linux version installed in the cluster
     */
    "osVersion"?: string;
    /**
     * Query Server Database version
     */
    "dbVersion"?: string;
    /**
     * Cloud SQL cell version
     */
    "bdCellVersion"?: string;
    /**
     * Big Data SQL version
     */
    "csqlCellVersion"?: string;
    /**
     * The time the cluster was created. An RFC3339 formatted datetime string
     */
    "timeCreated": Date;
    /**
     * The time the BDS instance was automatically, or manually refreshed.
     * An RFC3339 formatted datetime string
     *
     */
    "timeRefreshed"?: Date;
    /**
     * The URL of a Cloudera Manager
     */
    "clouderaManagerUrl"?: string;
    /**
     * The URL of a Big Data Manager
     */
    "bigDataManagerUrl"?: string;
    /**
     * The URL of a Hue Server
     */
    "hueServerUrl"?: string;
}
export declare namespace ClusterDetails {
    function getJsonObj(obj: ClusterDetails): object;
}
