/**
 *
 *
 * OpenAPI spec version: 20190111
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
import common = require("oci-common");
/**
 * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/1.15.1/budget/ListBudgets.ts.html |here} to see how to use ListBudgetsRequest.
 */
export interface ListBudgetsRequest extends common.BaseRequest {
    /**
     * The ID of the compartment in which to list resources.
     */
    "compartmentId": string;
    /**
     * The maximum number of items to return.
     */
    "limit"?: number;
    /**
     * The page token representing the page at which to start retrieving results. This is usually retrieved from a previous list call.
     */
    "page"?: string;
    /**
     * The sort order to use, either 'asc' or 'desc'.
     */
    "sortOrder"?: model.SortOrder;
    /**
     * The field to sort by. If not specified, the default is timeCreated.
     * The default sort order for timeCreated is DESC.
     * The default sort order for displayName is ASC in alphanumeric order.
     *
     */
    "sortBy"?: model.SortBy;
    /**
     * The current state of the resource to filter by.
     */
    "lifecycleState"?: model.LifecycleState;
    /**
   * A user-friendly name. Does not have to be unique, and it's changeable.
  * <p>
  Example: `My new resource`
  *
   */
    "displayName"?: string;
    /**
     * The type of target to filter by.
     *   * ALL - List all budgets
     *   * COMPARTMENT - List all budgets with targetType == \"COMPARTMENT\"
     *   * TAG - List all budgets with targetType == \"TAG\"
     *
     */
    "targetType"?: ListBudgetsRequest.TargetType;
    /**
     * The client request ID for tracing.
     */
    "opcRequestId"?: string;
}
export declare namespace ListBudgetsRequest {
    enum TargetType {
        All = "ALL",
        Compartment = "COMPARTMENT",
        Tag = "TAG"
    }
}
