/**
 * Support Management API
 * Use the Support Management API to manage support requests. For more information, see [Getting Help and Contacting Support](/iaas/Content/GSG/Tasks/contactingsupport.htm). **Note**: Before you can create service requests with this API, you need to have an Oracle Single Sign On (SSO) account, and you need to register your Customer Support Identifier (CSI) with My Oracle Support.
 * OpenAPI spec version: 20181231
 * Contact: oci_ops_cims_dev_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details about the ActivityItem object.
 */
export interface ActivityItem extends model.Item {
    /**
     * Comments added with the activity on the support ticket.
     */
    "comments"?: string;
    /**
     * The time when the activity was created, in milliseconds since epoch time. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "timeCreated"?: number;
    /**
     * The time when the activity was updated, in milliseconds since epoch time. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "timeUpdated"?: number;
    /**
     * The type of activity occuring on the support ticket.
     */
    "activityType"?: ActivityItem.ActivityType;
    /**
     * The person who updates the activity on the support ticket.
     */
    "activityAuthor"?: ActivityItem.ActivityAuthor;
    "type": string;
}
export declare namespace ActivityItem {
    enum ActivityType {
        Notes = "NOTES",
        ProblemDescription = "PROBLEM_DESCRIPTION",
        Update = "UPDATE",
        Close = "CLOSE",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    enum ActivityAuthor {
        Customer = "CUSTOMER",
        Oracle = "ORACLE",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: ActivityItem, isParentJsonObj?: boolean): object;
    const type = "activity";
}
