/**
 * Cloud Guard APIs
 * A description of the Cloud Guard APIs
 * OpenAPI spec version: 20200131
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details of Detector recipe
 */
export interface DetectorRecipe {
    /**
     * Ocid for detector recipe
     */
    "id": string;
    /**
     * DisplayName of detector recipe
     */
    "displayName": string;
    /**
     * Detector recipe description
     */
    "description"?: string;
    /**
     * compartmentId of detector recipe
     */
    "compartmentId": string;
    /**
     * Recipe Ocid of the Source Recipe to be cloned
     */
    "sourceDetectorRecipeId": string;
    /**
     * Owner of detector recipe
     */
    "owner": model.OwnerType;
    /**
     * Type of detector
     */
    "detector": model.DetectorEnum;
    /**
     * List of detetor rules for the detector type for recipe
     */
    "detectorRules"?: Array<model.DetectorRecipeDetectorRule>;
    /**
     * List of detetor rules for the detector type for recipe
     */
    "effectiveDetectorRules"?: Array<model.DetectorRecipeDetectorRule>;
    /**
     * The date and time the detector recipe was created. Format defined by RFC3339.
     */
    "timeCreated"?: Date;
    /**
     * The date and time the detector recipe was updated. Format defined by RFC3339.
     */
    "timeUpdated"?: Date;
    /**
     * The current state of the resource.
     */
    "lifecycleState"?: model.LifecycleState;
    /**
     * Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
     * Example: `{\"bar-key\": \"value\"}`
     *
     */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
     * Defined tags for this resource. Each key is predefined and scoped to a namespace.
     * Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`
     *
     */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
    /**
      * System tags for this resource. Each key is predefined and scoped to a namespace.
  * For more information, see [Resource Tags](https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm).
  * System tags can be viewed by users, but can only be created by the system.
  * <p>
  Example: `{\"orcl-cloud\": {\"free-tier-retained\": \"true\"}}`
  *
      */
    "systemTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
}
export declare namespace DetectorRecipe {
    function getJsonObj(obj: DetectorRecipe): object;
}
