/**
 * Cloud Guard APIs
 * A description of the Cloud Guard APIs
 * OpenAPI spec version: 20200131
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Target Detector recipe
 */
export interface TargetDetectorRecipe {
    /**
     * Ocid for detector recipe
     */
    "id": string;
    /**
     * DisplayName of detector recipe
     */
    "displayName": string;
    /**
     * Detector recipe description
     */
    "description"?: string;
    /**
     * compartmentId of detector recipe
     */
    "compartmentId": string;
    /**
     * Unique identifier for Detector Recipe of which this is an extension
     */
    "detectorRecipeId": string;
    /**
     * Owner of detector recipe
     */
    "owner": model.OwnerType;
    /**
     * Type of detector
     */
    "detector": model.DetectorEnum;
    /**
     * List of detector rules for the detector type for recipe - user input
     */
    "detectorRules"?: Array<model.TargetDetectorRecipeDetectorRule>;
    /**
     * List of effective detector rules for the detector type for recipe after applying defaults
     */
    "effectiveDetectorRules"?: Array<model.TargetDetectorRecipeDetectorRule>;
    /**
     * The date and time the target detector recipe was created. Format defined by RFC3339.
     */
    "timeCreated"?: Date;
    /**
     * The date and time the target detector recipe was updated. Format defined by RFC3339.
     */
    "timeUpdated"?: Date;
    /**
     * The current state of the resource.
     */
    "lifecycleState"?: model.LifecycleState;
}
export declare namespace TargetDetectorRecipe {
    function getJsonObj(obj: TargetDetectorRecipe): object;
}
