/**
 * Cloud Guard APIs
 * A description of the Cloud Guard APIs
 * OpenAPI spec version: 20200131
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details of Target ResponderRecipe
 */
export interface TargetResponderRecipe {
    /**
     * Unique identifier of TargetResponderRecipe that is immutable on creation
     */
    "id": string;
    /**
     * Unique identifier for Responder Recipe of which this is an extension
     */
    "responderRecipeId": string;
    /**
     * Compartment Identifier
     */
    "compartmentId": string;
    /**
     * ResponderRecipe Identifier Name
     */
    "displayName": string;
    /**
     * ResponderRecipe Description
     */
    "description": string;
    /**
     * Owner of ResponderRecipe
     */
    "owner": model.OwnerType;
    /**
     * The date and time the target responder recipe rule was created. Format defined by RFC3339.
     */
    "timeCreated"?: Date;
    /**
     * The date and time the target responder recipe rule was updated. Format defined by RFC3339.
     */
    "timeUpdated"?: Date;
    /**
     * List of responder rules associated with the recipe - user input
     */
    "responderRules"?: Array<model.TargetResponderRecipeResponderRule>;
    /**
     * List of responder rules associated with the recipe after applying all defaults
     */
    "effectiveResponderRules"?: Array<model.TargetResponderRecipeResponderRule>;
}
export declare namespace TargetResponderRecipe {
    function getJsonObj(obj: TargetResponderRecipe): object;
}
