/**
 * Cloud Guard APIs
 * A description of the Cloud Guard APIs
 * OpenAPI spec version: 20200131
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Description of Target.
 */
export interface Target {
    /**
     * Unique identifier that is immutable on creation
     */
    "id": string;
    /**
     * Target Identifier, can be renamed
     */
    "displayName"?: string;
    /**
     * Compartment Identifier where the resource is created
     */
    "compartmentId": string;
    /**
     * The target description.
     */
    "description"?: string;
    /**
     * possible type of targets
     */
    "targetResourceType": model.TargetResourceType;
    /**
     * Resource ID which the target uses to monitor
     */
    "targetResourceId": string;
    /**
     * Total number of recipes attached to target Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "recipeCount": number;
    /**
     * List of detector recipes associated with target
     */
    "targetDetectorRecipes"?: Array<model.TargetDetectorRecipe>;
    /**
     * List of responder recipes associated with target
     */
    "targetResponderRecipes"?: Array<model.TargetResponderRecipe>;
    /**
     * List of inherited compartments
     */
    "inheritedByCompartments"?: Array<string>;
    /**
     * The date and time the target was created. Format defined by RFC3339.
     */
    "timeCreated"?: Date;
    /**
     * The date and time the target was updated. Format defined by RFC3339.
     */
    "timeUpdated"?: Date;
    /**
     * The current state of the Target.
     */
    "lifecycleState"?: model.LifecycleState;
    /**
     * A message describing the current state in more detail. For example, can be used to provide actionable information for a resource in Failed state.
     */
    "lifecyleDetails"?: string;
    /**
     * Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
     * Example: `{\"bar-key\": \"value\"}`
     *
     */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
     * Defined tags for this resource. Each key is predefined and scoped to a namespace.
     * Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`
     *
     */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
    /**
      * System tags for this resource. Each key is predefined and scoped to a namespace.
  * For more information, see [Resource Tags](https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm).
  * System tags can be viewed by users, but can only be created by the system.
  * <p>
  Example: `{\"orcl-cloud\": {\"free-tier-retained\": \"true\"}}`
  *
      */
    "systemTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
}
export declare namespace Target {
    function getJsonObj(obj: Target): object;
}
