/**
 *
 *
 * OpenAPI spec version: 20200131
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
import common = require("oci-common");
/**
 * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/1.15.1/cloudguard/ListResponderExecutions.ts.html |here} to see how to use ListResponderExecutionsRequest.
 */
export interface ListResponderExecutionsRequest extends common.BaseRequest {
    /**
     * The ID of the compartment in which to list resources.
     */
    "compartmentId": string;
    /**
     * Default is false.
     * When set to true, the hierarchy of compartments is traversed
     * and all compartments and subcompartments in the tenancy are
     * returned depending on the the setting of `accessLevel`.
     *
     */
    "compartmentIdInSubtree"?: boolean;
    /**
     * Valid values are `RESTRICTED` and `ACCESSIBLE`. Default is `RESTRICTED`.
     * Setting this to `ACCESSIBLE` returns only those compartments for which the
     * user has INSPECT permissions directly or indirectly (permissions can be on a
     * resource in a subcompartment).
     * When set to `RESTRICTED` permissions are checked and no partial results are displayed.
     *
     */
    "accessLevel"?: ListResponderExecutionsRequest.AccessLevel;
    /**
     * Responder Rule Ids filter for the Responder Executions.
     */
    "responderRuleIds"?: Array<string>;
    /**
     * Creation Start time for filtering
     */
    "timeCreatedGreaterThanOrEqualTo"?: Date;
    /**
     * Creation End time for filtering
     */
    "timeCreatedLessThanOrEqualTo"?: Date;
    /**
     * Completion End Time
     */
    "timeCompletedGreaterThanOrEqualTo"?: Date;
    /**
     * Completion Start Time
     */
    "timeCompletedLessThanOrEqualTo"?: Date;
    /**
     * The ID of the target in which to list resources.
     */
    "targetId"?: string;
    /**
     * Resource Type associated with the resource.
     */
    "resourceType"?: string;
    /**
     * The field to list the Responder Executions by Responder Type. Valid values are REMEDIATION and NOTIFICATION
     *
     */
    "responderType"?: ListResponderExecutionsRequest.ResponderType;
    /**
     * The status of the responder execution in which to list responders.
     */
    "responderExecutionStatus"?: model.ResponderExecutionStates;
    /**
     * The mode of the responder execution in which to list responders.
     */
    "responderExecutionMode"?: model.ResponderExecutionModes;
    /**
     * The maximum number of items to return.
     */
    "limit"?: number;
    /**
     * The page token representing the page at which to start retrieving results. This is usually retrieved from a previous list call.
     */
    "page"?: string;
    /**
     * The sort order to use, either 'asc' or 'desc'.
     */
    "sortOrder"?: model.SortOrders;
    /**
     * The field to sort by. Only one sort order may be provided. Default order for timeCreated is descending. Default order for responderRuleName and resourceName is ascending. If no value is specified timeCreated is default.
     *
     */
    "sortBy"?: ListResponderExecutionsRequest.SortBy;
    /**
     * The client request ID for tracing.
     */
    "opcRequestId"?: string;
}
export declare namespace ListResponderExecutionsRequest {
    enum AccessLevel {
        Restricted = "RESTRICTED",
        Accessible = "ACCESSIBLE"
    }
    enum ResponderType {
        Remediation = "REMEDIATION",
        Notification = "NOTIFICATION"
    }
    enum SortBy {
        TimeCreated = "timeCreated",
        ResponderRuleName = "responderRuleName",
        ResourceName = "resourceName",
        TimeCompleted = "timeCompleted"
    }
}
