/**
 * Copyright (c) 2020, 2021 Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
interface CircuitBreakerOptions {
    timeout?: number;
    resetTimeout?: number;
    rollingCountTimeout?: number;
    rollingCountBuckets?: number;
    name?: string;
    rollingPercentilesEnabled?: boolean;
    capacity?: number;
    errorThresholdPercentage?: number;
    enabled?: boolean;
    allowWarmUp?: boolean;
    volumeThreshold?: number;
    errorFilter?: Function;
    cache?: boolean;
}
export default class CircuitBreaker {
    static enableDefault: boolean;
    circuit: null;
    static defaultCircuit: any;
    static internalCircuit: any;
    constructor(options?: CircuitBreakerOptions);
}
export {};
