"use strict";
/**
 * Copyright (c) 2020, 2021 Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const Breaker = require("opossum");
class CircuitBreaker {
    constructor(options) {
        this.circuit = null;
        this.circuit = options
            ? new Breaker(fetch, options)
            : new Breaker(fetch, {
                timeout: 10000,
                errorThresholdPercentage: 50,
                resetTimeout: 30000 // After 30 seconds, try again.
            });
    }
}
exports.default = CircuitBreaker;
CircuitBreaker.enableDefault = false;
CircuitBreaker.defaultCircuit = new Breaker(fetch, {
    timeout: 10000,
    errorThresholdPercentage: 50,
    resetTimeout: 30000 // After 30 seconds, try again.
});
CircuitBreaker.internalCircuit = new Breaker(fetch, {
    timeout: 10000,
    errorThresholdPercentage: 50,
    resetTimeout: 30000 // After 30 seconds, try again.
});
//# sourceMappingURL=circuit-breaker.js.map