"use strict";
/**
 * Copyright (c) 2020, 2021 Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

 * Utility method to check if environment is node or browser
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkNotNull = exports.isEmpty = exports.isBrowser = void 0;
function isBrowser() {
    if (typeof window === "undefined") {
        return false;
    }
    return true;
}
exports.isBrowser = isBrowser;
// utility method checks if object is empty or not
function isEmpty(obj) {
    return Object.keys(obj).length === 0;
}
exports.isEmpty = isEmpty;
// Utility method to check if value is null, else throw error with msg.
function checkNotNull(value, msg) {
    if (value) {
        return value;
    }
    throw new Error(msg);
}
exports.checkNotNull = checkNotNull;
//# sourceMappingURL=utils.js.map