/**
 * Oracle Cloud Agent API
 * API for the Oracle Cloud Agent software running on compute instances. Oracle Cloud Agent
is a lightweight process that monitors and manages compute instances.

 * OpenAPI spec version: 20180530
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as serviceRequests from "./request";
import * as serviceResponses from "./response";
import * as models from "./model";
import { ComputeInstanceAgentClient } from "./client";
export declare class ComputeInstanceAgentWaiter {
    private client;
    private readonly config?;
    constructor(client: ComputeInstanceAgentClient, config?: Partial<import("oci-common/lib/waiter").WaiterConfigurationDetails> | undefined);
    /**
     * Waits forInstanceAgentCommandExecution till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetInstanceAgentCommandExecutionResponse
     */
    forInstanceAgentCommandExecution(request: serviceRequests.GetInstanceAgentCommandExecutionRequest, ...targetStates: models.InstanceAgentCommandExecution.LifecycleState[]): Promise<serviceResponses.GetInstanceAgentCommandExecutionResponse>;
}
