/**
 * Core Services API
 * API covering the [Networking](/iaas/Content/Network/Concepts/overview.htm),
[Compute](/iaas/Content/Compute/Concepts/computeoverview.htm), and
[Block Volume](/iaas/Content/Block/Concepts/overview.htm) services. Use this API
to manage resources such as virtual cloud networks (VCNs), compute instances, and
block storage volumes.

 * OpenAPI spec version: 20160918
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Summary information for a compute global image capability schema
 */
export interface ComputeGlobalImageCapabilitySchemaVersionSummary {
    /**
     * The compute global image capability schema version name
     */
    "name": string;
    /**
     * The OCID of the compute global image capability schema
     *
     */
    "computeGlobalImageCapabilitySchemaId": string;
    /**
     * The display name of the version
     *
     */
    "displayName"?: string;
    /**
      * The date and time the compute global image capability schema version was created, in the format defined by [RFC3339](https://tools.ietf.org/html/rfc3339).
  * <p>
  Example: `2016-08-25T21:10:29.600Z`
  *
      */
    "timeCreated": Date;
}
export declare namespace ComputeGlobalImageCapabilitySchemaVersionSummary {
    function getJsonObj(obj: ComputeGlobalImageCapabilitySchemaVersionSummary): object;
}
