/**
 * Core Services API
 * API covering the [Networking](/iaas/Content/Network/Concepts/overview.htm),
[Compute](/iaas/Content/Compute/Concepts/computeoverview.htm), and
[Block Volume](/iaas/Content/Block/Concepts/overview.htm) services. Use this API
to manage resources such as virtual cloud networks (VCNs), compute instances, and
block storage volumes.

 * OpenAPI spec version: 20160918
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
* An individual question that the customer can answer about the CPE device.
* <p>
The customer provides answers to these questions in
* {@link #updateTunnelCpeDeviceConfig(UpdateTunnelCpeDeviceConfigRequest) updateTunnelCpeDeviceConfig}.
*
*/
export interface CpeDeviceConfigQuestion {
    /**
     * A string that identifies the question.
     *
     */
    "key"?: string;
    /**
     * A descriptive label for the question (for example, to display in a form in a graphical interface).
     * Avoid entering confidential information.
     *
     */
    "displayName"?: string;
    /**
     * A description or explanation of the question, to help the customer answer accurately.
     *
     */
    "explanation"?: string;
}
export declare namespace CpeDeviceConfigQuestion {
    function getJsonObj(obj: CpeDeviceConfigQuestion): object;
}
