/**
 * Core Services API
 * API covering the [Networking](/iaas/Content/Network/Concepts/overview.htm),
[Compute](/iaas/Content/Compute/Concepts/computeoverview.htm), and
[Block Volume](/iaas/Content/Block/Concepts/overview.htm) services. Use this API
to manage resources such as virtual cloud networks (VCNs), compute instances, and
block storage volumes.

 * OpenAPI spec version: 20160918
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
* For a flexible shape, the amount of memory available for instances that use this shape.
* <p>
If this field is null, then this shape has a fixed amount of memory equivalent to `memoryInGBs`.
*
*/
export interface ShapeMemoryOptions {
    /**
     * The minimum amount of memory, in gigabytes.
     *  Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "minInGBs"?: number;
    /**
     * The maximum amount of memory, in gigabytes.
     *  Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "maxInGBs"?: number;
    /**
     * The default amount of memory per OCPU available for this shape, in gigabytes.
     *  Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "defaultPerOcpuInGBs"?: number;
    /**
     * The minimum amount of memory per OCPU available for this shape, in gigabytes.
     *  Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "minPerOcpuInGBs"?: number;
    /**
     * The maximum amount of memory per OCPU available for this shape, in gigabytes.
     *  Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "maxPerOcpuInGBs"?: number;
}
export declare namespace ShapeMemoryOptions {
    function getJsonObj(obj: ShapeMemoryOptions): object;
}
