"use strict";
/**
 * Core Services API
 * API covering the [Networking](/iaas/Content/Network/Concepts/overview.htm),
[Compute](/iaas/Content/Compute/Concepts/computeoverview.htm), and
[Block Volume](/iaas/Content/Block/Concepts/overview.htm) services. Use this API
to manage resources such as virtual cloud networks (VCNs), compute instances, and
block storage volumes.

 * OpenAPI spec version: 20160918
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListVlansRequest = exports.ListVirtualCircuitsRequest = exports.ListVcnsRequest = exports.ListSubnetsRequest = exports.ListServiceGatewaysRequest = exports.ListSecurityListsRequest = exports.ListRouteTablesRequest = exports.ListPublicIpsRequest = exports.ListPublicIpPoolsRequest = exports.ListNetworkSecurityGroupsRequest = exports.ListNetworkSecurityGroupVnicsRequest = exports.ListNetworkSecurityGroupSecurityRulesRequest = exports.ListNatGatewaysRequest = exports.ListInternetGatewaysRequest = exports.ListDhcpOptionsRequest = exports.ListCrossConnectsRequest = exports.ListCrossConnectGroupsRequest = exports.ListByoipRangesRequest = exports.ListInstancePoolsRequest = exports.ListInstancePoolInstancesRequest = exports.ListInstanceConfigurationsRequest = exports.ListClusterNetworksRequest = exports.ListClusterNetworkInstancesRequest = exports.ListInstancesRequest = exports.ListInstanceDevicesRequest = exports.ListImagesRequest = exports.ListDedicatedVmHostsRequest = exports.ListDedicatedVmHostInstancesRequest = exports.ListConsoleHistoriesRequest = exports.ListComputeImageCapabilitySchemasRequest = exports.ListComputeGlobalImageCapabilitySchemasRequest = exports.ListComputeGlobalImageCapabilitySchemaVersionsRequest = exports.ListAppCatalogSubscriptionsRequest = exports.ListAppCatalogListingsRequest = exports.ListAppCatalogListingResourceVersionsRequest = exports.InstanceActionRequest = exports.ListVolumesRequest = exports.ListVolumeGroupsRequest = exports.ListVolumeGroupBackupsRequest = exports.ListVolumeBackupsRequest = exports.ListBootVolumeBackupsRequest = void 0;
const ListBootVolumeBackupsRequest = __importStar(require("./list-boot-volume-backups-request"));
exports.ListBootVolumeBackupsRequest = ListBootVolumeBackupsRequest.ListBootVolumeBackupsRequest;
const ListVolumeBackupsRequest = __importStar(require("./list-volume-backups-request"));
exports.ListVolumeBackupsRequest = ListVolumeBackupsRequest.ListVolumeBackupsRequest;
const ListVolumeGroupBackupsRequest = __importStar(require("./list-volume-group-backups-request"));
exports.ListVolumeGroupBackupsRequest = ListVolumeGroupBackupsRequest.ListVolumeGroupBackupsRequest;
const ListVolumeGroupsRequest = __importStar(require("./list-volume-groups-request"));
exports.ListVolumeGroupsRequest = ListVolumeGroupsRequest.ListVolumeGroupsRequest;
const ListVolumesRequest = __importStar(require("./list-volumes-request"));
exports.ListVolumesRequest = ListVolumesRequest.ListVolumesRequest;
const InstanceActionRequest = __importStar(require("./instance-action-request"));
exports.InstanceActionRequest = InstanceActionRequest.InstanceActionRequest;
const ListAppCatalogListingResourceVersionsRequest = __importStar(require("./list-app-catalog-listing-resource-versions-request"));
exports.ListAppCatalogListingResourceVersionsRequest = ListAppCatalogListingResourceVersionsRequest.ListAppCatalogListingResourceVersionsRequest;
const ListAppCatalogListingsRequest = __importStar(require("./list-app-catalog-listings-request"));
exports.ListAppCatalogListingsRequest = ListAppCatalogListingsRequest.ListAppCatalogListingsRequest;
const ListAppCatalogSubscriptionsRequest = __importStar(require("./list-app-catalog-subscriptions-request"));
exports.ListAppCatalogSubscriptionsRequest = ListAppCatalogSubscriptionsRequest.ListAppCatalogSubscriptionsRequest;
const ListComputeGlobalImageCapabilitySchemaVersionsRequest = __importStar(require("./list-compute-global-image-capability-schema-versions-request"));
exports.ListComputeGlobalImageCapabilitySchemaVersionsRequest = ListComputeGlobalImageCapabilitySchemaVersionsRequest.ListComputeGlobalImageCapabilitySchemaVersionsRequest;
const ListComputeGlobalImageCapabilitySchemasRequest = __importStar(require("./list-compute-global-image-capability-schemas-request"));
exports.ListComputeGlobalImageCapabilitySchemasRequest = ListComputeGlobalImageCapabilitySchemasRequest.ListComputeGlobalImageCapabilitySchemasRequest;
const ListComputeImageCapabilitySchemasRequest = __importStar(require("./list-compute-image-capability-schemas-request"));
exports.ListComputeImageCapabilitySchemasRequest = ListComputeImageCapabilitySchemasRequest.ListComputeImageCapabilitySchemasRequest;
const ListConsoleHistoriesRequest = __importStar(require("./list-console-histories-request"));
exports.ListConsoleHistoriesRequest = ListConsoleHistoriesRequest.ListConsoleHistoriesRequest;
const ListDedicatedVmHostInstancesRequest = __importStar(require("./list-dedicated-vm-host-instances-request"));
exports.ListDedicatedVmHostInstancesRequest = ListDedicatedVmHostInstancesRequest.ListDedicatedVmHostInstancesRequest;
const ListDedicatedVmHostsRequest = __importStar(require("./list-dedicated-vm-hosts-request"));
exports.ListDedicatedVmHostsRequest = ListDedicatedVmHostsRequest.ListDedicatedVmHostsRequest;
const ListImagesRequest = __importStar(require("./list-images-request"));
exports.ListImagesRequest = ListImagesRequest.ListImagesRequest;
const ListInstanceDevicesRequest = __importStar(require("./list-instance-devices-request"));
exports.ListInstanceDevicesRequest = ListInstanceDevicesRequest.ListInstanceDevicesRequest;
const ListInstancesRequest = __importStar(require("./list-instances-request"));
exports.ListInstancesRequest = ListInstancesRequest.ListInstancesRequest;
const ListClusterNetworkInstancesRequest = __importStar(require("./list-cluster-network-instances-request"));
exports.ListClusterNetworkInstancesRequest = ListClusterNetworkInstancesRequest.ListClusterNetworkInstancesRequest;
const ListClusterNetworksRequest = __importStar(require("./list-cluster-networks-request"));
exports.ListClusterNetworksRequest = ListClusterNetworksRequest.ListClusterNetworksRequest;
const ListInstanceConfigurationsRequest = __importStar(require("./list-instance-configurations-request"));
exports.ListInstanceConfigurationsRequest = ListInstanceConfigurationsRequest.ListInstanceConfigurationsRequest;
const ListInstancePoolInstancesRequest = __importStar(require("./list-instance-pool-instances-request"));
exports.ListInstancePoolInstancesRequest = ListInstancePoolInstancesRequest.ListInstancePoolInstancesRequest;
const ListInstancePoolsRequest = __importStar(require("./list-instance-pools-request"));
exports.ListInstancePoolsRequest = ListInstancePoolsRequest.ListInstancePoolsRequest;
const ListByoipRangesRequest = __importStar(require("./list-byoip-ranges-request"));
exports.ListByoipRangesRequest = ListByoipRangesRequest.ListByoipRangesRequest;
const ListCrossConnectGroupsRequest = __importStar(require("./list-cross-connect-groups-request"));
exports.ListCrossConnectGroupsRequest = ListCrossConnectGroupsRequest.ListCrossConnectGroupsRequest;
const ListCrossConnectsRequest = __importStar(require("./list-cross-connects-request"));
exports.ListCrossConnectsRequest = ListCrossConnectsRequest.ListCrossConnectsRequest;
const ListDhcpOptionsRequest = __importStar(require("./list-dhcp-options-request"));
exports.ListDhcpOptionsRequest = ListDhcpOptionsRequest.ListDhcpOptionsRequest;
const ListInternetGatewaysRequest = __importStar(require("./list-internet-gateways-request"));
exports.ListInternetGatewaysRequest = ListInternetGatewaysRequest.ListInternetGatewaysRequest;
const ListNatGatewaysRequest = __importStar(require("./list-nat-gateways-request"));
exports.ListNatGatewaysRequest = ListNatGatewaysRequest.ListNatGatewaysRequest;
const ListNetworkSecurityGroupSecurityRulesRequest = __importStar(require("./list-network-security-group-security-rules-request"));
exports.ListNetworkSecurityGroupSecurityRulesRequest = ListNetworkSecurityGroupSecurityRulesRequest.ListNetworkSecurityGroupSecurityRulesRequest;
const ListNetworkSecurityGroupVnicsRequest = __importStar(require("./list-network-security-group-vnics-request"));
exports.ListNetworkSecurityGroupVnicsRequest = ListNetworkSecurityGroupVnicsRequest.ListNetworkSecurityGroupVnicsRequest;
const ListNetworkSecurityGroupsRequest = __importStar(require("./list-network-security-groups-request"));
exports.ListNetworkSecurityGroupsRequest = ListNetworkSecurityGroupsRequest.ListNetworkSecurityGroupsRequest;
const ListPublicIpPoolsRequest = __importStar(require("./list-public-ip-pools-request"));
exports.ListPublicIpPoolsRequest = ListPublicIpPoolsRequest.ListPublicIpPoolsRequest;
const ListPublicIpsRequest = __importStar(require("./list-public-ips-request"));
exports.ListPublicIpsRequest = ListPublicIpsRequest.ListPublicIpsRequest;
const ListRouteTablesRequest = __importStar(require("./list-route-tables-request"));
exports.ListRouteTablesRequest = ListRouteTablesRequest.ListRouteTablesRequest;
const ListSecurityListsRequest = __importStar(require("./list-security-lists-request"));
exports.ListSecurityListsRequest = ListSecurityListsRequest.ListSecurityListsRequest;
const ListServiceGatewaysRequest = __importStar(require("./list-service-gateways-request"));
exports.ListServiceGatewaysRequest = ListServiceGatewaysRequest.ListServiceGatewaysRequest;
const ListSubnetsRequest = __importStar(require("./list-subnets-request"));
exports.ListSubnetsRequest = ListSubnetsRequest.ListSubnetsRequest;
const ListVcnsRequest = __importStar(require("./list-vcns-request"));
exports.ListVcnsRequest = ListVcnsRequest.ListVcnsRequest;
const ListVirtualCircuitsRequest = __importStar(require("./list-virtual-circuits-request"));
exports.ListVirtualCircuitsRequest = ListVirtualCircuitsRequest.ListVirtualCircuitsRequest;
const ListVlansRequest = __importStar(require("./list-vlans-request"));
exports.ListVlansRequest = ListVlansRequest.ListVlansRequest;
//# sourceMappingURL=index.js.map