/**
 * Database Service API
 * The API for the Database Service. Use this API to manage resources such as databases and DB Systems. For more information, see [Overview of the Database Service](/iaas/Content/Database/Concepts/databaseoverview.htm).

 * OpenAPI spec version: 20160918
 * Contact: sic_dbaas_cp_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
export interface AutonomousPatch {
    /**
     * The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the patch.
     */
    "id": string;
    /**
     * The text describing this patch package.
     */
    "description": string;
    /**
     * The type of patch. BUNDLE is one example.
     */
    "type": string;
    /**
     * A descriptive text associated with the lifecycleState.
     * Typically can contain additional displayable text.
     *
     */
    "lifecycleDetails"?: string;
    /**
     * The current state of the patch as a result of lastAction.
     */
    "lifecycleState"?: AutonomousPatch.LifecycleState;
    /**
     * The date and time that the patch was released.
     */
    "timeReleased": Date;
    /**
     * The version of this patch package.
     */
    "version": string;
    /**
     * Database patching model preference. See [My Oracle Support note 2285040.1](https://support.oracle.com/rs?type=doc&id=2285040.1) for information on the Release Update (RU) and Release Update Revision (RUR) patching models.
     */
    "patchModel"?: AutonomousPatch.PatchModel;
    /**
     * First month of the quarter in which the patch was released.
     */
    "quarter"?: string;
    /**
     * Year in which the patch was released.
     */
    "year"?: string;
}
export declare namespace AutonomousPatch {
    enum LifecycleState {
        Available = "AVAILABLE",
        Success = "SUCCESS",
        InProgress = "IN_PROGRESS",
        Failed = "FAILED",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    enum PatchModel {
        ReleaseUpdates = "RELEASE_UPDATES",
        ReleaseUpdateRevisions = "RELEASE_UPDATE_REVISIONS",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: AutonomousPatch): object;
}
