/**
 * Database Service API
 * The API for the Database Service. Use this API to manage resources such as databases and DB Systems. For more information, see [Overview of the Database Service](/iaas/Content/Database/Concepts/databaseoverview.htm).

 * OpenAPI spec version: 20160918
 * Contact: sic_dbaas_cp_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Parameters for creating a database software image in the specified compartment.
 * <p>
 **Warning:** Oracle recommends that you avoid using any confidential information when you supply string values using the API.
 *
 */
export interface CreateDatabaseSoftwareImageDetails {
    /**
     * The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the compartment the database software image  belongs in.
     */
    "compartmentId": string;
    /**
     * The database version with which the database software image is to be built.
     */
    "databaseVersion": string;
    /**
     * The user-friendly name for the database software image. The name does not have to be unique.
     */
    "displayName": string;
    /**
     * To what shape the image is meant for.
     */
    "imageShapeFamily"?: CreateDatabaseSoftwareImageDetails.ImageShapeFamily;
    /**
     * The type of software image. Can be grid or database.
     */
    "imageType"?: CreateDatabaseSoftwareImageDetails.ImageType;
    /**
     * The PSU or PBP or Release Updates. To get a list of supported versions, use the {@link #listDbVersions(ListDbVersionsRequest) listDbVersions} operation.
     */
    "patchSet": string;
    /**
     * List of one-off patches for Database Homes.
     */
    "databaseSoftwareImageOneOffPatches"?: Array<string>;
    /**
     * output from lsinventory which will get passed as a string
     */
    "lsInventory"?: string;
    /**
      * Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace.
  * For more information, see [Resource Tags](https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm).
  * <p>
  Example: `{\"Department\": \"Finance\"}`
  *
      */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
     * Defined tags for this resource. Each key is predefined and scoped to a namespace.
     * For more information, see [Resource Tags](https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm).
     *
     */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
}
export declare namespace CreateDatabaseSoftwareImageDetails {
    enum ImageShapeFamily {
        VmBmShape = "VM_BM_SHAPE",
        ExadataShape = "EXADATA_SHAPE"
    }
    enum ImageType {
        GridImage = "GRID_IMAGE",
        DatabaseImage = "DATABASE_IMAGE"
    }
    function getJsonObj(obj: CreateDatabaseSoftwareImageDetails): object;
}
