/**
 * Database Service API
 * The API for the Database Service. Use this API to manage resources such as databases and DB Systems. For more information, see [Overview of the Database Service](/iaas/Content/Database/Concepts/databaseoverview.htm).

 * OpenAPI spec version: 20160918
 * Contact: sic_dbaas_cp_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * User information to connect to the database.
 *
 */
export interface DatabaseConnectionCredentialsByDetails extends model.DatabaseConnectionCredentials {
    /**
     * The name of the credential information that used to connect to the database.
     */
    "credentialName"?: string;
    /**
     * The username that will be used to connect to the database.
     */
    "username": string;
    /**
     * The password that will be used to connect to the database.
     */
    "password": string;
    /**
     * The role of the user that will be connecting to the database.
     */
    "role": DatabaseConnectionCredentialsByDetails.Role;
    "credentialType": string;
}
export declare namespace DatabaseConnectionCredentialsByDetails {
    enum Role {
        Sysdba = "SYSDBA",
        Normal = "NORMAL",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: DatabaseConnectionCredentialsByDetails, isParentJsonObj?: boolean): object;
    const credentialType = "DETAILS";
}
