/**
 * Database Service API
 * The API for the Database Service. Use this API to manage resources such as databases and DB Systems. For more information, see [Overview of the Database Service](/iaas/Content/Database/Concepts/databaseoverview.htm).

 * OpenAPI spec version: 20160918
 * Contact: sic_dbaas_cp_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details of the database software image to be used to upgrade a database.
 *
 */
export interface DatabaseUpgradeWithDatabaseSoftwareImageDetails extends model.DatabaseUpgradeSourceBase {
    /**
     * The database software image [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the image to be used to upgrade a database.
     */
    "databaseSoftwareImageId": string;
    "source": string;
}
export declare namespace DatabaseUpgradeWithDatabaseSoftwareImageDetails {
    function getJsonObj(obj: DatabaseUpgradeWithDatabaseSoftwareImageDetails, isParentJsonObj?: boolean): object;
    const source = "DB_SOFTWARE_IMAGE";
}
