/**
 * Database Service API
 * The API for the Database Service. Use this API to manage resources such as databases and DB Systems. For more information, see [Overview of the Database Service](/iaas/Content/Database/Concepts/databaseoverview.htm).

 * OpenAPI spec version: 20160918
 * Contact: sic_dbaas_cp_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details for Oracle Key Vault
 */
export interface KeyStoreTypeFromOracleKeyVaultDetails extends model.KeyStoreTypeDetails {
    /**
     * The list of Oracle Key Vault connection IP addresses.
     */
    "connectionIps": Array<string>;
    /**
     * The administrator username to connect to Oracle Key Vault
     */
    "adminUsername": string;
    /**
     * The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the Oracle Cloud Infrastructure [vault](https://docs.cloud.oracle.com/Content/KeyManagement/Concepts/keyoverview.htm#concepts).
     */
    "vaultId": string;
    /**
     * The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the Oracle Cloud Infrastructure [secret](https://docs.cloud.oracle.com/Content/KeyManagement/Concepts/keyoverview.htm#concepts).
     */
    "secretId": string;
    "type": string;
}
export declare namespace KeyStoreTypeFromOracleKeyVaultDetails {
    function getJsonObj(obj: KeyStoreTypeFromOracleKeyVaultDetails, isParentJsonObj?: boolean): object;
    const type = "ORACLE_KEY_VAULT";
}
