/**
 * Database Service API
 * The API for the Database Service. Use this API to manage resources such as databases and DB Systems. For more information, see [Overview of the Database Service](/iaas/Content/Database/Concepts/databaseoverview.htm).

 * OpenAPI spec version: 20160918
 * Contact: sic_dbaas_cp_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Details specifying which maintenance update to apply to the cloud VM cluster and which actions are to be performed by the maintenance update. Applies to Exadata Cloud Service instances only.
 *
 */
export interface UpdateDetails {
    /**
     * The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the maintenance update.
     */
    "updateId"?: string;
    /**
     * The update action.
     */
    "updateAction"?: UpdateDetails.UpdateAction;
}
export declare namespace UpdateDetails {
    enum UpdateAction {
        RollingApply = "ROLLING_APPLY",
        NonRollingApply = "NON_ROLLING_APPLY",
        Precheck = "PRECHECK",
        Rollback = "ROLLBACK"
    }
    function getJsonObj(obj: UpdateDetails): object;
}
