/**
 * Database Management API
 * Use the Database Management API to perform tasks such as obtaining performance and resource usage metrics
for a fleet of Managed Databases or a specific Managed Database, creating Managed Database Groups, and
running a SQL job on a Managed Database or Managed Database Group.

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The details required to create a job.
 */
export interface CreateJobDetails {
    /**
     * The name of the job. Valid characters are uppercase or lowercase letters,
     * numbers, and \"_\". The name of the job cannot be modified. It must be unique
     * in the compartment and must begin with an alphabetic character.
     *
     */
    "name": string;
    /**
     * The description of the job.
     */
    "description"?: string;
    /**
     * The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the compartment in which the job resides.
     */
    "compartmentId": string;
    /**
     * The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the Managed Database Group where the job has to be executed.
     */
    "managedDatabaseGroupId"?: string;
    /**
     * The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the Managed Database where the job has to be executed.
     */
    "managedDatabaseId"?: string;
    /**
     * The subtype of the Oracle Database where the job has to be executed. Only applicable when managedDatabaseGroupId is provided.
     */
    "databaseSubType"?: model.DatabaseSubType;
    /**
     * The schedule type of the job.
     */
    "scheduleType": string;
    /**
     * The job timeout duration, which is expressed like \"1h 10m 15s\".
     */
    "timeout"?: string;
    "resultLocation"?: model.ObjectStorageJobExecutionResultLocation;
    "jobType": string;
}
export declare namespace CreateJobDetails {
    function getJsonObj(obj: CreateJobDetails): object;
}
