/**
 * Database Management API
 * Use the Database Management API to perform tasks such as obtaining performance and resource usage metrics
for a fleet of Managed Databases or a specific Managed Database, creating Managed Database Groups, and
running a SQL job on a Managed Database or Managed Database Group.

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The details of the fleet health metrics.
 */
export interface DatabaseFleetHealthMetrics {
    /**
     * The baseline date and time in UTC in ISO-8601 format, which is \"yyyy-MM-dd'T'hh:mm:ss.sss'Z'\".
     * This is the date and time against which percentage change is calculated.
     *
     */
    "compareBaselineTime": string;
    /**
     * The target date and time in UTC in ISO-8601 format, which is \"yyyy-MM-dd'T'hh:mm:ss.sss'Z'\".
     * All the metrics are returned for the target date and time and the percentage change
     * is calculated against the baseline date and time.
     *
     */
    "compareTargetTime": string;
    /**
     * The time window used for metrics comparison.
     */
    "compareType"?: model.CompareType;
    "fleetSummary"?: model.FleetSummary;
    /**
     * A list of the databases present in the fleet and their usage metrics.
     */
    "fleetDatabases": Array<model.DatabaseUsageMetrics>;
}
export declare namespace DatabaseFleetHealthMetrics {
    function getJsonObj(obj: DatabaseFleetHealthMetrics): object;
}
