"use strict";
/**
 * Database Management API
 * Use the Database Management API to perform tasks such as obtaining performance and resource usage metrics
for a fleet of Managed Databases or a specific Managed Database, creating Managed Database Groups, and
running a SQL job on a Managed Database or Managed Database Group.

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateSqlJobDetails = exports.UpdateManagedDatabaseGroupDetails = exports.SortOrders = exports.RemoveManagedDatabaseFromManagedDatabaseGroupDetails = exports.ParentGroup = exports.MetricDimensionDefinition = exports.MetricDataPoint = exports.MemoryAggregateMetrics = exports.ManagedDatabaseSummary = exports.ManagedDatabaseGroupSummary = exports.ManagedDatabaseGroupCollection = exports.ManagedDatabaseGroup = exports.ManagedDatabaseCollection = exports.ManagedDatabase = exports.LifecycleStates = exports.JobTypes = exports.JobSummary = exports.JobRunSummary = exports.JobRunCollection = exports.JobRun = exports.JobExecutionSummary = exports.JobExecutionResultLocation = exports.JobExecutionResultDetails = exports.JobExecutionCollection = exports.JobExecution = exports.JobDatabase = exports.JobCollection = exports.Job = exports.FleetSummary = exports.FleetStatusByCategory = exports.FleetMetricSummaryDefinition = exports.FleetMetricDefinition = exports.DatabaseUsageMetrics = exports.DatabaseType = exports.DatabaseTimeAggregateMetrics = exports.DatabaseSubType = exports.DatabaseStorageAggregateMetrics = exports.DatabaseStatus = exports.DatabaseIOAggregateMetrics = exports.DatabaseHomeMetrics = exports.DatabaseHomeMetricDefinition = exports.DatabaseFleetHealthMetrics = exports.CreateManagedDatabaseGroupDetails = exports.CreateJobDetails = exports.CompareType = exports.ChildDatabase = exports.ChangeManagedDatabaseGroupCompartmentDetails = exports.ChangeJobCompartmentDetails = exports.AddManagedDatabaseToManagedDatabaseGroupDetails = exports.ActivityTimeSeriesMetrics = void 0;
exports.SqlJob = exports.ObjectStorageJobExecutionResultLocation = exports.ObjectStorageJobExecutionResultDetails = void 0;
const ActivityTimeSeriesMetrics = __importStar(require("./activity-time-series-metrics"));
exports.ActivityTimeSeriesMetrics = ActivityTimeSeriesMetrics.ActivityTimeSeriesMetrics;
const AddManagedDatabaseToManagedDatabaseGroupDetails = __importStar(require("./add-managed-database-to-managed-database-group-details"));
exports.AddManagedDatabaseToManagedDatabaseGroupDetails = AddManagedDatabaseToManagedDatabaseGroupDetails.AddManagedDatabaseToManagedDatabaseGroupDetails;
const ChangeJobCompartmentDetails = __importStar(require("./change-job-compartment-details"));
exports.ChangeJobCompartmentDetails = ChangeJobCompartmentDetails.ChangeJobCompartmentDetails;
const ChangeManagedDatabaseGroupCompartmentDetails = __importStar(require("./change-managed-database-group-compartment-details"));
exports.ChangeManagedDatabaseGroupCompartmentDetails = ChangeManagedDatabaseGroupCompartmentDetails.ChangeManagedDatabaseGroupCompartmentDetails;
const ChildDatabase = __importStar(require("./child-database"));
exports.ChildDatabase = ChildDatabase.ChildDatabase;
const CompareType = __importStar(require("./compare-type"));
exports.CompareType = CompareType.CompareType;
const CreateJobDetails = __importStar(require("./create-job-details"));
exports.CreateJobDetails = CreateJobDetails.CreateJobDetails;
const CreateManagedDatabaseGroupDetails = __importStar(require("./create-managed-database-group-details"));
exports.CreateManagedDatabaseGroupDetails = CreateManagedDatabaseGroupDetails.CreateManagedDatabaseGroupDetails;
const DatabaseFleetHealthMetrics = __importStar(require("./database-fleet-health-metrics"));
exports.DatabaseFleetHealthMetrics = DatabaseFleetHealthMetrics.DatabaseFleetHealthMetrics;
const DatabaseHomeMetricDefinition = __importStar(require("./database-home-metric-definition"));
exports.DatabaseHomeMetricDefinition = DatabaseHomeMetricDefinition.DatabaseHomeMetricDefinition;
const DatabaseHomeMetrics = __importStar(require("./database-home-metrics"));
exports.DatabaseHomeMetrics = DatabaseHomeMetrics.DatabaseHomeMetrics;
const DatabaseIOAggregateMetrics = __importStar(require("./database-io-aggregate-metrics"));
exports.DatabaseIOAggregateMetrics = DatabaseIOAggregateMetrics.DatabaseIOAggregateMetrics;
const DatabaseStatus = __importStar(require("./database-status"));
exports.DatabaseStatus = DatabaseStatus.DatabaseStatus;
const DatabaseStorageAggregateMetrics = __importStar(require("./database-storage-aggregate-metrics"));
exports.DatabaseStorageAggregateMetrics = DatabaseStorageAggregateMetrics.DatabaseStorageAggregateMetrics;
const DatabaseSubType = __importStar(require("./database-sub-type"));
exports.DatabaseSubType = DatabaseSubType.DatabaseSubType;
const DatabaseTimeAggregateMetrics = __importStar(require("./database-time-aggregate-metrics"));
exports.DatabaseTimeAggregateMetrics = DatabaseTimeAggregateMetrics.DatabaseTimeAggregateMetrics;
const DatabaseType = __importStar(require("./database-type"));
exports.DatabaseType = DatabaseType.DatabaseType;
const DatabaseUsageMetrics = __importStar(require("./database-usage-metrics"));
exports.DatabaseUsageMetrics = DatabaseUsageMetrics.DatabaseUsageMetrics;
const FleetMetricDefinition = __importStar(require("./fleet-metric-definition"));
exports.FleetMetricDefinition = FleetMetricDefinition.FleetMetricDefinition;
const FleetMetricSummaryDefinition = __importStar(require("./fleet-metric-summary-definition"));
exports.FleetMetricSummaryDefinition = FleetMetricSummaryDefinition.FleetMetricSummaryDefinition;
const FleetStatusByCategory = __importStar(require("./fleet-status-by-category"));
exports.FleetStatusByCategory = FleetStatusByCategory.FleetStatusByCategory;
const FleetSummary = __importStar(require("./fleet-summary"));
exports.FleetSummary = FleetSummary.FleetSummary;
const Job = __importStar(require("./job"));
exports.Job = Job.Job;
const JobCollection = __importStar(require("./job-collection"));
exports.JobCollection = JobCollection.JobCollection;
const JobDatabase = __importStar(require("./job-database"));
exports.JobDatabase = JobDatabase.JobDatabase;
const JobExecution = __importStar(require("./job-execution"));
exports.JobExecution = JobExecution.JobExecution;
const JobExecutionCollection = __importStar(require("./job-execution-collection"));
exports.JobExecutionCollection = JobExecutionCollection.JobExecutionCollection;
const JobExecutionResultDetails = __importStar(require("./job-execution-result-details"));
exports.JobExecutionResultDetails = JobExecutionResultDetails.JobExecutionResultDetails;
const JobExecutionResultLocation = __importStar(require("./job-execution-result-location"));
exports.JobExecutionResultLocation = JobExecutionResultLocation.JobExecutionResultLocation;
const JobExecutionSummary = __importStar(require("./job-execution-summary"));
exports.JobExecutionSummary = JobExecutionSummary.JobExecutionSummary;
const JobRun = __importStar(require("./job-run"));
exports.JobRun = JobRun.JobRun;
const JobRunCollection = __importStar(require("./job-run-collection"));
exports.JobRunCollection = JobRunCollection.JobRunCollection;
const JobRunSummary = __importStar(require("./job-run-summary"));
exports.JobRunSummary = JobRunSummary.JobRunSummary;
const JobSummary = __importStar(require("./job-summary"));
exports.JobSummary = JobSummary.JobSummary;
const JobTypes = __importStar(require("./job-types"));
exports.JobTypes = JobTypes.JobTypes;
const LifecycleStates = __importStar(require("./lifecycle-states"));
exports.LifecycleStates = LifecycleStates.LifecycleStates;
const ManagedDatabase = __importStar(require("./managed-database"));
exports.ManagedDatabase = ManagedDatabase.ManagedDatabase;
const ManagedDatabaseCollection = __importStar(require("./managed-database-collection"));
exports.ManagedDatabaseCollection = ManagedDatabaseCollection.ManagedDatabaseCollection;
const ManagedDatabaseGroup = __importStar(require("./managed-database-group"));
exports.ManagedDatabaseGroup = ManagedDatabaseGroup.ManagedDatabaseGroup;
const ManagedDatabaseGroupCollection = __importStar(require("./managed-database-group-collection"));
exports.ManagedDatabaseGroupCollection = ManagedDatabaseGroupCollection.ManagedDatabaseGroupCollection;
const ManagedDatabaseGroupSummary = __importStar(require("./managed-database-group-summary"));
exports.ManagedDatabaseGroupSummary = ManagedDatabaseGroupSummary.ManagedDatabaseGroupSummary;
const ManagedDatabaseSummary = __importStar(require("./managed-database-summary"));
exports.ManagedDatabaseSummary = ManagedDatabaseSummary.ManagedDatabaseSummary;
const MemoryAggregateMetrics = __importStar(require("./memory-aggregate-metrics"));
exports.MemoryAggregateMetrics = MemoryAggregateMetrics.MemoryAggregateMetrics;
const MetricDataPoint = __importStar(require("./metric-data-point"));
exports.MetricDataPoint = MetricDataPoint.MetricDataPoint;
const MetricDimensionDefinition = __importStar(require("./metric-dimension-definition"));
exports.MetricDimensionDefinition = MetricDimensionDefinition.MetricDimensionDefinition;
const ParentGroup = __importStar(require("./parent-group"));
exports.ParentGroup = ParentGroup.ParentGroup;
const RemoveManagedDatabaseFromManagedDatabaseGroupDetails = __importStar(require("./remove-managed-database-from-managed-database-group-details"));
exports.RemoveManagedDatabaseFromManagedDatabaseGroupDetails = RemoveManagedDatabaseFromManagedDatabaseGroupDetails.RemoveManagedDatabaseFromManagedDatabaseGroupDetails;
const SortOrders = __importStar(require("./sort-orders"));
exports.SortOrders = SortOrders.SortOrders;
const UpdateManagedDatabaseGroupDetails = __importStar(require("./update-managed-database-group-details"));
exports.UpdateManagedDatabaseGroupDetails = UpdateManagedDatabaseGroupDetails.UpdateManagedDatabaseGroupDetails;
const CreateSqlJobDetails = __importStar(require("./create-sql-job-details"));
exports.CreateSqlJobDetails = CreateSqlJobDetails.CreateSqlJobDetails;
const ObjectStorageJobExecutionResultDetails = __importStar(require("./object-storage-job-execution-result-details"));
exports.ObjectStorageJobExecutionResultDetails = ObjectStorageJobExecutionResultDetails.ObjectStorageJobExecutionResultDetails;
const ObjectStorageJobExecutionResultLocation = __importStar(require("./object-storage-job-execution-result-location"));
exports.ObjectStorageJobExecutionResultLocation = ObjectStorageJobExecutionResultLocation.ObjectStorageJobExecutionResultLocation;
const SqlJob = __importStar(require("./sql-job"));
exports.SqlJob = SqlJob.SqlJob;
//# sourceMappingURL=index.js.map