"use strict";
/**
 * Database Management API
 * Use the Database Management API to perform tasks such as obtaining performance and resource usage metrics
for a fleet of Managed Databases or a specific Managed Database, creating Managed Database Groups, and
running a SQL job on a Managed Database or Managed Database Group.

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Job = void 0;
const model = __importStar(require("../model"));
var Job;
(function (Job) {
    let ScheduleType;
    (function (ScheduleType) {
        ScheduleType["Immediate"] = "IMMEDIATE";
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        ScheduleType["UnknownValue"] = "UNKNOWN_VALUE";
    })(ScheduleType = Job.ScheduleType || (Job.ScheduleType = {}));
    let LifecycleState;
    (function (LifecycleState) {
        LifecycleState["Active"] = "ACTIVE";
        LifecycleState["Inactive"] = "INACTIVE";
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        LifecycleState["UnknownValue"] = "UNKNOWN_VALUE";
    })(LifecycleState = Job.LifecycleState || (Job.LifecycleState = {}));
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "managedDatabasesDetails": obj.managedDatabasesDetails
                ? obj.managedDatabasesDetails.map(item => {
                    return model.JobDatabase.getJsonObj(item);
                })
                : undefined,
            "resultLocation": obj.resultLocation
                ? model.JobExecutionResultLocation.getJsonObj(obj.resultLocation)
                : undefined
        });
        if ("jobType" in obj && obj.jobType) {
            switch (obj.jobType) {
                case "SQL":
                    return model.SqlJob.getJsonObj(jsonObj, true);
                default:
                    throw Error("Unknown value for: " + obj.jobType);
            }
        }
        return jsonObj;
    }
    Job.getJsonObj = getJsonObj;
})(Job = exports.Job || (exports.Job = {}));
//# sourceMappingURL=job.js.map