/**
 * Database Management API
 * Use the Database Management API to perform tasks such as obtaining performance and resource usage metrics
for a fleet of Managed Databases or a specific Managed Database, creating Managed Database Groups, and
running a SQL job on a Managed Database or Managed Database Group.

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The details of a Managed Database Group.
 */
export interface ManagedDatabaseGroup {
    /**
     * The name of the Managed Database Group.
     */
    "name": string;
    /**
     * The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the Managed Database Group.
     */
    "id": string;
    /**
     * The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the compartment.
     */
    "compartmentId": string;
    /**
     * The information specified by the user about the Managed Database Group.
     */
    "description"?: string;
    /**
     * A list of Managed Databases in the Managed Database Group.
     */
    "managedDatabases": Array<model.ChildDatabase>;
    /**
     * The current lifecycle state of the Managed Database Group.
     */
    "lifecycleState": model.LifecycleStates;
    /**
     * The date and time the Managed Database Group was created.
     */
    "timeCreated": Date;
    /**
     * The date and time the Managed Database Group was last updated.
     */
    "timeUpdated"?: Date;
}
export declare namespace ManagedDatabaseGroup {
    function getJsonObj(obj: ManagedDatabaseGroup): object;
}
