/**
 *
 *
 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
import common = require("oci-common");
/**
 * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/1.15.1/databasemanagement/GetDatabaseFleetHealthMetrics.ts.html |here} to see how to use GetDatabaseFleetHealthMetricsRequest.
 */
export interface GetDatabaseFleetHealthMetricsRequest extends common.BaseRequest {
    /**
     * The baseline time for metrics comparison.
     */
    "compareBaselineTime": string;
    /**
     * The target time for metrics comparison.
     */
    "compareTargetTime": string;
    /**
     * The client request ID for tracing.
     */
    "opcRequestId"?: string;
    /**
     * The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the Managed Database Group.
     */
    "managedDatabaseGroupId"?: string;
    /**
     * The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the compartment.
     */
    "compartmentId"?: string;
    /**
     * The time window used for metrics comparison.
     */
    "compareType"?: model.CompareType;
    /**
     * The filter used to retrieve a specific set of metrics by passing the desired metric names with a comma separator. Note that, by default, the service returns all supported metrics.
     */
    "filterByMetricNames"?: string;
    /**
     * The filter used to filter the databases in the fleet by a specific Oracle Database type.
     */
    "filterByDatabaseType"?: string;
    /**
     * The filter used to filter the databases in the fleet by a specific Oracle Database subtype.
     */
    "filterByDatabaseSubType"?: string;
}
