/**
 * Data Catalog API
 * Use the Data Catalog APIs to collect, organize, find, access, understand, enrich, and activate technical, business, and operational metadata.
 * OpenAPI spec version: 20190325
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Properties used in data asset create operations.
 */
export interface CreatePatternDetails {
    /**
     * A user-friendly display name. Does not have to be unique, and it's changeable.
     * Avoid entering confidential information.
     *
     */
    "displayName": string;
    /**
     * Detailed description of the Pattern.
     */
    "description"?: string;
    /**
     * The expression used in the pattern that may include qualifiers. Refer to the user documentation for details of the format and examples.
     *
     */
    "expression"?: string;
    /**
     * List of file paths against which the expression can be tried, as a check. This documents, for reference
     * purposes, some example objects a pattern is meant to work with. If isEnableCheckFailureLimit is set to true,
     * this will be run as a validation during the request, such that if the check fails the request fails. If
     * isEnableCheckFailureLimit instead is set to (the default) false, a pattern will still be created or updated even
     * if the check fails, with a lifecycleState of FAILED.
     *
     */
    "checkFilePathList"?: Array<string>;
    /**
     * Indicates whether the expression check, against the checkFilePathList, will fail the request if the count of
     * UNMATCHED files is above the checkFailureLimit.
     *
     */
    "isEnableCheckFailureLimit"?: boolean;
    /**
     * The maximum number of UNMATCHED files, in checkFilePathList, above which the check fails. Optional, if
     * checkFilePathList is provided - but if isEnableCheckFailureLimit is set to true it is required.
     *  Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "checkFailureLimit"?: number;
    /**
     * A map of maps that contains the properties which are specific to the pattern type. Each pattern type
     * definition defines it's set of required and optional properties.
     * Example: `{\"properties\": { \"default\": { \"tbd\"}}}`
     *
     */
    "properties"?: {
        [key: string]: {
            [key: string]: string;
        };
    };
}
export declare namespace CreatePatternDetails {
    function getJsonObj(obj: CreatePatternDetails): object;
}
