/**
 * Data Catalog API
 * Use the Data Catalog APIs to collect, organize, find, access, understand, enrich, and activate technical, business, and operational metadata.
 * OpenAPI spec version: 20190325
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Entities derived from the application of a pattern to a list of file paths.
 */
export interface DerivedLogicalEntities {
    /**
     * The name of the derived logical entity. The group name of the unmatched files will be UNMATCHED
     */
    "name"?: string;
    /**
     * The expression realized after resolving qualifiers . Used in deriving this logical entity
     */
    "realizedExpression"?: string;
    /**
     * The list of file paths that belong to the grouping of logical entity or UNMATCHED for which realizedExpression is a selector.
     */
    "filesInLogicalGrouping"?: Array<string>;
}
export declare namespace DerivedLogicalEntities {
    function getJsonObj(obj: DerivedLogicalEntities): object;
}
