/**
 * Data Catalog API
 * Use the Data Catalog APIs to collect, organize, find, access, understand, enrich, and activate technical, business, and operational metadata.
 * OpenAPI spec version: 20190325
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * A list of job executions. A job execution is a unit of work being executed on behalf of a job.
 */
export interface JobExecutionSummary {
    /**
     * Unique key of the job execution resource.
     */
    "key": string;
    /**
     * The unique key of the parent job.
     */
    "jobKey"?: string;
    /**
     * Type of the job execution.
     */
    "jobType"?: model.JobType;
    /**
     * The unique key of the parent execution or null if this job execution has no parent.
     */
    "parentKey"?: string;
    /**
     * The unique key of the triggering external scheduler resource or null if this job execution is not externally triggered.
     */
    "scheduleInstanceKey"?: string;
    /**
     * Status of the job execution, such as running, paused, or completed.
     */
    "lifecycleState"?: model.JobExecutionState;
    /**
     * The date and time the job execution was created, in the format defined by [RFC3339](https://tools.ietf.org/html/rfc3339).
     * Example: `2019-03-25T21:10:29.600Z`
     *
     */
    "timeCreated"?: Date;
    /**
     * Time that job execution started. An [RFC3339](https://tools.ietf.org/html/rfc3339) formatted datetime string.
     */
    "timeStarted"?: Date;
    /**
     * Time that the job execution ended or null if it hasn't yet completed.
     * An [RFC3339](https://tools.ietf.org/html/rfc3339) formatted datetime string.
     *
     */
    "timeEnded"?: Date;
    /**
     * URI to the job execution instance in the API.
     */
    "uri"?: string;
}
export declare namespace JobExecutionSummary {
    function getJsonObj(obj: JobExecutionSummary): object;
}
