/**
 * Data Catalog API
 * Use the Data Catalog APIs to collect, organize, find, access, understand, enrich, and activate technical, business, and operational metadata.
 * OpenAPI spec version: 20190325
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Summary data catalog type information. All types are statically defined in the system and are immutable.
 * It isn't possible to create new types or update existing types via the API.
 *
 */
export interface TypeSummary {
    /**
     * Unique type key that is immutable.
     */
    "key": string;
    /**
     * The immutable name of the type.
     */
    "name"?: string;
    /**
     * Detailed description of the type.
     */
    "description"?: string;
    /**
     * The data catalog's OCID.
     */
    "catalogId"?: string;
    /**
     * Indicates the category this type belongs to. For instance, data assets, connections.
     */
    "typeCategory"?: string;
    /**
     * URI to the type instance in the API.
     */
    "uri"?: string;
    /**
     * State of the folder.
     */
    "lifecycleState"?: model.LifecycleState;
}
export declare namespace TypeSummary {
    function getJsonObj(obj: TypeSummary): object;
}
