"use strict";
/**
 * Data Integration API
 * Use the Data Integration Service APIs to perform common extract, load, and transform (ETL) tasks.
 * OpenAPI spec version: 20200430
 * Contact: di_dis_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Connection = void 0;
const model = __importStar(require("../model"));
var Connection;
(function (Connection) {
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "parentRef": obj.parentRef ? model.ParentReference.getJsonObj(obj.parentRef) : undefined,
            "primarySchema": obj.primarySchema ? model.Schema.getJsonObj(obj.primarySchema) : undefined,
            "connectionProperties": obj.connectionProperties
                ? obj.connectionProperties.map(item => {
                    return model.ConnectionProperty.getJsonObj(item);
                })
                : undefined,
            "metadata": obj.metadata ? model.ObjectMetadata.getJsonObj(obj.metadata) : undefined
        });
        if ("modelType" in obj && obj.modelType) {
            switch (obj.modelType) {
                case "ORACLE_OBJECT_STORAGE_CONNECTION":
                    return model.ConnectionFromObjectStorage.getJsonObj(jsonObj, true);
                case "ORACLE_ADWC_CONNECTION":
                    return model.ConnectionFromAdwc.getJsonObj(jsonObj, true);
                case "ORACLE_ATP_CONNECTION":
                    return model.ConnectionFromAtp.getJsonObj(jsonObj, true);
                case "ORACLEDB_CONNECTION":
                    return model.ConnectionFromOracle.getJsonObj(jsonObj, true);
                case "MYSQL_CONNECTION":
                    return model.ConnectionFromMySQL.getJsonObj(jsonObj, true);
                case "GENERIC_JDBC_CONNECTION":
                    return model.ConnectionFromJdbc.getJsonObj(jsonObj, true);
                default:
                    throw Error("Unknown value for: " + obj.modelType);
            }
        }
        return jsonObj;
    }
    Connection.getJsonObj = getJsonObj;
})(Connection = exports.Connection || (exports.Connection = {}));
//# sourceMappingURL=connection.js.map