/**
 * Data Integration API
 * Use the Data Integration Service APIs to perform common extract, load, and transform (ETL) tasks.
 * OpenAPI spec version: 20200430
 * Contact: di_dis_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Properties used in patch create operations.
 */
export interface CreatePatchDetails {
    /**
     * The object's key.
     */
    "key"?: string;
    /**
     * The object's model version.
     */
    "modelVersion"?: string;
    /**
     * Free form text without any restriction on permitted characters. Name can have letters, numbers, and special characters. The value is editable and is restricted to 1000 characters.
     */
    "name": string;
    /**
     * Detailed description for the object.
     */
    "description"?: string;
    /**
     * The status of an object that can be set to value 1 for shallow references across objects, other values reserved. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "objectStatus"?: number;
    /**
     * Value can only contain upper case letters, underscore and numbers. It should begin with upper case letter or underscore. The value can be modified.
     */
    "identifier": string;
    /**
     * The type of the patch applied or being applied on the application.
     */
    "patchType": CreatePatchDetails.PatchType;
    /**
     * The array of object keys to publish into application.
     */
    "objectKeys": Array<string>;
    "registryMetadata"?: model.RegistryMetadata;
}
export declare namespace CreatePatchDetails {
    enum PatchType {
        Publish = "PUBLISH",
        Refresh = "REFRESH",
        Unpublish = "UNPUBLISH"
    }
    function getJsonObj(obj: CreatePatchDetails): object;
}
