/**
 * Data Integration API
 * Use the Data Integration Service APIs to perform common extract, load, and transform (ETL) tasks.
 * OpenAPI spec version: 20200430
 * Contact: di_dis_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Summary details for the Oracle Object storage data asset type.
 */
export interface DataAssetSummaryFromObjectStorage extends model.DataAssetSummary {
    /**
     * The Oracle Object storage URL.
     */
    "url"?: string;
    /**
     * The OCI tenancy OCID.
     */
    "tenancyId"?: string;
    /**
     * The namespace for the specified Oracle Object storage resource. You can find the namespace under Object Storage Settings in the Console.
     */
    "namespace"?: string;
    "defaultConnection"?: model.ConnectionSummaryFromObjectStorage;
    "modelType": string;
}
export declare namespace DataAssetSummaryFromObjectStorage {
    function getJsonObj(obj: DataAssetSummaryFromObjectStorage, isParentJsonObj?: boolean): object;
    const modelType = "ORACLE_OBJECT_STORAGE_DATA_ASSET";
}
