/**
 * Data Integration API
 * Use the Data Integration Service APIs to perform common extract, load, and transform (ETL) tasks.
 * OpenAPI spec version: 20200430
 * Contact: di_dis_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * A `DataType` object is a simple primitive type that describes the type of a single atomic unit of data.  For example, `INT`, `VARCHAR`, `NUMBER`, and so on.
 */
export interface DataType extends model.BaseType {
    /**
     * The data type.
     */
    "dtType"?: DataType.DtType;
    /**
     * The data type system name.
     */
    "typeSystemName"?: string;
    "configDefinition"?: model.ConfigDefinition;
    "modelType": string;
}
export declare namespace DataType {
    enum DtType {
        Primitive = "PRIMITIVE",
        Structured = "STRUCTURED",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: DataType, isParentJsonObj?: boolean): object;
    const modelType = "DATA_TYPE";
}
