/**
 * Data Integration API
 * Use the Data Integration Service APIs to perform common extract, load, and transform (ETL) tasks.
 * OpenAPI spec version: 20200430
 * Contact: di_dis_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The native shape field object.
 */
export interface NativeShapeField {
    /**
     * Free form text without any restriction on permitted characters. Name can have letters, numbers, and special characters. The value is editable and is restricted to 1000 characters.
     */
    "name"?: string;
    /**
     * The model type reference.
     */
    "modelType"?: string;
    /**
     * The type reference.
     */
    "type"?: string;
    "configValues"?: model.ConfigValues;
    /**
     * The position of the attribute. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "position"?: number;
    /**
     * The default value.
     */
    "defaultValueString"?: string;
    /**
     * Specifies whether the field is mandatory.
     */
    "isMandatory"?: boolean;
}
export declare namespace NativeShapeField {
    function getJsonObj(obj: NativeShapeField): object;
}
