/**
 * Data Integration API
 * Use the Data Integration Service APIs to perform common extract, load, and transform (ETL) tasks.
 * OpenAPI spec version: 20200430
 * Contact: di_dis_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * A map of rule patterns.
 */
export interface RuleBasedFieldMap extends model.FieldMap {
    /**
     * The object key.
     */
    "key"?: string;
    /**
     * The object's model version.
     */
    "modelVersion"?: string;
    "parentRef"?: model.ParentReference;
    "configValues"?: model.ConfigValues;
    /**
     * mapType
     */
    "mapType"?: RuleBasedFieldMap.MapType;
    /**
     * The pattern to map from.
     */
    "fromPattern"?: string;
    /**
     * The pattern to map to.
     */
    "toPattern"?: string;
    /**
     * Specifies whether the rule uses a java regex syntax.
     */
    "isJavaRegexSyntax"?: boolean;
    /**
     * The status of an object that can be set to value 1 for shallow references across objects, other values reserved. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "objectStatus"?: number;
    "fromRuleConfig"?: model.RuleTypeConfig;
    "toRuleConfig"?: model.RuleTypeConfig;
    "modelType": string;
}
export declare namespace RuleBasedFieldMap {
    enum MapType {
        Mapbyname = "MAPBYNAME",
        Mapbyposition = "MAPBYPOSITION",
        Mapbypattern = "MAPBYPATTERN",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: RuleBasedFieldMap, isParentJsonObj?: boolean): object;
    const modelType = "RULE_BASED_FIELD_MAP";
}
