/**
 * Data Integration API
 * Use the Data Integration Service APIs to perform common extract, load, and transform (ETL) tasks.
 * OpenAPI spec version: 20200430
 * Contact: di_dis_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details for the Oracle Database data asset type.
 */
export interface UpdateDataAssetFromOracle extends model.UpdateDataAssetDetails {
    /**
     * The Oracle Database hostname.
     */
    "host"?: string;
    /**
     * The Oracle Database port.
     */
    "port"?: string;
    /**
     * The Oracle Database service name.
     */
    "serviceName"?: string;
    /**
     * The Oracle Database driver class.
     */
    "driverClass"?: string;
    /**
     * The Oracle Database SID.
     */
    "sid"?: string;
    /**
     * The credential file content from a wallet for the data asset.
     */
    "credentialFileContent"?: string;
    "defaultConnection"?: model.UpdateConnectionFromOracle;
    "modelType": string;
}
export declare namespace UpdateDataAssetFromOracle {
    function getJsonObj(obj: UpdateDataAssetFromOracle, isParentJsonObj?: boolean): object;
    const modelType = "ORACLE_DATA_ASSET";
}
