/**
 * Data Integration API
 * Use the Data Integration Service APIs to perform common extract, load, and transform (ETL) tasks.
 * OpenAPI spec version: 20200430
 * Contact: di_dis_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * The error that occured while executing an operation that is tracked by a work request.
 */
export interface WorkRequestError {
    /**
     * A machine-usable code for the error that occured, as listed in [API Errors](https://docs.cloud.oracle.com/Content/API/References/apierrors.htm).
     *
     */
    "code": string;
    /**
     * A user friendly description of the error that occured.
     */
    "message": string;
    /**
     * The date and time the error occured, in the timestamp format defined by [RFC 3339](https://tools.ietf.org/rfc/rfc3339).
     */
    "timestamp": Date;
}
export declare namespace WorkRequestError {
    function getJsonObj(obj: WorkRequestError): object;
}
