/**
 *
 *
 * OpenAPI spec version: 20200430
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import common = require("oci-common");
/**
 * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/1.15.1/dataintegration/ListExternalPublications.ts.html |here} to see how to use ListExternalPublicationsRequest.
 */
export interface ListExternalPublicationsRequest extends common.BaseRequest {
    /**
     * The workspace ID.
     */
    "workspaceId": string;
    /**
     * The task key.
     */
    "taskKey": string;
    /**
     * Specifies the fields to get for an object.
     */
    "fields"?: Array<string>;
    /**
     * Used to filter by the name of the object.
     */
    "name"?: string;
    /**
     * Sets the maximum number of results per page, or items to return in a paginated `List` call. See [List Pagination](https://docs.cloud.oracle.com/iaas/Content/API/Concepts/usingapi.htm#nine).
     */
    "limit"?: number;
    /**
     * For list pagination. The value for this parameter is the `opc-next-page` or the `opc-prev-page` response header from the previous `List` call. See [List Pagination](https://docs.cloud.oracle.com/iaas/Content/API/Concepts/usingapi.htm#nine).
     */
    "page"?: string;
    /**
     * Specifies sort order to use, either `ASC` (ascending) or `DESC` (descending).
     */
    "sortOrder"?: ListExternalPublicationsRequest.SortOrder;
    /**
     * Specifies the field to sort by. Accepts only one field. By default, when you sort by time fields, results are shown in descending order. All other fields default to ascending order. Sorting related parameters are ignored when parameter `query` is present (search operation and sorting order is by relevance score in descending order).
     */
    "sortBy"?: ListExternalPublicationsRequest.SortBy;
    /**
     * Unique Oracle-assigned identifier for the request. If
     * you need to contact Oracle about a particular request,
     * please provide the request ID.
     *
     */
    "opcRequestId"?: string;
}
export declare namespace ListExternalPublicationsRequest {
    enum SortOrder {
        Asc = "ASC",
        Desc = "DESC"
    }
    enum SortBy {
        TimeCreated = "TIME_CREATED",
        DisplayName = "DISPLAY_NAME"
    }
}
