/**
 * Data Safe API
 * APIs for using Oracle Data Safe.
 * OpenAPI spec version: 20181201
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Summary of a Data Safe private endpoint.
 */
export interface DataSafePrivateEndpointSummary {
    /**
     * The OCID of the Data Safe private endpoint.
     */
    "id": string;
    /**
     * The display name of the private endpoint.
     */
    "displayName": string;
    /**
     * The OCID of the compartment.
     */
    "compartmentId": string;
    /**
     * The OCID of the VCN.
     */
    "vcnId": string;
    /**
     * The OCID of the subnet.
     */
    "subnetId": string;
    /**
     * The OCID of the private endpoint.
     */
    "privateEndpointId": string;
    /**
     * The description of the private endpoint.
     */
    "description"?: string;
    /**
     * The date and time the private endpoint was created, in the format defined by [RFC3339](https://tools.ietf.org/html/rfc3339).
     */
    "timeCreated"?: Date;
    /**
     * The current state of the private endpoint.
     */
    "lifecycleState"?: model.LifecycleState;
}
export declare namespace DataSafePrivateEndpointSummary {
    function getJsonObj(obj: DataSafePrivateEndpointSummary): object;
}
