/**
 * DNS API
 * API for the DNS service. Use this API to manage DNS zones, records, and other DNS resources.
For more information, see [Overview of the DNS Service](/iaas/Content/DNS/Concepts/dnszonemanagement.htm).

 * OpenAPI spec version: 20180115
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
* The configuration of the sorting and filtering behaviors in a steering policy. Rules can
* filter and sort answers based on weight, priority, endpoint health, and other data.
* <p>

* A rule may optionally include a sequence of cases, each with an optional `caseCondition`
* expression. Cases allow a sequence of conditions to be defined that will apply different
* parameters to the rule when the conditions are met. For more information about cases,
* see [Traffic Management API Guide](https://docs.cloud.oracle.com/iaas/Content/TrafficManagement/Concepts/trafficmanagementapi.htm).
* <p>

* **Warning:** Oracle recommends that you avoid using any confidential information when you supply string values using the API.
*
*/
export interface SteeringPolicyRule {
    /**
     * A user-defined description of the rule's purpose or behavior.
     */
    "description"?: string;
    "ruleType": string;
}
export declare namespace SteeringPolicyRule {
    function getJsonObj(obj: SteeringPolicyRule): object;
}
