/**
 * Email Delivery API
 * API for the Email Delivery service. Use this API to send high-volume, application-generated
emails. For more information, see [Overview of the Email Delivery Service](/iaas/Content/Email/Concepts/overview.htm).


**Note:** Write actions (POST, UPDATE, DELETE) may take several minutes to propagate and be reflected by the API. If a subsequent read request fails to reflect your changes, wait a few minutes and try again.

 * OpenAPI spec version: 20170907
 * Contact: email-dev_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * The full information representing an email suppression.
 */
export interface Suppression {
    /**
     * The OCID of the compartment to contain the suppression. Since
     * suppressions are at the customer level, this must be the tenancy
     * OCID.
     *
     */
    "compartmentId"?: string;
    /**
     * Email address of the suppression.
     */
    "emailAddress"?: string;
    /**
     * The unique ID of the suppression.
     */
    "id"?: string;
    /**
     * The reason that the email address was suppressed. For more information on the types of bounces, see [Suppression List](https://docs.us-phoenix-1.oraclecloud.com/Content/Email/Concepts/overview.htm#components).
     */
    "reason"?: Suppression.Reason;
    /**
     * The date and time the suppression was added in \"YYYY-MM-ddThh:mmZ\"
     * format with a Z offset, as defined by RFC 3339.
     *
     */
    "timeCreated"?: Date;
}
export declare namespace Suppression {
    enum Reason {
        Unknown = "UNKNOWN",
        Hardbounce = "HARDBOUNCE",
        Complaint = "COMPLAINT",
        Manual = "MANUAL",
        Softbounce = "SOFTBOUNCE",
        Unsubscribe = "UNSUBSCRIBE",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: Suppression): object;
}
