/**
 * Identity and Access Management Service API
 * APIs for managing users, groups, compartments, and policies.
 * OpenAPI spec version: 20160918
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
export interface CreateIdentityProviderDetails {
    /**
     * The OCID of your tenancy.
     */
    "compartmentId": string;
    /**
     * The name you assign to the `IdentityProvider` during creation.
     * The name must be unique across all `IdentityProvider` objects in the
     * tenancy and cannot be changed.
     *
     */
    "name": string;
    /**
     * The description you assign to the `IdentityProvider` during creation.
     * Does not have to be unique, and it's changeable.
     *
     */
    "description": string;
    /**
      * The identity provider service or product.
  * Supported identity providers are Oracle Identity Cloud Service (IDCS) and Microsoft
  * Active Directory Federation Services (ADFS).
  * <p>
  Example: `IDCS`
  *
      */
    "productType": CreateIdentityProviderDetails.ProductType;
    /**
     * Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace.
     * For more information, see [Resource Tags](https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm).
     * Example: `{\"Department\": \"Finance\"}`
     *
     */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
     * Defined tags for this resource. Each key is predefined and scoped to a namespace.
     * For more information, see [Resource Tags](https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm).
     * Example: `{\"Operations\": {\"CostCenter\": \"42\"}}`
     *
     */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
    "protocol": string;
}
export declare namespace CreateIdentityProviderDetails {
    enum ProductType {
        Idcs = "IDCS",
        Adfs = "ADFS"
    }
    function getJsonObj(obj: CreateIdentityProviderDetails): object;
}
