/**
 * Identity and Access Management Service API
 * APIs for managing users, groups, compartments, and policies.
 * OpenAPI spec version: 20160918
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Properties for creating a network source object.
 */
export interface CreateNetworkSourceDetails {
    /**
     * The OCID of the tenancy (root compartment) containing the network source object.
     */
    "compartmentId": string;
    /**
     * The name you assign to the network source during creation. The name must be unique across all groups
     * in the tenancy and cannot be changed.
     *
     */
    "name": string;
    /**
     * A list of allowed public IP addresses and CIDR ranges.
     *
     */
    "publicSourceList"?: Array<string>;
    /**
     * A list of allowed VCN OCID and IP range pairs.
     * Example:`\"vcnId\": \"ocid1.vcn.oc1.iad.aaaaaaaaexampleuniqueID\", \"ipRanges\": [ \"129.213.39.0/24\" ]`
     *
     */
    "virtualSourceList"?: Array<model.NetworkSourcesVirtualSourceList>;
    /**
     * A list of services allowed to make on-behalf-of requests. These requests can have different source IP addresses
     * than those listed in the network source.
     * Currently, only `all` and `none` are supported. The default is `all`.
     *
     */
    "services"?: Array<string>;
    /**
     * The description you assign to the network source during creation. Does not have to be unique, and it's changeable.
     */
    "description": string;
    /**
     * Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace.
     * For more information, see [Resource Tags](https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm).
     * Example: `{\"Department\": \"Finance\"}`
     *
     */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
     * Defined tags for this resource. Each key is predefined and scoped to a namespace.
     * For more information, see [Resource Tags](https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm).
     * Example: `{\"Operations\": {\"CostCenter\": \"42\"}}`
     *
     */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
}
export declare namespace CreateNetworkSourceDetails {
    function getJsonObj(obj: CreateNetworkSourceDetails): object;
}
