/**
 * Identity and Access Management Service API
 * APIs for managing users, groups, compartments, and policies.
 * OpenAPI spec version: 20160918
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as AddUserToGroupDetails from "./add-user-to-group-details";
export import AddUserToGroupDetails = AddUserToGroupDetails.AddUserToGroupDetails;
import * as ApiKey from "./api-key";
export import ApiKey = ApiKey.ApiKey;
import * as AuthToken from "./auth-token";
export import AuthToken = AuthToken.AuthToken;
import * as AuthenticationPolicy from "./authentication-policy";
export import AuthenticationPolicy = AuthenticationPolicy.AuthenticationPolicy;
import * as AvailabilityDomain from "./availability-domain";
export import AvailabilityDomain = AvailabilityDomain.AvailabilityDomain;
import * as BaseTagDefinitionValidator from "./base-tag-definition-validator";
export import BaseTagDefinitionValidator = BaseTagDefinitionValidator.BaseTagDefinitionValidator;
import * as BulkActionResource from "./bulk-action-resource";
export import BulkActionResource = BulkActionResource.BulkActionResource;
import * as BulkActionResourceType from "./bulk-action-resource-type";
export import BulkActionResourceType = BulkActionResourceType.BulkActionResourceType;
import * as BulkActionResourceTypeCollection from "./bulk-action-resource-type-collection";
export import BulkActionResourceTypeCollection = BulkActionResourceTypeCollection.BulkActionResourceTypeCollection;
import * as BulkDeleteResourcesDetails from "./bulk-delete-resources-details";
export import BulkDeleteResourcesDetails = BulkDeleteResourcesDetails.BulkDeleteResourcesDetails;
import * as BulkDeleteTagsDetails from "./bulk-delete-tags-details";
export import BulkDeleteTagsDetails = BulkDeleteTagsDetails.BulkDeleteTagsDetails;
import * as BulkEditOperationDetails from "./bulk-edit-operation-details";
export import BulkEditOperationDetails = BulkEditOperationDetails.BulkEditOperationDetails;
import * as BulkEditResource from "./bulk-edit-resource";
export import BulkEditResource = BulkEditResource.BulkEditResource;
import * as BulkEditTagsDetails from "./bulk-edit-tags-details";
export import BulkEditTagsDetails = BulkEditTagsDetails.BulkEditTagsDetails;
import * as BulkEditTagsResourceType from "./bulk-edit-tags-resource-type";
export import BulkEditTagsResourceType = BulkEditTagsResourceType.BulkEditTagsResourceType;
import * as BulkEditTagsResourceTypeCollection from "./bulk-edit-tags-resource-type-collection";
export import BulkEditTagsResourceTypeCollection = BulkEditTagsResourceTypeCollection.BulkEditTagsResourceTypeCollection;
import * as BulkMoveResourcesDetails from "./bulk-move-resources-details";
export import BulkMoveResourcesDetails = BulkMoveResourcesDetails.BulkMoveResourcesDetails;
import * as ChangeTagNamespaceCompartmentDetail from "./change-tag-namespace-compartment-detail";
export import ChangeTagNamespaceCompartmentDetail = ChangeTagNamespaceCompartmentDetail.ChangeTagNamespaceCompartmentDetail;
import * as Compartment from "./compartment";
export import Compartment = Compartment.Compartment;
import * as CreateApiKeyDetails from "./create-api-key-details";
export import CreateApiKeyDetails = CreateApiKeyDetails.CreateApiKeyDetails;
import * as CreateAuthTokenDetails from "./create-auth-token-details";
export import CreateAuthTokenDetails = CreateAuthTokenDetails.CreateAuthTokenDetails;
import * as CreateCompartmentDetails from "./create-compartment-details";
export import CreateCompartmentDetails = CreateCompartmentDetails.CreateCompartmentDetails;
import * as CreateCustomerSecretKeyDetails from "./create-customer-secret-key-details";
export import CreateCustomerSecretKeyDetails = CreateCustomerSecretKeyDetails.CreateCustomerSecretKeyDetails;
import * as CreateDynamicGroupDetails from "./create-dynamic-group-details";
export import CreateDynamicGroupDetails = CreateDynamicGroupDetails.CreateDynamicGroupDetails;
import * as CreateGroupDetails from "./create-group-details";
export import CreateGroupDetails = CreateGroupDetails.CreateGroupDetails;
import * as CreateIdentityProviderDetails from "./create-identity-provider-details";
export import CreateIdentityProviderDetails = CreateIdentityProviderDetails.CreateIdentityProviderDetails;
import * as CreateIdpGroupMappingDetails from "./create-idp-group-mapping-details";
export import CreateIdpGroupMappingDetails = CreateIdpGroupMappingDetails.CreateIdpGroupMappingDetails;
import * as CreateNetworkSourceDetails from "./create-network-source-details";
export import CreateNetworkSourceDetails = CreateNetworkSourceDetails.CreateNetworkSourceDetails;
import * as CreateOAuth2ClientCredentialDetails from "./create-oauth2-client-credential-details";
export import CreateOAuth2ClientCredentialDetails = CreateOAuth2ClientCredentialDetails.CreateOAuth2ClientCredentialDetails;
import * as CreatePolicyDetails from "./create-policy-details";
export import CreatePolicyDetails = CreatePolicyDetails.CreatePolicyDetails;
import * as CreateRegionSubscriptionDetails from "./create-region-subscription-details";
export import CreateRegionSubscriptionDetails = CreateRegionSubscriptionDetails.CreateRegionSubscriptionDetails;
import * as CreateSmtpCredentialDetails from "./create-smtp-credential-details";
export import CreateSmtpCredentialDetails = CreateSmtpCredentialDetails.CreateSmtpCredentialDetails;
import * as CreateSwiftPasswordDetails from "./create-swift-password-details";
export import CreateSwiftPasswordDetails = CreateSwiftPasswordDetails.CreateSwiftPasswordDetails;
import * as CreateTagDefaultDetails from "./create-tag-default-details";
export import CreateTagDefaultDetails = CreateTagDefaultDetails.CreateTagDefaultDetails;
import * as CreateTagDetails from "./create-tag-details";
export import CreateTagDetails = CreateTagDetails.CreateTagDetails;
import * as CreateTagNamespaceDetails from "./create-tag-namespace-details";
export import CreateTagNamespaceDetails = CreateTagNamespaceDetails.CreateTagNamespaceDetails;
import * as CreateUserDetails from "./create-user-details";
export import CreateUserDetails = CreateUserDetails.CreateUserDetails;
import * as CustomerSecretKey from "./customer-secret-key";
export import CustomerSecretKey = CustomerSecretKey.CustomerSecretKey;
import * as CustomerSecretKeySummary from "./customer-secret-key-summary";
export import CustomerSecretKeySummary = CustomerSecretKeySummary.CustomerSecretKeySummary;
import * as DynamicGroup from "./dynamic-group";
export import DynamicGroup = DynamicGroup.DynamicGroup;
import * as FaultDomain from "./fault-domain";
export import FaultDomain = FaultDomain.FaultDomain;
import * as FullyQualifiedScope from "./fully-qualified-scope";
export import FullyQualifiedScope = FullyQualifiedScope.FullyQualifiedScope;
import * as Group from "./group";
export import Group = Group.Group;
import * as IdentityProvider from "./identity-provider";
export import IdentityProvider = IdentityProvider.IdentityProvider;
import * as IdentityProviderGroupSummary from "./identity-provider-group-summary";
export import IdentityProviderGroupSummary = IdentityProviderGroupSummary.IdentityProviderGroupSummary;
import * as IdpGroupMapping from "./idp-group-mapping";
export import IdpGroupMapping = IdpGroupMapping.IdpGroupMapping;
import * as MfaTotpDevice from "./mfa-totp-device";
export import MfaTotpDevice = MfaTotpDevice.MfaTotpDevice;
import * as MfaTotpDeviceSummary from "./mfa-totp-device-summary";
export import MfaTotpDeviceSummary = MfaTotpDeviceSummary.MfaTotpDeviceSummary;
import * as MfaTotpToken from "./mfa-totp-token";
export import MfaTotpToken = MfaTotpToken.MfaTotpToken;
import * as MoveCompartmentDetails from "./move-compartment-details";
export import MoveCompartmentDetails = MoveCompartmentDetails.MoveCompartmentDetails;
import * as NetworkPolicy from "./network-policy";
export import NetworkPolicy = NetworkPolicy.NetworkPolicy;
import * as NetworkSources from "./network-sources";
export import NetworkSources = NetworkSources.NetworkSources;
import * as NetworkSourcesSummary from "./network-sources-summary";
export import NetworkSourcesSummary = NetworkSourcesSummary.NetworkSourcesSummary;
import * as NetworkSourcesVirtualSourceList from "./network-sources_virtual-source-list";
export import NetworkSourcesVirtualSourceList = NetworkSourcesVirtualSourceList.NetworkSourcesVirtualSourceList;
import * as OAuth2ClientCredential from "./o-auth2-client-credential";
export import OAuth2ClientCredential = OAuth2ClientCredential.OAuth2ClientCredential;
import * as OAuth2ClientCredentialSummary from "./o-auth2-client-credential-summary";
export import OAuth2ClientCredentialSummary = OAuth2ClientCredentialSummary.OAuth2ClientCredentialSummary;
import * as PasswordPolicy from "./password-policy";
export import PasswordPolicy = PasswordPolicy.PasswordPolicy;
import * as Policy from "./policy";
export import Policy = Policy.Policy;
import * as Region from "./region";
export import Region = Region.Region;
import * as RegionSubscription from "./region-subscription";
export import RegionSubscription = RegionSubscription.RegionSubscription;
import * as ScimClientCredentials from "./scim-client-credentials";
export import ScimClientCredentials = ScimClientCredentials.ScimClientCredentials;
import * as SmtpCredential from "./smtp-credential";
export import SmtpCredential = SmtpCredential.SmtpCredential;
import * as SmtpCredentialSummary from "./smtp-credential-summary";
export import SmtpCredentialSummary = SmtpCredentialSummary.SmtpCredentialSummary;
import * as SwiftPassword from "./swift-password";
export import SwiftPassword = SwiftPassword.SwiftPassword;
import * as Tag from "./tag";
export import Tag = Tag.Tag;
import * as TagDefault from "./tag-default";
export import TagDefault = TagDefault.TagDefault;
import * as TagDefaultSummary from "./tag-default-summary";
export import TagDefaultSummary = TagDefaultSummary.TagDefaultSummary;
import * as TagNamespace from "./tag-namespace";
export import TagNamespace = TagNamespace.TagNamespace;
import * as TagNamespaceSummary from "./tag-namespace-summary";
export import TagNamespaceSummary = TagNamespaceSummary.TagNamespaceSummary;
import * as TagSummary from "./tag-summary";
export import TagSummary = TagSummary.TagSummary;
import * as TaggingWorkRequest from "./tagging-work-request";
export import TaggingWorkRequest = TaggingWorkRequest.TaggingWorkRequest;
import * as TaggingWorkRequestErrorSummary from "./tagging-work-request-error-summary";
export import TaggingWorkRequestErrorSummary = TaggingWorkRequestErrorSummary.TaggingWorkRequestErrorSummary;
import * as TaggingWorkRequestLogSummary from "./tagging-work-request-log-summary";
export import TaggingWorkRequestLogSummary = TaggingWorkRequestLogSummary.TaggingWorkRequestLogSummary;
import * as TaggingWorkRequestSummary from "./tagging-work-request-summary";
export import TaggingWorkRequestSummary = TaggingWorkRequestSummary.TaggingWorkRequestSummary;
import * as Tenancy from "./tenancy";
export import Tenancy = Tenancy.Tenancy;
import * as UIPassword from "./u-ipassword";
export import UIPassword = UIPassword.UIPassword;
import * as UIPasswordInformation from "./u-ipassword-information";
export import UIPasswordInformation = UIPasswordInformation.UIPasswordInformation;
import * as UpdateAuthTokenDetails from "./update-auth-token-details";
export import UpdateAuthTokenDetails = UpdateAuthTokenDetails.UpdateAuthTokenDetails;
import * as UpdateAuthenticationPolicyDetails from "./update-authentication-policy-details";
export import UpdateAuthenticationPolicyDetails = UpdateAuthenticationPolicyDetails.UpdateAuthenticationPolicyDetails;
import * as UpdateCompartmentDetails from "./update-compartment-details";
export import UpdateCompartmentDetails = UpdateCompartmentDetails.UpdateCompartmentDetails;
import * as UpdateCustomerSecretKeyDetails from "./update-customer-secret-key-details";
export import UpdateCustomerSecretKeyDetails = UpdateCustomerSecretKeyDetails.UpdateCustomerSecretKeyDetails;
import * as UpdateDynamicGroupDetails from "./update-dynamic-group-details";
export import UpdateDynamicGroupDetails = UpdateDynamicGroupDetails.UpdateDynamicGroupDetails;
import * as UpdateGroupDetails from "./update-group-details";
export import UpdateGroupDetails = UpdateGroupDetails.UpdateGroupDetails;
import * as UpdateIdentityProviderDetails from "./update-identity-provider-details";
export import UpdateIdentityProviderDetails = UpdateIdentityProviderDetails.UpdateIdentityProviderDetails;
import * as UpdateIdpGroupMappingDetails from "./update-idp-group-mapping-details";
export import UpdateIdpGroupMappingDetails = UpdateIdpGroupMappingDetails.UpdateIdpGroupMappingDetails;
import * as UpdateNetworkSourceDetails from "./update-network-source-details";
export import UpdateNetworkSourceDetails = UpdateNetworkSourceDetails.UpdateNetworkSourceDetails;
import * as UpdateOAuth2ClientCredentialDetails from "./update-oauth2-client-credential-details";
export import UpdateOAuth2ClientCredentialDetails = UpdateOAuth2ClientCredentialDetails.UpdateOAuth2ClientCredentialDetails;
import * as UpdatePolicyDetails from "./update-policy-details";
export import UpdatePolicyDetails = UpdatePolicyDetails.UpdatePolicyDetails;
import * as UpdateSmtpCredentialDetails from "./update-smtp-credential-details";
export import UpdateSmtpCredentialDetails = UpdateSmtpCredentialDetails.UpdateSmtpCredentialDetails;
import * as UpdateStateDetails from "./update-state-details";
export import UpdateStateDetails = UpdateStateDetails.UpdateStateDetails;
import * as UpdateSwiftPasswordDetails from "./update-swift-password-details";
export import UpdateSwiftPasswordDetails = UpdateSwiftPasswordDetails.UpdateSwiftPasswordDetails;
import * as UpdateTagDefaultDetails from "./update-tag-default-details";
export import UpdateTagDefaultDetails = UpdateTagDefaultDetails.UpdateTagDefaultDetails;
import * as UpdateTagDetails from "./update-tag-details";
export import UpdateTagDetails = UpdateTagDetails.UpdateTagDetails;
import * as UpdateTagNamespaceDetails from "./update-tag-namespace-details";
export import UpdateTagNamespaceDetails = UpdateTagNamespaceDetails.UpdateTagNamespaceDetails;
import * as UpdateUserCapabilitiesDetails from "./update-user-capabilities-details";
export import UpdateUserCapabilitiesDetails = UpdateUserCapabilitiesDetails.UpdateUserCapabilitiesDetails;
import * as UpdateUserDetails from "./update-user-details";
export import UpdateUserDetails = UpdateUserDetails.UpdateUserDetails;
import * as User from "./user";
export import User = User.User;
import * as UserCapabilities from "./user-capabilities";
export import UserCapabilities = UserCapabilities.UserCapabilities;
import * as UserGroupMembership from "./user-group-membership";
export import UserGroupMembership = UserGroupMembership.UserGroupMembership;
import * as WorkRequest from "./work-request";
export import WorkRequest = WorkRequest.WorkRequest;
import * as WorkRequestError from "./work-request-error";
export import WorkRequestError = WorkRequestError.WorkRequestError;
import * as WorkRequestLogEntry from "./work-request-log-entry";
export import WorkRequestLogEntry = WorkRequestLogEntry.WorkRequestLogEntry;
import * as WorkRequestResource from "./work-request-resource";
export import WorkRequestResource = WorkRequestResource.WorkRequestResource;
import * as WorkRequestSummary from "./work-request-summary";
export import WorkRequestSummary = WorkRequestSummary.WorkRequestSummary;
import * as CreateSaml2IdentityProviderDetails from "./create-saml2-identity-provider-details";
export import CreateSaml2IdentityProviderDetails = CreateSaml2IdentityProviderDetails.CreateSaml2IdentityProviderDetails;
import * as DefaultTagDefinitionValidator from "./default-tag-definition-validator";
export import DefaultTagDefinitionValidator = DefaultTagDefinitionValidator.DefaultTagDefinitionValidator;
import * as EnumTagDefinitionValidator from "./enum-tag-definition-validator";
export import EnumTagDefinitionValidator = EnumTagDefinitionValidator.EnumTagDefinitionValidator;
import * as Saml2IdentityProvider from "./saml2-identity-provider";
export import Saml2IdentityProvider = Saml2IdentityProvider.Saml2IdentityProvider;
import * as UpdateSaml2IdentityProviderDetails from "./update-saml2-identity-provider-details";
export import UpdateSaml2IdentityProviderDetails = UpdateSaml2IdentityProviderDetails.UpdateSaml2IdentityProviderDetails;
