/**
 * Vault Service Key Management API
 * API for managing and performing operations with keys and vaults. (For the API for managing secrets, see the Vault Service
Secret Management API. For the API for retrieving secrets, see the Vault Service Secret Retrieval API.)

 * OpenAPI spec version: release
 * Contact: sparta_kms_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
export interface DecryptedData {
    /**
     * The decrypted data, expressed as a base64-encoded value.
     */
    "plaintext": string;
    /**
     * Checksum of the decrypted data.
     */
    "plaintextChecksum": string;
    /**
     * The OCID of the key used to encrypt the ciphertext.
     */
    "keyId"?: string;
    /**
     * The OCID of the keyVersion used to encrypt the ciphertext.
     */
    "keyVersionId"?: string;
    /**
     * Encryption algorithm to be used while encrypting/decrypting data using a customer key
     * AES_256_GCM is the supported value AES keys and uses GCM mode of operation
     * RSA_OAEP_SHA_1 and RSA_OAEP_SHA_256 are supported for RSA keys and use OAEP padding.
     *
     */
    "encryptionAlgorithm"?: DecryptedData.EncryptionAlgorithm;
}
export declare namespace DecryptedData {
    enum EncryptionAlgorithm {
        Aes256Gcm = "AES_256_GCM",
        RsaOaepSha1 = "RSA_OAEP_SHA_1",
        RsaOaepSha256 = "RSA_OAEP_SHA_256",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: DecryptedData): object;
}
