/**
 * Load Balancing API
 * API for the Load Balancing service. Use this API to manage load balancers, backend sets, and related items. For more
information, see [Overview of Load Balancing](/iaas/Content/Balance/Concepts/balanceoverview.htm).

 * OpenAPI spec version: 20170115
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * An object that represents the action of adding a header to a response.
 * This rule applies only to HTTP listeners.
 * <p>
 **NOTES:**
 * <p>
 *  If a matching header already exists in the response, the system removes all of its occurrences, and then adds the
 *    new header.
 * <p>
 *  The system does not distinquish between underscore and dash characters in headers. That is, it treats
 *   `example_header_name` and `example-header-name` as identical. Oracle recommends that you do not rely on underscore
 *   or dash characters to uniquely distinguish header names.
 *
 */
export interface AddHttpResponseHeaderRule extends model.Rule {
    /**
      * A header name that conforms to RFC 7230.
  * <p>
  Example: `example_header_name`
  *
      */
    "header": string;
    /**
      * A header value that conforms to RFC 7230.
  * <p>
  Example: `example_value`
  *
      */
    "value": string;
    "action": string;
}
export declare namespace AddHttpResponseHeaderRule {
    function getJsonObj(obj: AddHttpResponseHeaderRule, isParentJsonObj?: boolean): object;
    const action = "ADD_HTTP_RESPONSE_HEADER";
}
