/**
 * Load Balancing API
 * API for the Load Balancing service. Use this API to manage load balancers, backend sets, and related items. For more
information, see [Overview of Load Balancing](/iaas/Content/Balance/Concepts/balanceoverview.htm).

 * OpenAPI spec version: 20170115
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * An object that represents the action of configuring an access control rule. Access control rules permit access
 * to application resources based on user-specified match conditions. This rule applies only to HTTP listeners.
 * <p>
 **NOTES:**
 * *  If you do not specify any access control rules, the default rule is to allow all traffic.
 * *  If you add access control rules, the load balancer denies any traffic that does not match the rules.
 * *  Maximum of two match conditions can be specified in a rule.
 * *  You can specify this rule only with the following `RuleCondition` combinations:
 *     *  `SOURCE_IP_ADDRESS`
 *     *  `SOURCE_VCN_ID`
 *     *  `SOURCE_VCN_ID\", \"SOURCE_VCN_IP_ADDRESS`
 *
 */
export interface AllowRule extends model.Rule {
    "conditions": Array<model.RuleCondition>;
    /**
      * A brief description of the access control rule. Avoid entering confidential information.
  * <p>
  example: `192.168.0.0/16 and 2001:db8::/32 are trusted clients. Whitelist them.`
  *
      */
    "description"?: string;
    "action": string;
}
export declare namespace AllowRule {
    function getJsonObj(obj: AllowRule, isParentJsonObj?: boolean): object;
    const action = "ALLOW";
}
