/**
 * Load Balancing API
 * API for the Load Balancing service. Use this API to manage load balancers, backend sets, and related items. For more
information, see [Overview of Load Balancing](/iaas/Content/Balance/Concepts/balanceoverview.htm).

 * OpenAPI spec version: 20170115
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The attributes of a rule associated with the specified listener, and the name of the rule set that the rule
 * belongs to.
 *
 */
export interface ListenerRuleSummary {
    /**
     * A rule object that applies to the listener.
     */
    "rule"?: model.AddHttpRequestHeaderRule | model.RedirectRule | model.RemoveHttpRequestHeaderRule | model.ExtendHttpRequestHeaderValueRule | model.RemoveHttpResponseHeaderRule | model.ControlAccessUsingHttpMethodsRule | model.AllowRule | model.HttpHeaderRule | model.AddHttpResponseHeaderRule | model.ExtendHttpResponseHeaderValueRule;
    /**
     * The name of the rule set that the rule belongs to.
     *
     */
    "ruleSetName"?: string;
}
export declare namespace ListenerRuleSummary {
    function getJsonObj(obj: ListenerRuleSummary): object;
}
