"use strict";
/**
 * Load Balancing API
 * API for the Load Balancing service. Use this API to manage load balancers, backend sets, and related items. For more
information, see [Overview of Load Balancing](/iaas/Content/Balance/Concepts/balanceoverview.htm).

 * OpenAPI spec version: 20170115
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Rule = void 0;
const model = __importStar(require("../model"));
var Rule;
(function (Rule) {
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {});
        if ("action" in obj && obj.action) {
            switch (obj.action) {
                case "ADD_HTTP_REQUEST_HEADER":
                    return model.AddHttpRequestHeaderRule.getJsonObj(jsonObj, true);
                case "REDIRECT":
                    return model.RedirectRule.getJsonObj(jsonObj, true);
                case "REMOVE_HTTP_REQUEST_HEADER":
                    return model.RemoveHttpRequestHeaderRule.getJsonObj(jsonObj, true);
                case "EXTEND_HTTP_REQUEST_HEADER_VALUE":
                    return model.ExtendHttpRequestHeaderValueRule.getJsonObj(jsonObj, true);
                case "REMOVE_HTTP_RESPONSE_HEADER":
                    return model.RemoveHttpResponseHeaderRule.getJsonObj(jsonObj, true);
                case "CONTROL_ACCESS_USING_HTTP_METHODS":
                    return model.ControlAccessUsingHttpMethodsRule.getJsonObj(jsonObj, true);
                case "ALLOW":
                    return model.AllowRule.getJsonObj(jsonObj, true);
                case "HTTP_HEADER":
                    return model.HttpHeaderRule.getJsonObj(jsonObj, true);
                case "ADD_HTTP_RESPONSE_HEADER":
                    return model.AddHttpResponseHeaderRule.getJsonObj(jsonObj, true);
                case "EXTEND_HTTP_RESPONSE_HEADER_VALUE":
                    return model.ExtendHttpResponseHeaderValueRule.getJsonObj(jsonObj, true);
                default:
                    throw Error("Unknown value for: " + obj.action);
            }
        }
        return jsonObj;
    }
    Rule.getJsonObj = getJsonObj;
})(Rule = exports.Rule || (exports.Rule = {}));
//# sourceMappingURL=rule.js.map