/**
 * Load Balancing API
 * API for the Load Balancing service. Use this API to manage load balancers, backend sets, and related items. For more
information, see [Overview of Load Balancing](/iaas/Content/Balance/Concepts/balanceoverview.htm).

 * OpenAPI spec version: 20170115
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * An access control rule condition that requires a match on the specified source VCN OCID.
 *
 */
export interface SourceVcnIdCondition extends model.RuleCondition {
    /**
      * The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the originating VCN that an incoming packet
  * must match.
  * <p>
  You can use this condition in conjunction with `SourceVcnIpAddressCondition`.
  * <p>
  **NOTE:** If you define this condition for a rule without a `SourceVcnIpAddressCondition`, this condition
  * matches all incoming traffic in the specified VCN.
  *
      */
    "attributeValue": string;
    "attributeName": string;
}
export declare namespace SourceVcnIdCondition {
    function getJsonObj(obj: SourceVcnIdCondition, isParentJsonObj?: boolean): object;
    const attributeName = "SOURCE_VCN_ID";
}
