/**
 * Load Balancing API
 * API for the Load Balancing service. Use this API to manage load balancers, backend sets, and related items. For more
information, see [Overview of Load Balancing](/iaas/Content/Balance/Concepts/balanceoverview.htm).

 * OpenAPI spec version: 20170115
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * An access control rule condition that requires a match on the specified source VCN and IP address range.
 * This condition must be used only in conjunction with `SourceVcnIdCondition`.
 *
 */
export interface SourceVcnIpAddressCondition extends model.RuleCondition {
    /**
      * An IPv4 address range that the original client IP address (in the context of the specified VCN) of an
  * incoming packet must match.
  * <p>
  The service accepts only classless inter-domain routing (CIDR) format (x.x.x.x/y) strings.
  * <p>
  Specify 0.0.0.0/0 to match all incoming traffic in the customer VCN.
  * <p>
  example: \"10.10.1.0/24\"
  *
      */
    "attributeValue": string;
    "attributeName": string;
}
export declare namespace SourceVcnIpAddressCondition {
    function getJsonObj(obj: SourceVcnIpAddressCondition, isParentJsonObj?: boolean): object;
    const attributeName = "SOURCE_VCN_IP_ADDRESS";
}
