/**
 * LogAnalytics API
 * The LogAnalytics API for the LogAnalytics service.

 * OpenAPI spec version: 20200601
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Generic command descriptor defining all attributes common to all querylanguage commands for parse output.
 *
 */
export interface AbstractCommandDescriptor {
    /**
     * Command fragment display string from user specified query string formatted by query builder.
     *
     */
    "displayQueryString": string;
    /**
     * Command fragment internal string from user specified query string formatted by query builder.
     *
     */
    "internalQueryString": string;
    /**
     * querylanguage command designation for example; reporting vs filtering
     *
     */
    "category"?: string;
    /**
     * Fields referenced in command fragment from user specified query string.
     *
     */
    "referencedFields"?: Array<model.AbstractField>;
    /**
     * Fields declared in command fragment from user specified query string.
     *
     */
    "declaredFields"?: Array<model.AbstractField>;
    "name": string;
}
export declare namespace AbstractCommandDescriptor {
    function getJsonObj(obj: AbstractCommandDescriptor): object;
}
