/**
 * LogAnalytics API
 * The LogAnalytics API for the LogAnalytics service.

 * OpenAPI spec version: 20200601
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Command descriptor for querylanguage BUCKET command.
 *
 */
export interface BucketCommandDescriptor extends model.AbstractCommandDescriptor {
    /**
     * number of auto calculated ranges to compute if specified.
     *  Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "maxBuckets"?: number;
    /**
     * Size of each numeric range if specified. Data type should match numeric field data type specified in the query string.
     *  Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "span"?: number;
    /**
     * List of the specified numeric ranges.
     *
     */
    "ranges"?: Array<model.BucketRange>;
    /**
     * Default value to use in place of null if a result does not fit into any of the specified / calculated ranges.
     *
     */
    "defaultValue"?: string;
    "name": string;
}
export declare namespace BucketCommandDescriptor {
    function getJsonObj(obj: BucketCommandDescriptor, isParentJsonObj?: boolean): object;
    const name = "BUCKET";
}
