/**
 * LogAnalytics API
 * The LogAnalytics API for the LogAnalytics service.

 * OpenAPI spec version: 20200601
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * LogAnalyticsConfigWorkRequest
 */
export interface LogAnalyticsConfigWorkRequest {
    /**
     * workrequest id
     */
    "id"?: string;
    /**
     * compartment id
     */
    "compartmentId"?: string;
    /**
     * operation type
     */
    "operationType"?: LogAnalyticsConfigWorkRequest.OperationType;
    /**
     * list of log group summary objects
     */
    "payload"?: Array<model.LogAnalyticsConfigWorkRequestPayload>;
    /**
     * percentage complete Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "percentComplete"?: number;
    /**
     * when the work request was started
     */
    "timeStarted"?: Date;
    /**
     * when the work request was accepted
     */
    "timeAccepted"?: Date;
    /**
     * when the work request finished
     */
    "timeFinished"?: Date;
    /**
     * status
     */
    "lifecycleState"?: LogAnalyticsConfigWorkRequest.LifecycleState;
}
export declare namespace LogAnalyticsConfigWorkRequest {
    enum OperationType {
        CreateAssociations = "CREATE_ASSOCIATIONS",
        DeleteAssociations = "DELETE_ASSOCIATIONS",
        AppendLookupData = "APPEND_LOOKUP_DATA",
        UpdateLookupData = "UPDATE_LOOKUP_DATA",
        DeleteLookup = "DELETE_LOOKUP",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    enum LifecycleState {
        Accepted = "ACCEPTED",
        InProgress = "IN_PROGRESS",
        Succeeded = "SUCCEEDED",
        Failed = "FAILED",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: LogAnalyticsConfigWorkRequest): object;
}
