/**
 * LogAnalytics API
 * The LogAnalytics API for the LogAnalytics service.

 * OpenAPI spec version: 20200601
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * LogAnalytics label
 */
export interface LogAnalyticsLabel {
    /**
     * alias list
     */
    "aliases"?: Array<model.LogAnalyticsLabelAlias>;
    /**
     * count usage in source Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "countUsageInSource"?: number;
    /**
     * suggest type Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "suggestType"?: number;
    /**
     * description
     */
    "description"?: string;
    /**
     * display name
     */
    "displayName"?: string;
    /**
     * edit version Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "editVersion"?: number;
    /**
     * impact
     */
    "impact"?: string;
    /**
     * is system flag
     */
    "isSystem"?: boolean;
    /**
     * label identifier
     */
    "name"?: string;
    /**
     * Valid values are (NONE, LOW, HIGH). NONE is default.
     */
    "priority"?: LogAnalyticsLabel.Priority;
    /**
     * tag recommendation
     */
    "recommendation"?: string;
    /**
     * Valid values are (INFO, PROBLEM). INFO is default.
     */
    "type"?: LogAnalyticsLabel.Type;
    /**
     * user deleted flag
     */
    "isUserDeleted"?: boolean;
}
export declare namespace LogAnalyticsLabel {
    enum Priority {
        None = "NONE",
        Low = "LOW",
        Medium = "MEDIUM",
        High = "HIGH",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    enum Type {
        Info = "INFO",
        Problem = "PROBLEM",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: LogAnalyticsLabel): object;
}
