/**
 * LogAnalytics API
 * The LogAnalytics API for the LogAnalytics service.

 * OpenAPI spec version: 20200601
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * LoganParserDetails
 */
export interface LogAnalyticsParserSummary {
    /**
     * content
     */
    "content"?: string;
    /**
     * description
     */
    "description"?: string;
    /**
     * display name
     */
    "displayName"?: string;
    /**
     * edit version Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "editVersion"?: number;
    /**
     * encoding
     */
    "encoding"?: string;
    /**
     * example content
     */
    "exampleContent"?: string;
    /**
     * fields Maps
     */
    "fieldMaps"?: Array<model.LogAnalyticsParserField>;
    /**
     * footer regular expression
     */
    "footerContent"?: string;
    /**
     * header content
     */
    "headerContent"?: string;
    /**
     * Name
     */
    "name"?: string;
    /**
     * is default flag
     */
    "isDefault"?: boolean;
    /**
     * is single line content
     */
    "isSingleLineContent"?: boolean;
    /**
     * is system flag
     */
    "isSystem"?: boolean;
    /**
     * language
     */
    "language"?: string;
    /**
     * last updated date
     */
    "timeUpdated"?: Date;
    /**
     * log type test request version Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "logTypeTestRequestVersion"?: number;
    /**
     * mapped parser list
     */
    "mappedParsers"?: Array<model.LogAnalyticsParser>;
    /**
     * parser ignore line characters
     */
    "parserIgnorelineCharacters"?: string;
    /**
     * is hidden flag
     */
    "isHidden"?: boolean;
    /**
     * sequence Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "parserSequence"?: number;
    /**
     * time zone
     */
    "parserTimezone"?: string;
    "parserFilter"?: model.LogAnalyticsParserFilter;
    /**
     * write once
     */
    "isParserWrittenOnce"?: boolean;
    /**
     * plugin instance list
     */
    "parserFunctions"?: Array<model.LogAnalyticsParserFunction>;
    /**
     * sources using this parser Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "sourcesCount"?: number;
    /**
     * sources using list
     */
    "sources"?: Array<model.LogAnalyticsSource>;
    /**
     * tokenize original text
     */
    "shouldTokenizeOriginalText"?: boolean;
    /**
     * type
     */
    "type"?: LogAnalyticsParserSummary.Type;
    /**
     * user deleted flag
     */
    "isUserDeleted"?: boolean;
}
export declare namespace LogAnalyticsParserSummary {
    enum Type {
        Xml = "XML",
        Json = "JSON",
        Regex = "REGEX",
        Odl = "ODL",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: LogAnalyticsParserSummary): object;
}
