/**
 * LogAnalytics API
 * The LogAnalytics API for the LogAnalytics service.

 * OpenAPI spec version: 20200601
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * LogAnalyticsSource
 */
export interface LogAnalyticsSource {
    /**
     * alert conditions
     */
    "labelConditions"?: Array<model.LogAnalyticsSourceLabelCondition>;
    /**
     * association count Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "associationCount"?: number;
    /**
     * association entity
     */
    "associationEntity"?: Array<model.LogAnalyticsAssociation>;
    /**
     * data filter definitions
     */
    "dataFilterDefinitions"?: Array<model.LogAnalyticsSourceDataFilter>;
    /**
     * DB credential
     */
    "databaseCredential"?: string;
    /**
     * extended field definition
     */
    "extendedFieldDefinitions"?: Array<model.LogAnalyticsSourceExtendedFieldDefinition>;
    /**
     * is for cloud flag
     */
    "isForCloud"?: boolean;
    /**
     * labels
     */
    "labels"?: Array<model.LogAnalyticsLabelView>;
    /**
     * metric definitions
     */
    "metricDefinitions"?: Array<model.LogAnalyticsMetric>;
    /**
     * metric source map
     */
    "metrics"?: Array<model.LogAnalyticsSourceMetric>;
    /**
     * out-of-the-box source parser list
     */
    "oobParsers"?: Array<model.LogAnalyticsParser>;
    /**
     * parameters
     */
    "parameters"?: Array<model.LogAnalyticsParameter>;
    /**
     * pattern count Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "patternCount"?: number;
    /**
     * patterns
     */
    "patterns"?: Array<model.LogAnalyticsSourcePattern>;
    /**
     * description
     */
    "description"?: string;
    /**
     * display name
     */
    "displayName"?: string;
    /**
     * source edit version Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "editVersion"?: number;
    /**
     * source functions
     */
    "functions"?: Array<model.LogAnalyticsSourceFunction>;
    /**
     * source Id Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "sourceId"?: number;
    /**
     * source internal name
     */
    "name"?: string;
    /**
     * is secure content flag
     */
    "isSecureContent"?: boolean;
    /**
     * is system flag
     */
    "isSystem"?: boolean;
    /**
     * parser list
     */
    "parsers"?: Array<model.LogAnalyticsParser>;
    /**
     * rule auto association enabled flag
     */
    "isAutoAssociationEnabled"?: boolean;
    /**
     * rule auto association override
     */
    "isAutoAssociationOverride"?: boolean;
    /**
     * rule Id Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "ruleId"?: number;
    /**
     * source type internal name
     */
    "typeName"?: string;
    /**
     * source type name
     */
    "typeDisplayName"?: string;
    /**
     * source warning configuration Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "warningConfig"?: number;
    /**
     * source metadata fields
     */
    "metadataFields"?: Array<model.LogAnalyticsSourceMetadataField>;
    /**
     * tags
     */
    "labelDefinitions"?: Array<model.LogAnalyticsLabelDefinition>;
    /**
     * Entity types
     */
    "entityTypes"?: Array<model.LogAnalyticsSourceEntityType>;
    /**
     * time zone override
     */
    "isTimezoneOverride"?: boolean;
    /**
     * source parser list
     */
    "userParsers"?: Array<model.LogAnalyticsParser>;
    /**
     * timeUpdated
     */
    "timeUpdated"?: Date;
    /**
     * An array of event types.
     */
    "eventTypes"?: Array<model.EventType>;
}
export declare namespace LogAnalyticsSource {
    function getJsonObj(obj: LogAnalyticsSource): object;
}
