"use strict";
/**
 * LogAnalytics API
 * The LogAnalytics API for the LogAnalytics service.

 * OpenAPI spec version: 20200601
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.ObjectCollectionRuleCollectionTypes = void 0;
/**
 * The type of Object Collection Rule that needs to be performed with the rule being created.
 * LIVE : Using this type will prompt the process to collect all the logs that gets uploaded to the object store bucket from the time the rule gets registered
 * HISTORIC: This specifies that it is a one off collection request from one time (pollSince) to a second time period (pollTill). In this colletion the pollTill >pollSince
 * HISTORIC_LIVE: This specifies that the collection of objects from the object store bucket needs to be started from a specific time stamp (pollSince) and should collect all the objects that ever gets into this bucket till this rule is configured and active.
 *
 **/
var ObjectCollectionRuleCollectionTypes;
(function (ObjectCollectionRuleCollectionTypes) {
    ObjectCollectionRuleCollectionTypes["Live"] = "LIVE";
    ObjectCollectionRuleCollectionTypes["Historic"] = "HISTORIC";
    ObjectCollectionRuleCollectionTypes["HistoricLive"] = "HISTORIC_LIVE";
    /**
     * This value is used if a service returns a value for this enum that is not recognized by this
     * version of the SDK.
     */
    ObjectCollectionRuleCollectionTypes["UnknownValue"] = "UNKNOWN_VALUE";
})(ObjectCollectionRuleCollectionTypes = exports.ObjectCollectionRuleCollectionTypes || (exports.ObjectCollectionRuleCollectionTypes = {}));
(function (ObjectCollectionRuleCollectionTypes) {
    function getJsonObj(obj) {
        return { obj };
    }
    ObjectCollectionRuleCollectionTypes.getJsonObj = getJsonObj;
})(ObjectCollectionRuleCollectionTypes = exports.ObjectCollectionRuleCollectionTypes || (exports.ObjectCollectionRuleCollectionTypes = {}));
//# sourceMappingURL=object-collection-rule-collection-types.js.map