/**
 * LogAnalytics API
 * The LogAnalytics API for the LogAnalytics service.

 * OpenAPI spec version: 20200601
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Parsed representation of the log file.
 */
export interface ParsedContent {
    /**
     * List of field names.
     */
    "fieldNames"?: Array<string>;
    /**
     * List of field display names.
     */
    "fieldDisplayNames"?: Array<string>;
    /**
     * Parsed field values.
     */
    "parsedFieldValues"?: Array<model.ParsedField>;
    /**
     * Sample log entries picked up from the given file for validation.
     */
    "logContent"?: string;
    /**
     * Sample Size taken for validation. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "sampleSize"?: number;
    /**
     * Match Status.
     */
    "matchStatus"?: string;
}
export declare namespace ParsedContent {
    function getJsonObj(obj: ParsedContent): object;
}
