/**
 *
 *
 * OpenAPI spec version: 20200601
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import common = require("oci-common");
/**
 * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/1.15.1/loganalytics/ListEntitySourceAssociations.ts.html |here} to see how to use ListEntitySourceAssociationsRequest.
 */
export interface ListEntitySourceAssociationsRequest extends common.BaseRequest {
    /**
     * The Logging Analytics namespace used for the request.
     *
     */
    "namespaceName": string;
    /**
     * The ID of the compartment in which to list resources.
     */
    "compartmentId": string;
    /**
     * The entity OCID.
     *
     */
    "entityId"?: string;
    /**
     * entity type name
     */
    "entityType"?: string;
    /**
     * entity type display name
     */
    "entityTypeDisplayName"?: string;
    /**
     * Status
     */
    "lifeCycleState"?: ListEntitySourceAssociationsRequest.LifeCycleState;
    /**
     * is Show Total
     */
    "isShowTotal"?: boolean;
    /**
     * The maximum number of items to return.
     */
    "limit"?: number;
    /**
     * The page token representing the page at which to start retrieving results. This is usually retrieved from a previous list call.
     */
    "page"?: string;
    /**
     * The sort order to use, either ascending (`ASC`) or descending (`DESC`).
     *
     */
    "sortOrder"?: ListEntitySourceAssociationsRequest.SortOrder;
    /**
     * sort by field
     */
    "sortBy"?: ListEntitySourceAssociationsRequest.SortBy;
    /**
     * The client request ID for tracing.
     */
    "opcRequestId"?: string;
}
export declare namespace ListEntitySourceAssociationsRequest {
    enum LifeCycleState {
        All = "ALL",
        Accepted = "ACCEPTED",
        InProgress = "IN_PROGRESS",
        Succeeded = "SUCCEEDED",
        Failed = "FAILED"
    }
    enum SortOrder {
        Asc = "ASC",
        Desc = "DESC"
    }
    enum SortBy {
        SourceDisplayName = "sourceDisplayName",
        TimeLastAttempted = "timeLastAttempted",
        Status = "status"
    }
}
