/**
 *
 *
 * OpenAPI spec version: 20200601
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import common = require("oci-common");
/**
 * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/1.15.1/loganalytics/ListFields.ts.html |here} to see how to use ListFieldsRequest.
 */
export interface ListFieldsRequest extends common.BaseRequest {
    /**
     * The Logging Analytics namespace used for the request.
     *
     */
    "namespaceName": string;
    /**
     * isMatchAll
     */
    "isMatchAll"?: boolean;
    /**
     * comma delimited list of source ids
     */
    "sourceIds"?: string;
    /**
     * comma delimited list of source Names
     */
    "sourceNames"?: string;
    /**
     * parserType
     */
    "parserType"?: ListFieldsRequest.ParserType;
    /**
     * comma delimited list of parser ids
     */
    "parserIds"?: string;
    /**
     * comma delimited list of parser names
     */
    "parserNames"?: string;
    /**
     * isIncludeParser
     */
    "isIncludeParser"?: boolean;
    /**
     * filter
     */
    "filter"?: string;
    /**
     * The maximum number of items to return.
     */
    "limit"?: number;
    /**
     * The page token representing the page at which to start retrieving results. This is usually retrieved from a previous list call.
     */
    "page"?: string;
    /**
     * The sort order to use, either ascending (`ASC`) or descending (`DESC`).
     *
     */
    "sortOrder"?: ListFieldsRequest.SortOrder;
    /**
     * sort by field
     */
    "sortBy"?: ListFieldsRequest.SortBy;
    /**
     * The client request ID for tracing.
     */
    "opcRequestId"?: string;
}
export declare namespace ListFieldsRequest {
    enum ParserType {
        All = "ALL",
        Regex = "REGEX",
        Xml = "XML",
        Json = "JSON"
    }
    enum SortOrder {
        Asc = "ASC",
        Desc = "DESC"
    }
    enum SortBy {
        Name = "name",
        DataType = "dataType"
    }
}
