/**
 *
 *
 * OpenAPI spec version: 20200601
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import common = require("oci-common");
/**
 * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/1.15.1/loganalytics/ListLabels.ts.html |here} to see how to use ListLabelsRequest.
 */
export interface ListLabelsRequest extends common.BaseRequest {
    /**
     * The Logging Analytics namespace used for the request.
     *
     */
    "namespaceName": string;
    /**
     * label name
     */
    "labelName"?: string;
    /**
     * search by label display name or description
     */
    "labelDisplayText"?: string;
    /**
     * Is system param of value (all, custom, sourceUsing)
     *
     */
    "isSystem"?: ListLabelsRequest.IsSystem;
    /**
     * label priority
     */
    "labelPriority"?: ListLabelsRequest.LabelPriority;
    /**
     * isCountPop
     */
    "isCountPop"?: boolean;
    /**
     * isAliasPop
     */
    "isAliasPop"?: boolean;
    /**
     * The maximum number of items to return.
     */
    "limit"?: number;
    /**
     * The page token representing the page at which to start retrieving results. This is usually retrieved from a previous list call.
     */
    "page"?: string;
    /**
     * The sort order to use, either ascending (`ASC`) or descending (`DESC`).
     *
     */
    "sortOrder"?: ListLabelsRequest.SortOrder;
    /**
     * sort by label
     */
    "labelSortBy"?: ListLabelsRequest.LabelSortBy;
    /**
     * The client request ID for tracing.
     */
    "opcRequestId"?: string;
}
export declare namespace ListLabelsRequest {
    enum IsSystem {
        All = "ALL",
        Custom = "CUSTOM",
        BuiltIn = "BUILT_IN"
    }
    enum LabelPriority {
        None = "NONE",
        Low = "LOW",
        Medium = "MEDIUM",
        High = "HIGH"
    }
    enum SortOrder {
        Asc = "ASC",
        Desc = "DESC"
    }
    enum LabelSortBy {
        Name = "name",
        Priority = "priority",
        SourceUsing = "sourceUsing"
    }
}
