/**
 *
 *
 * OpenAPI spec version: 20200601
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import common = require("oci-common");
/**
 * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/1.15.1/loganalytics/ListParsers.ts.html |here} to see how to use ListParsersRequest.
 */
export interface ListParsersRequest extends common.BaseRequest {
    /**
     * The Logging Analytics namespace used for the request.
     *
     */
    "namespaceName": string;
    /**
     * isMatchAll
     */
    "isMatchAll"?: boolean;
    /**
     * source type
     */
    "sourceType"?: ListParsersRequest.SourceType;
    /**
     * parserName
     */
    "parserName"?: string;
    /**
     * search by parser display name or description
     */
    "parserDisplayText"?: string;
    /**
     * parserType
     */
    "parserType"?: ListParsersRequest.ParserType;
    /**
     * Is system param of value (all, custom, sourceUsing)
     *
     */
    "isSystem"?: ListParsersRequest.IsSystem;
    /**
     * The maximum number of items to return.
     */
    "limit"?: number;
    /**
     * The page token representing the page at which to start retrieving results. This is usually retrieved from a previous list call.
     */
    "page"?: string;
    /**
     * The sort order to use, either ascending (`ASC`) or descending (`DESC`).
     *
     */
    "sortOrder"?: ListParsersRequest.SortOrder;
    /**
     * sort by parser
     */
    "sortBy"?: ListParsersRequest.SortBy;
    /**
     * The client request ID for tracing.
     */
    "opcRequestId"?: string;
}
export declare namespace ListParsersRequest {
    enum SourceType {
        OsFile = "OS_FILE",
        Syslog = "SYSLOG",
        Odl = "ODL",
        OsWindowsSys = "OS_WINDOWS_SYS"
    }
    enum ParserType {
        All = "ALL",
        Regex = "REGEX",
        Xml = "XML",
        Json = "JSON"
    }
    enum IsSystem {
        All = "ALL",
        Custom = "CUSTOM",
        BuiltIn = "BUILT_IN"
    }
    enum SortOrder {
        Asc = "ASC",
        Desc = "DESC"
    }
    enum SortBy {
        Name = "name",
        Type = "type",
        SourcesCount = "sourcesCount",
        TimeUpdated = "timeUpdated"
    }
}
