/**
 *
 *
 * OpenAPI spec version: 20200601
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import common = require("oci-common");
/**
 * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/1.15.1/loganalytics/ListRecalledData.ts.html |here} to see how to use ListRecalledDataRequest.
 */
export interface ListRecalledDataRequest extends common.BaseRequest {
    /**
     * The Logging Analytics namespace used for the request.
     *
     */
    "namespaceName": string;
    /**
     * The client request ID for tracing.
     */
    "opcRequestId"?: string;
    /**
     * The maximum number of items to return.
     */
    "limit"?: number;
    /**
     * The page token representing the page at which to start retrieving results. This is usually retrieved from a previous list call.
     */
    "page"?: string;
    /**
     * This is the query parameter of which field to sort by. Only one sort order may be provided. Default order for timeDataStarted
     * is descending. If no value is specified timeDataStarted is default.
     *
     */
    "sortBy"?: ListRecalledDataRequest.SortBy;
    /**
     * The sort order to use, either ascending (`ASC`) or descending (`DESC`).
     *
     */
    "sortOrder"?: ListRecalledDataRequest.SortOrder;
    /**
     * This is the start of the time range for recalled data
     */
    "timeDataStartedGreaterThanOrEqual"?: Date;
    /**
     * This is the end of the time range for recalled data
     */
    "timeDataEndedLessThan"?: Date;
}
export declare namespace ListRecalledDataRequest {
    enum SortBy {
        TimeStarted = "timeStarted",
        TimeDataStarted = "timeDataStarted"
    }
    enum SortOrder {
        Asc = "ASC",
        Desc = "DESC"
    }
}
