/**
 * Logging Management API
 * Use the Logging Management API to create, read, list, update, and delete log groups, log objects, and agent configurations.
 * OpenAPI spec version: 20200531
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * grok pattern object.
 */
export interface GrokPattern {
    /**
     * The grok pattern.
     */
    "pattern": string;
    /**
     * The name key to tag this grok pattern.
     */
    "name"?: string;
    /**
     * Specify the time field for the event time. If the event doesn't have this field, the current time is used.
     */
    "fieldTimeKey"?: string;
    /**
     * Process value using the specified format. This is available only when time_type is a string.
     */
    "fieldTimeFormat"?: string;
    /**
     * Use the specified time zone. The time value can be parsed or formatted in the specified time zone.
     */
    "fieldTimeZone"?: string;
}
export declare namespace GrokPattern {
    function getJsonObj(obj: GrokPattern): object;
}
