"use strict";
/**
 * Logging Management API
 * Use the Logging Management API to create, read, list, update, and delete log groups, log objects, and agent configurations.
 * OpenAPI spec version: 20200531
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogGroupLifecycleState = void 0;
/**
 * The log group object state. The states workflow is:
 *    1. *CREATING* Log group is being created, backend service contacted.
 *    2. *ACTIVE* Log group is active.
 *    3. *UPDATING* Object configuration change requested, but the backend service has not confirmed the update.
 *    4. *INACTIVE* Log group is disabled.
 *    5. *DELETING* Log group is being deleted.
 *
 **/
var LogGroupLifecycleState;
(function (LogGroupLifecycleState) {
    LogGroupLifecycleState["Creating"] = "CREATING";
    LogGroupLifecycleState["Active"] = "ACTIVE";
    LogGroupLifecycleState["Updating"] = "UPDATING";
    LogGroupLifecycleState["Inactive"] = "INACTIVE";
    LogGroupLifecycleState["Deleting"] = "DELETING";
    LogGroupLifecycleState["Failed"] = "FAILED";
    /**
     * This value is used if a service returns a value for this enum that is not recognized by this
     * version of the SDK.
     */
    LogGroupLifecycleState["UnknownValue"] = "UNKNOWN_VALUE";
})(LogGroupLifecycleState = exports.LogGroupLifecycleState || (exports.LogGroupLifecycleState = {}));
(function (LogGroupLifecycleState) {
    function getJsonObj(obj) {
        return { obj };
    }
    LogGroupLifecycleState.getJsonObj = getJsonObj;
})(LogGroupLifecycleState = exports.LogGroupLifecycleState || (exports.LogGroupLifecycleState = {}));
//# sourceMappingURL=log-group-lifecycle-state.js.map