/**
 * Logging Management API
 * Use the Logging Management API to create, read, list, update, and delete log groups, log objects, and agent configurations.
 * OpenAPI spec version: 20200531
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Summary of services that are integrated with public logging.
 */
export interface ServiceSummary {
    /**
     * Tenant OCID.
     */
    "tenantId": string;
    /**
     * Apollo project namespace, if any.
     */
    "namespace"?: string;
    /**
     * Service ID as set in Service Principal.
     */
    "servicePrincipalName": string;
    /**
     * Service endpoint.
     */
    "endpoint": string;
    /**
     * User-friendly service name.
     */
    "name": string;
    /**
     * Service ID.
     */
    "id"?: string;
    /**
     * Type of resource that a service provides.
     */
    "resourceTypes": Array<model.ResourceType>;
}
export declare namespace ServiceSummary {
    function getJsonObj(obj: ServiceSummary): object;
}
