/**
 *
 *
 * OpenAPI spec version: 20200202
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
import common = require("oci-common");
/**
 * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/1.15.1/managementagent/ListManagementAgentImages.ts.html |here} to see how to use ListManagementAgentImagesRequest.
 */
export interface ListManagementAgentImagesRequest extends common.BaseRequest {
    /**
     * The ID of the compartment from which the Management Agents to be listed.
     */
    "compartmentId": string;
    /**
     * A token that uniquely identifies a request so it can be retried in case of a timeout or
     * server error without risk of executing that same action again. Retry tokens expire after 24
     * hours, but can be invalidated before then due to conflicting operations. For example, if a resource
     * has been deleted and purged from the system, then a retry of the original creation request
     * might be rejected.
     *
     */
    "opcRetryToken"?: string;
    /**
     * The client request ID for tracing.
     */
    "opcRequestId"?: string;
    /**
     * The maximum number of items to return.
     */
    "limit"?: number;
    /**
     * The page token representing the page at which to start retrieving results. This is usually retrieved from a previous list call.
     */
    "page"?: string;
    /**
     * The sort order to use, either 'asc' or 'desc'.
     */
    "sortOrder"?: ListManagementAgentImagesRequest.SortOrder;
    /**
     * The field to sort by. Only one sort order may be provided. Default order for platformType is descending. Default order for version is descending. If no value is specified platformType is default.
     *
     */
    "sortBy"?: ListManagementAgentImagesRequest.SortBy;
    /**
     * A filter to return only resources that match the entire platform name given.
     */
    "name"?: string;
    /**
     * Filter to return only Management Agents in the particular lifecycle state.
     */
    "lifecycleState"?: model.LifecycleStates;
}
export declare namespace ListManagementAgentImagesRequest {
    enum SortOrder {
        Asc = "ASC",
        Desc = "DESC"
    }
    enum SortBy {
        PlatformType = "platformType",
        Version = "version"
    }
}
