/**
 *
 *
 * OpenAPI spec version: 20200202
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
import common = require("oci-common");
/**
 * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/1.15.1/managementagent/ListManagementAgentInstallKeys.ts.html |here} to see how to use ListManagementAgentInstallKeysRequest.
 */
export interface ListManagementAgentInstallKeysRequest extends common.BaseRequest {
    /**
     * The ID of the compartment from which the Management Agents to be listed.
     */
    "compartmentId": string;
    /**
     * if set to true then it fetches install key for all compartments where user has access to else only on the compartment specified.
     */
    "compartmentIdInSubtree"?: boolean;
    /**
     * Value of this is always \"ACCESSIBLE\" and any other value is not supported.
     */
    "accessLevel"?: string;
    /**
     * Filter to return only Management Agents in the particular lifecycle state.
     */
    "lifecycleState"?: model.LifecycleStates;
    /**
     * The display name for which the Key needs to be listed.
     */
    "displayName"?: string;
    /**
     * The page token representing the page at which to start retrieving results. This is usually retrieved from a previous list call.
     */
    "page"?: string;
    /**
     * The sort order to use, either 'asc' or 'desc'.
     */
    "sortOrder"?: ListManagementAgentInstallKeysRequest.SortOrder;
    /**
     * The field to sort by. Only one sort order may be provided. Default order for timeCreated is descending. Default order for displayName is ascending. If no value is specified timeCreated is default.
     *
     */
    "sortBy"?: ListManagementAgentInstallKeysRequest.SortBy;
    /**
     * The client request ID for tracing.
     */
    "opcRequestId"?: string;
}
export declare namespace ListManagementAgentInstallKeysRequest {
    enum SortOrder {
        Asc = "ASC",
        Desc = "DESC"
    }
    enum SortBy {
        TimeCreated = "timeCreated",
        DisplayName = "displayName"
    }
}
