/**
 * ManagementDashboard API
 * API for the Management Dashboard micro-service. Use this API for dashboard and saved search metadata preservation and to perform  tasks such as creating a dashboard, creating a saved search, and obtaining a list of dashboards and saved searches in a compartment.
    

 * OpenAPI spec version: 20200901
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Properties of the dashboard tile representing a saved search.
 * Tiles are laid out in a twelve column grid system with (0,0) at upper left corner.
 *
 */
export interface ManagementDashboardTileDetails {
    /**
     * Display name of the saved search.
     */
    "displayName": string;
    /**
     * ID of the saved search.
     */
    "savedSearchId": string;
    /**
     * Tile's row number. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "row": number;
    /**
     * Tile's column number. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "column": number;
    /**
     * The number of rows the tile occupies. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "height": number;
    /**
     * The number of columns the tile occupies. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "width": number;
    /**
     * JSON that contains internationalization options.
     */
    "nls": any;
    /**
     * JSON that contains user interface options.
     */
    "uiConfig": any;
    /**
     * Array of JSON that contain data source options.
     */
    "dataConfig": Array<any>;
    /**
     * Current state of the saved search.
     */
    "state": ManagementDashboardTileDetails.State;
    /**
     * Drill-down configuration to define the destination of a drill-down action.
     */
    "drilldownConfig": any;
}
export declare namespace ManagementDashboardTileDetails {
    enum State {
        Deleted = "DELETED",
        Unauthorized = "UNAUTHORIZED",
        Default = "DEFAULT",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: ManagementDashboardTileDetails): object;
}
