/**
 * Marketplace Service API
 * Manage applications in Oracle Cloud Infrastructure Marketplace.
 * OpenAPI spec version: 20181001
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * The model for an end user license agreement.
 */
export interface Agreement {
    /**
     * The unique identifier for the agreement.
     */
    "id": string;
    /**
     * The content URL of the agreement.
     */
    "contentUrl": string;
    /**
     * A time-based signature that can be used to accept an agreement or remove a
     * previously accepted agreement from the list that Marketplace checks before a deployment.
     *
     */
    "signature": string;
    /**
     * The unique identifier for the compartment.
     */
    "compartmentId"?: string;
    /**
     * Who authored the agreement.
     */
    "author"?: Agreement.Author;
    /**
     * Textual prompt to read and accept the agreement.
     */
    "prompt"?: string;
}
export declare namespace Agreement {
    enum Author {
        Oracle = "ORACLE",
        Partner = "PARTNER",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: Agreement): object;
}
