/**
 * Marketplace Service API
 * Manage applications in Oracle Cloud Infrastructure Marketplace.
 * OpenAPI spec version: 20181001
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * A package for image listings.
 */
export interface ImageListingPackage extends model.ListingPackage {
    /**
     * The ID of the listing resource associated with this listing package. For more information, see [AppCatalogListing](https://docs.cloud.oracle.com/en-us/iaas/api/#/en/iaas/latest/AppCatalogListing/) in the Core Services API.
     *
     */
    "appCatalogListingId"?: string;
    /**
     * The resource version of the listing resource associated with this listing package.
     */
    "appCatalogListingResourceVersion"?: string;
    /**
     * The ID of the image corresponding to the package.
     */
    "imageId"?: string;
    /**
     * The regions where you can deploy the listing package. (Some packages have restrictions that limit their deployment to United States regions only.)
     *
     */
    "regions"?: Array<model.Region>;
    "packageType": string;
}
export declare namespace ImageListingPackage {
    function getJsonObj(obj: ImageListingPackage, isParentJsonObj?: boolean): object;
    const packageType = "IMAGE";
}
