/**
 * Marketplace Service API
 * Manage applications in Oracle Cloud Infrastructure Marketplace.
 * OpenAPI spec version: 20181001
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The model of a variable for an orchestration resource.
 */
export interface OrchestrationVariable {
    /**
     * The name of the variable.
     */
    "name"?: string;
    /**
     * The variable's default value.
     */
    "defaultValue"?: string;
    /**
     * A description of the variable.
     */
    "description"?: string;
    /**
     * The data type of the variable.
     */
    "dataType"?: model.OrchestrationVariableTypeEnum;
    /**
     * Whether the variable is mandatory.
     */
    "isMandatory"?: boolean;
    /**
     * A brief textual description that helps to explain the variable.
     */
    "hintMessage"?: string;
}
export declare namespace OrchestrationVariable {
    function getJsonObj(obj: OrchestrationVariable): object;
}
