/**
 * Marketplace Service API
 * Manage applications in Oracle Cloud Infrastructure Marketplace.
 * OpenAPI spec version: 20181001
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The model for a publisher.
 */
export interface Publisher {
    /**
     * Unique identifier for the publisher.
     */
    "id"?: string;
    /**
     * The name of the publisher.
     */
    "name"?: string;
    /**
     * A description of the publisher.
     */
    "description"?: string;
    /**
     * The year the publisher's company or organization was founded. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "yearFounded"?: number;
    /**
     * The publisher's website.
     */
    "websiteUrl"?: string;
    /**
     * The email address of the publisher.
     */
    "contactEmail"?: string;
    /**
     * The phone number of the publisher.
     */
    "contactPhone"?: string;
    /**
     * The address of the publisher's headquarters.
     */
    "hqAddress"?: string;
    "logo"?: model.UploadData;
    /**
     * Reference links.
     */
    "links"?: Array<model.Link>;
}
export declare namespace Publisher {
    function getJsonObj(obj: Publisher): object;
}
