/**
 * MySQL Database Service API
 * The API for the MySQL Database Service
 * OpenAPI spec version: 20190415
 * Contact: mysql-cloud-dev_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Parameters detailing how to provision the source endpoint that is a MySQL Server.
 * Typically a MySQL Server that is not managed by the MySQL Database Service.
 *
 */
export interface UpdateChannelSourceFromMysqlDetails extends model.UpdateChannelSourceDetails {
    /**
     * The network address of the MySQL instance.
     */
    "hostname"?: string;
    /**
     * The port the source MySQL instance listens on. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "port"?: number;
    /**
     * The name of the replication user on the source MySQL instance.
     * The username has a maximum length of 96 characters. For more information,
     * please see the [MySQL documentation](https://dev.mysql.com/doc/refman/8.0/en/change-master-to.html)
     *
     */
    "username"?: string;
    /**
     * The password for the replication user. The password must be
     * between 8 and 32 characters long, and must contain at least 1
     * numeric character, 1 lowercase character, 1 uppercase character,
     * and 1 special (nonalphanumeric) character.
     *
     */
    "password"?: string;
    /**
     * The SSL mode of the Channel.
     */
    "sslMode"?: string;
    "sslCaCertificate"?: model.PemCaCertificate;
    "sourceType": string;
}
export declare namespace UpdateChannelSourceFromMysqlDetails {
    function getJsonObj(obj: UpdateChannelSourceFromMysqlDetails, isParentJsonObj?: boolean): object;
    const sourceType = "MYSQL";
}
