/**
 * Object Storage Service API
 * Common set of Object Storage and Archive Storage APIs for managing buckets, objects, and related resources.
For more information, see [Overview of Object Storage](/Content/Object/Concepts/objectstorageoverview.htm) and
[Overview of Archive Storage](/Content/Archive/Concepts/archivestorageoverview.htm).

 * OpenAPI spec version: 20160918
 * Contact: opc_casper_users_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * The details of a replication source bucket that replicates to a target destination bucket.
 */
export interface ReplicationSource {
    /**
     * The name of the policy.
     */
    "policyName": string;
    /**
     * The source region replicating data from, for example \"us-ashburn-1\".
     */
    "sourceRegionName": string;
    /**
     * The source bucket replicating data from.
     */
    "sourceBucketName": string;
}
export declare namespace ReplicationSource {
    function getJsonObj(obj: ReplicationSource): object;
}
