/**
 *
 *
 * OpenAPI spec version: 20160918
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
export interface DeleteObjectResponse {
    /**
     * Echoes back the value passed in the opc-client-request-id header, for use by clients when debugging.
     */
    "opcClientRequestId": string;
    /**
     * Unique Oracle-assigned identifier for the request. If you need to contact Oracle about a particular
     * request, provide this request ID.
     *
     */
    "opcRequestId": string;
    /**
     * The time the object was deleted, as described in [RFC 2616](https://tools.ietf.org/html/rfc2616#section-14.29).
     */
    "lastModified": Date;
    /**
     * The `versionId` of the delete marker created as a result of the DELETE Object.
     * If the request contains a specific `versionId`, then this response header will be the same as the requested `versionId` of the object that was deleted.
     *
     */
    "versionId": string;
    /**
     * This is `true` if the deleted object is a delete marker, otherwise `false`
     *
     */
    "isDeleteMarker": boolean;
}
