/**
 * Object Storage Service API
 * Common set of Object Storage and Archive Storage APIs for managing buckets, objects, and related resources.
For more information, see [Overview of Object Storage](/Content/Object/Concepts/objectstorageoverview.htm) and
[Overview of Archive Storage](/Content/Archive/Concepts/archivestorageoverview.htm).

 * OpenAPI spec version: 20160918
 * Contact: opc_casper_users_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as AbortMultipartUploadResponse from "./abort-multipart-upload-response";
export import AbortMultipartUploadResponse = AbortMultipartUploadResponse.AbortMultipartUploadResponse;
import * as CancelWorkRequestResponse from "./cancel-work-request-response";
export import CancelWorkRequestResponse = CancelWorkRequestResponse.CancelWorkRequestResponse;
import * as CommitMultipartUploadResponse from "./commit-multipart-upload-response";
export import CommitMultipartUploadResponse = CommitMultipartUploadResponse.CommitMultipartUploadResponse;
import * as CopyObjectResponse from "./copy-object-response";
export import CopyObjectResponse = CopyObjectResponse.CopyObjectResponse;
import * as CreateBucketResponse from "./create-bucket-response";
export import CreateBucketResponse = CreateBucketResponse.CreateBucketResponse;
import * as CreateMultipartUploadResponse from "./create-multipart-upload-response";
export import CreateMultipartUploadResponse = CreateMultipartUploadResponse.CreateMultipartUploadResponse;
import * as CreatePreauthenticatedRequestResponse from "./create-preauthenticated-request-response";
export import CreatePreauthenticatedRequestResponse = CreatePreauthenticatedRequestResponse.CreatePreauthenticatedRequestResponse;
import * as CreateReplicationPolicyResponse from "./create-replication-policy-response";
export import CreateReplicationPolicyResponse = CreateReplicationPolicyResponse.CreateReplicationPolicyResponse;
import * as CreateRetentionRuleResponse from "./create-retention-rule-response";
export import CreateRetentionRuleResponse = CreateRetentionRuleResponse.CreateRetentionRuleResponse;
import * as DeleteBucketResponse from "./delete-bucket-response";
export import DeleteBucketResponse = DeleteBucketResponse.DeleteBucketResponse;
import * as DeleteObjectResponse from "./delete-object-response";
export import DeleteObjectResponse = DeleteObjectResponse.DeleteObjectResponse;
import * as DeleteObjectLifecyclePolicyResponse from "./delete-object-lifecycle-policy-response";
export import DeleteObjectLifecyclePolicyResponse = DeleteObjectLifecyclePolicyResponse.DeleteObjectLifecyclePolicyResponse;
import * as DeletePreauthenticatedRequestResponse from "./delete-preauthenticated-request-response";
export import DeletePreauthenticatedRequestResponse = DeletePreauthenticatedRequestResponse.DeletePreauthenticatedRequestResponse;
import * as DeleteReplicationPolicyResponse from "./delete-replication-policy-response";
export import DeleteReplicationPolicyResponse = DeleteReplicationPolicyResponse.DeleteReplicationPolicyResponse;
import * as DeleteRetentionRuleResponse from "./delete-retention-rule-response";
export import DeleteRetentionRuleResponse = DeleteRetentionRuleResponse.DeleteRetentionRuleResponse;
import * as GetBucketResponse from "./get-bucket-response";
export import GetBucketResponse = GetBucketResponse.GetBucketResponse;
import * as GetNamespaceResponse from "./get-namespace-response";
export import GetNamespaceResponse = GetNamespaceResponse.GetNamespaceResponse;
import * as GetNamespaceMetadataResponse from "./get-namespace-metadata-response";
export import GetNamespaceMetadataResponse = GetNamespaceMetadataResponse.GetNamespaceMetadataResponse;
import * as GetObjectResponse from "./get-object-response";
export import GetObjectResponse = GetObjectResponse.GetObjectResponse;
import * as GetObjectLifecyclePolicyResponse from "./get-object-lifecycle-policy-response";
export import GetObjectLifecyclePolicyResponse = GetObjectLifecyclePolicyResponse.GetObjectLifecyclePolicyResponse;
import * as GetPreauthenticatedRequestResponse from "./get-preauthenticated-request-response";
export import GetPreauthenticatedRequestResponse = GetPreauthenticatedRequestResponse.GetPreauthenticatedRequestResponse;
import * as GetReplicationPolicyResponse from "./get-replication-policy-response";
export import GetReplicationPolicyResponse = GetReplicationPolicyResponse.GetReplicationPolicyResponse;
import * as GetRetentionRuleResponse from "./get-retention-rule-response";
export import GetRetentionRuleResponse = GetRetentionRuleResponse.GetRetentionRuleResponse;
import * as GetWorkRequestResponse from "./get-work-request-response";
export import GetWorkRequestResponse = GetWorkRequestResponse.GetWorkRequestResponse;
import * as HeadBucketResponse from "./head-bucket-response";
export import HeadBucketResponse = HeadBucketResponse.HeadBucketResponse;
import * as HeadObjectResponse from "./head-object-response";
export import HeadObjectResponse = HeadObjectResponse.HeadObjectResponse;
import * as ListBucketsResponse from "./list-buckets-response";
export import ListBucketsResponse = ListBucketsResponse.ListBucketsResponse;
import * as ListMultipartUploadPartsResponse from "./list-multipart-upload-parts-response";
export import ListMultipartUploadPartsResponse = ListMultipartUploadPartsResponse.ListMultipartUploadPartsResponse;
import * as ListMultipartUploadsResponse from "./list-multipart-uploads-response";
export import ListMultipartUploadsResponse = ListMultipartUploadsResponse.ListMultipartUploadsResponse;
import * as ListObjectVersionsResponse from "./list-object-versions-response";
export import ListObjectVersionsResponse = ListObjectVersionsResponse.ListObjectVersionsResponse;
import * as ListObjectsResponse from "./list-objects-response";
export import ListObjectsResponse = ListObjectsResponse.ListObjectsResponse;
import * as ListPreauthenticatedRequestsResponse from "./list-preauthenticated-requests-response";
export import ListPreauthenticatedRequestsResponse = ListPreauthenticatedRequestsResponse.ListPreauthenticatedRequestsResponse;
import * as ListReplicationPoliciesResponse from "./list-replication-policies-response";
export import ListReplicationPoliciesResponse = ListReplicationPoliciesResponse.ListReplicationPoliciesResponse;
import * as ListReplicationSourcesResponse from "./list-replication-sources-response";
export import ListReplicationSourcesResponse = ListReplicationSourcesResponse.ListReplicationSourcesResponse;
import * as ListRetentionRulesResponse from "./list-retention-rules-response";
export import ListRetentionRulesResponse = ListRetentionRulesResponse.ListRetentionRulesResponse;
import * as ListWorkRequestErrorsResponse from "./list-work-request-errors-response";
export import ListWorkRequestErrorsResponse = ListWorkRequestErrorsResponse.ListWorkRequestErrorsResponse;
import * as ListWorkRequestLogsResponse from "./list-work-request-logs-response";
export import ListWorkRequestLogsResponse = ListWorkRequestLogsResponse.ListWorkRequestLogsResponse;
import * as ListWorkRequestsResponse from "./list-work-requests-response";
export import ListWorkRequestsResponse = ListWorkRequestsResponse.ListWorkRequestsResponse;
import * as MakeBucketWritableResponse from "./make-bucket-writable-response";
export import MakeBucketWritableResponse = MakeBucketWritableResponse.MakeBucketWritableResponse;
import * as PutObjectResponse from "./put-object-response";
export import PutObjectResponse = PutObjectResponse.PutObjectResponse;
import * as PutObjectLifecyclePolicyResponse from "./put-object-lifecycle-policy-response";
export import PutObjectLifecyclePolicyResponse = PutObjectLifecyclePolicyResponse.PutObjectLifecyclePolicyResponse;
import * as ReencryptBucketResponse from "./reencrypt-bucket-response";
export import ReencryptBucketResponse = ReencryptBucketResponse.ReencryptBucketResponse;
import * as ReencryptObjectResponse from "./reencrypt-object-response";
export import ReencryptObjectResponse = ReencryptObjectResponse.ReencryptObjectResponse;
import * as RenameObjectResponse from "./rename-object-response";
export import RenameObjectResponse = RenameObjectResponse.RenameObjectResponse;
import * as RestoreObjectsResponse from "./restore-objects-response";
export import RestoreObjectsResponse = RestoreObjectsResponse.RestoreObjectsResponse;
import * as UpdateBucketResponse from "./update-bucket-response";
export import UpdateBucketResponse = UpdateBucketResponse.UpdateBucketResponse;
import * as UpdateNamespaceMetadataResponse from "./update-namespace-metadata-response";
export import UpdateNamespaceMetadataResponse = UpdateNamespaceMetadataResponse.UpdateNamespaceMetadataResponse;
import * as UpdateObjectStorageTierResponse from "./update-object-storage-tier-response";
export import UpdateObjectStorageTierResponse = UpdateObjectStorageTierResponse.UpdateObjectStorageTierResponse;
import * as UpdateRetentionRuleResponse from "./update-retention-rule-response";
export import UpdateRetentionRuleResponse = UpdateRetentionRuleResponse.UpdateRetentionRuleResponse;
import * as UploadPartResponse from "./upload-part-response";
export import UploadPartResponse = UploadPartResponse.UploadPartResponse;
