/**
 * Oracle Cloud VMware Solution API
 * Use this API to manage the Oracle Cloud VMware Solution.

 * OpenAPI spec version: 20200501
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * A resource that is created or operated on by an asynchronous operation that is
 * tracked by a work request.
 *
 */
export interface WorkRequestResource {
    /**
     * The resource type the work request affects.
     */
    "entityType": string;
    /**
     * The way in which this resource was affected by the operation that spawned the
     * work request.
     *
     */
    "actionType": model.ActionTypes;
    /**
     * An [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) or other unique identifier
     * for the resource.
     *
     */
    "identifier": string;
    /**
     * The URI path that you can use for a GET request to access the resource metadata.
     *
     */
    "entityUri"?: string;
}
export declare namespace WorkRequestResource {
    function getJsonObj(obj: WorkRequestResource): object;
}
