/**
 *
 *
 * OpenAPI spec version: 20181201
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import common = require("oci-common");
/**
 * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/1.15.1/ons/GetConfirmSubscription.ts.html |here} to see how to use GetConfirmSubscriptionRequest.
 */
export interface GetConfirmSubscriptionRequest extends common.BaseRequest {
    /**
     * The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the subscription to get the confirmation details for.
     *
     */
    "id": string;
    /**
     * The subscription confirmation token.
     */
    "token": string;
    /**
   * The protocol used for the subscription.
  * <p>
  Allowed values:
  *   * `CUSTOM_HTTPS`
  *   * `EMAIL`
  *   * `HTTPS` (deprecated; for PagerDuty endpoints, use `PAGERDUTY`)
  *   * `PAGERDUTY`
  *   * `SLACK`
  *   * `ORACLE_FUNCTIONS`
  * <p>
  For information about subscription protocols, see
  * [To create a subscription](https://docs.cloud.oracle.com/iaas/Content/Notification/Tasks/managingtopicsandsubscriptions.htm#createSub).
  *
   */
    "protocol": string;
    /**
     * The unique Oracle-assigned identifier for the request. If you need to contact Oracle about a
     * particular request, please provide the request ID.
     *
     */
    "opcRequestId"?: string;
}
