/**
 * Operations Insights API
 * Use the Operations Insights API to perform data extraction operations to obtain database
resource utilization, performance statistics, and reference information. For more information,
see [About Oracle Cloud Infrastructure Operations Insights](https://docs.cloud.oracle.com/en-us/iaas/operations-insights/doc/operations-insights.html).

 * OpenAPI spec version: 20200630
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as DatabaseDetails from "./database-details";
export import DatabaseDetails = DatabaseDetails.DatabaseDetails;
import * as DatabaseInsightSummary from "./database-insight-summary";
export import DatabaseInsightSummary = DatabaseInsightSummary.DatabaseInsightSummary;
import * as DatabaseInsights from "./database-insights";
export import DatabaseInsights = DatabaseInsights.DatabaseInsights;
import * as DatabaseInsightsCollection from "./database-insights-collection";
export import DatabaseInsightsCollection = DatabaseInsightsCollection.DatabaseInsightsCollection;
import * as HistoricalDataItem from "./historical-data-item";
export import HistoricalDataItem = HistoricalDataItem.HistoricalDataItem;
import * as IngestSqlBucketDetails from "./ingest-sql-bucket-details";
export import IngestSqlBucketDetails = IngestSqlBucketDetails.IngestSqlBucketDetails;
import * as IngestSqlBucketResponseDetails from "./ingest-sql-bucket-response-details";
export import IngestSqlBucketResponseDetails = IngestSqlBucketResponseDetails.IngestSqlBucketResponseDetails;
import * as IngestSqlPlanLinesDetails from "./ingest-sql-plan-lines-details";
export import IngestSqlPlanLinesDetails = IngestSqlPlanLinesDetails.IngestSqlPlanLinesDetails;
import * as IngestSqlPlanLinesResponseDetails from "./ingest-sql-plan-lines-response-details";
export import IngestSqlPlanLinesResponseDetails = IngestSqlPlanLinesResponseDetails.IngestSqlPlanLinesResponseDetails;
import * as IngestSqlTextDetails from "./ingest-sql-text-details";
export import IngestSqlTextDetails = IngestSqlTextDetails.IngestSqlTextDetails;
import * as IngestSqlTextResponseDetails from "./ingest-sql-text-response-details";
export import IngestSqlTextResponseDetails = IngestSqlTextResponseDetails.IngestSqlTextResponseDetails;
import * as ProjectedDataItem from "./projected-data-item";
export import ProjectedDataItem = ProjectedDataItem.ProjectedDataItem;
import * as ResourceCapacityTrendAggregation from "./resource-capacity-trend-aggregation";
export import ResourceCapacityTrendAggregation = ResourceCapacityTrendAggregation.ResourceCapacityTrendAggregation;
import * as ResourceInsightCurrentUtilization from "./resource-insight-current-utilization";
export import ResourceInsightCurrentUtilization = ResourceInsightCurrentUtilization.ResourceInsightCurrentUtilization;
import * as ResourceInsightProjectedUtilization from "./resource-insight-projected-utilization";
export import ResourceInsightProjectedUtilization = ResourceInsightProjectedUtilization.ResourceInsightProjectedUtilization;
import * as ResourceInsightProjectedUtilizationItem from "./resource-insight-projected-utilization-item";
export import ResourceInsightProjectedUtilizationItem = ResourceInsightProjectedUtilizationItem.ResourceInsightProjectedUtilizationItem;
import * as ResourceStatistics from "./resource-statistics";
export import ResourceStatistics = ResourceStatistics.ResourceStatistics;
import * as ResourceStatisticsAggregation from "./resource-statistics-aggregation";
export import ResourceStatisticsAggregation = ResourceStatisticsAggregation.ResourceStatisticsAggregation;
import * as ResourceUsageTrendAggregation from "./resource-usage-trend-aggregation";
export import ResourceUsageTrendAggregation = ResourceUsageTrendAggregation.ResourceUsageTrendAggregation;
import * as SortOrder from "./sort-order";
export import SortOrder = SortOrder.SortOrder;
import * as SqlBucket from "./sql-bucket";
export import SqlBucket = SqlBucket.SqlBucket;
import * as SqlInsightAggregation from "./sql-insight-aggregation";
export import SqlInsightAggregation = SqlInsightAggregation.SqlInsightAggregation;
import * as SqlInsightAggregationCollection from "./sql-insight-aggregation-collection";
export import SqlInsightAggregationCollection = SqlInsightAggregationCollection.SqlInsightAggregationCollection;
import * as SqlInsightThresholds from "./sql-insight-thresholds";
export import SqlInsightThresholds = SqlInsightThresholds.SqlInsightThresholds;
import * as SqlInventory from "./sql-inventory";
export import SqlInventory = SqlInventory.SqlInventory;
import * as SqlPlanCollection from "./sql-plan-collection";
export import SqlPlanCollection = SqlPlanCollection.SqlPlanCollection;
import * as SqlPlanInsightAggregation from "./sql-plan-insight-aggregation";
export import SqlPlanInsightAggregation = SqlPlanInsightAggregation.SqlPlanInsightAggregation;
import * as SqlPlanInsightAggregationCollection from "./sql-plan-insight-aggregation-collection";
export import SqlPlanInsightAggregationCollection = SqlPlanInsightAggregationCollection.SqlPlanInsightAggregationCollection;
import * as SqlPlanInsights from "./sql-plan-insights";
export import SqlPlanInsights = SqlPlanInsights.SqlPlanInsights;
import * as SqlPlanLine from "./sql-plan-line";
export import SqlPlanLine = SqlPlanLine.SqlPlanLine;
import * as SqlPlanSummary from "./sql-plan-summary";
export import SqlPlanSummary = SqlPlanSummary.SqlPlanSummary;
import * as SqlResponseTimeDistributionAggregation from "./sql-response-time-distribution-aggregation";
export import SqlResponseTimeDistributionAggregation = SqlResponseTimeDistributionAggregation.SqlResponseTimeDistributionAggregation;
import * as SqlResponseTimeDistributionAggregationCollection from "./sql-response-time-distribution-aggregation-collection";
export import SqlResponseTimeDistributionAggregationCollection = SqlResponseTimeDistributionAggregationCollection.SqlResponseTimeDistributionAggregationCollection;
import * as SqlSearchCollection from "./sql-search-collection";
export import SqlSearchCollection = SqlSearchCollection.SqlSearchCollection;
import * as SqlSearchSummary from "./sql-search-summary";
export import SqlSearchSummary = SqlSearchSummary.SqlSearchSummary;
import * as SqlStatisticAggregation from "./sql-statistic-aggregation";
export import SqlStatisticAggregation = SqlStatisticAggregation.SqlStatisticAggregation;
import * as SqlStatisticAggregationCollection from "./sql-statistic-aggregation-collection";
export import SqlStatisticAggregationCollection = SqlStatisticAggregationCollection.SqlStatisticAggregationCollection;
import * as SqlStatistics from "./sql-statistics";
export import SqlStatistics = SqlStatistics.SqlStatistics;
import * as SqlStatisticsTimeSeries from "./sql-statistics-time-series";
export import SqlStatisticsTimeSeries = SqlStatisticsTimeSeries.SqlStatisticsTimeSeries;
import * as SqlStatisticsTimeSeriesAggregation from "./sql-statistics-time-series-aggregation";
export import SqlStatisticsTimeSeriesAggregation = SqlStatisticsTimeSeriesAggregation.SqlStatisticsTimeSeriesAggregation;
import * as SqlStatisticsTimeSeriesAggregationCollection from "./sql-statistics-time-series-aggregation-collection";
export import SqlStatisticsTimeSeriesAggregationCollection = SqlStatisticsTimeSeriesAggregationCollection.SqlStatisticsTimeSeriesAggregationCollection;
import * as SqlStatisticsTimeSeriesByPlanAggregation from "./sql-statistics-time-series-by-plan-aggregation";
export import SqlStatisticsTimeSeriesByPlanAggregation = SqlStatisticsTimeSeriesByPlanAggregation.SqlStatisticsTimeSeriesByPlanAggregation;
import * as SqlStatisticsTimeSeriesByPlanAggregationCollection from "./sql-statistics-time-series-by-plan-aggregation-collection";
export import SqlStatisticsTimeSeriesByPlanAggregationCollection = SqlStatisticsTimeSeriesByPlanAggregationCollection.SqlStatisticsTimeSeriesByPlanAggregationCollection;
import * as SqlText from "./sql-text";
export import SqlText = SqlText.SqlText;
import * as SqlTextCollection from "./sql-text-collection";
export import SqlTextCollection = SqlTextCollection.SqlTextCollection;
import * as SqlTextSummary from "./sql-text-summary";
export import SqlTextSummary = SqlTextSummary.SqlTextSummary;
import * as SummarizeDatabaseInsightResourceCapacityTrendAggregationCollection from "./summarize-database-insight-resource-capacity-trend-aggregation-collection";
export import SummarizeDatabaseInsightResourceCapacityTrendAggregationCollection = SummarizeDatabaseInsightResourceCapacityTrendAggregationCollection.SummarizeDatabaseInsightResourceCapacityTrendAggregationCollection;
import * as SummarizeDatabaseInsightResourceForecastTrendAggregation from "./summarize-database-insight-resource-forecast-trend-aggregation";
export import SummarizeDatabaseInsightResourceForecastTrendAggregation = SummarizeDatabaseInsightResourceForecastTrendAggregation.SummarizeDatabaseInsightResourceForecastTrendAggregation;
import * as SummarizeDatabaseInsightResourceStatisticsAggregationCollection from "./summarize-database-insight-resource-statistics-aggregation-collection";
export import SummarizeDatabaseInsightResourceStatisticsAggregationCollection = SummarizeDatabaseInsightResourceStatisticsAggregationCollection.SummarizeDatabaseInsightResourceStatisticsAggregationCollection;
import * as SummarizeDatabaseInsightResourceUsageAggregation from "./summarize-database-insight-resource-usage-aggregation";
export import SummarizeDatabaseInsightResourceUsageAggregation = SummarizeDatabaseInsightResourceUsageAggregation.SummarizeDatabaseInsightResourceUsageAggregation;
import * as SummarizeDatabaseInsightResourceUsageTrendAggregationCollection from "./summarize-database-insight-resource-usage-trend-aggregation-collection";
export import SummarizeDatabaseInsightResourceUsageTrendAggregationCollection = SummarizeDatabaseInsightResourceUsageTrendAggregationCollection.SummarizeDatabaseInsightResourceUsageTrendAggregationCollection;
import * as SummarizeDatabaseInsightResourceUtilizationInsightAggregation from "./summarize-database-insight-resource-utilization-insight-aggregation";
export import SummarizeDatabaseInsightResourceUtilizationInsightAggregation = SummarizeDatabaseInsightResourceUtilizationInsightAggregation.SummarizeDatabaseInsightResourceUtilizationInsightAggregation;
import * as UsageUnit from "./usage-unit";
export import UsageUnit = UsageUnit.UsageUnit;
