/**
 * Operations Insights API
 * Use the Operations Insights API to perform data extraction operations to obtain database
resource utilization, performance statistics, and reference information. For more information,
see [About Oracle Cloud Infrastructure Operations Insights](https://docs.cloud.oracle.com/en-us/iaas/operations-insights/doc/operations-insights.html).

 * OpenAPI spec version: 20200630
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as IngestSqlBucketRequest from "./ingest-sql-bucket-request";
export import IngestSqlBucketRequest = IngestSqlBucketRequest.IngestSqlBucketRequest;
import * as IngestSqlPlanLinesRequest from "./ingest-sql-plan-lines-request";
export import IngestSqlPlanLinesRequest = IngestSqlPlanLinesRequest.IngestSqlPlanLinesRequest;
import * as IngestSqlTextRequest from "./ingest-sql-text-request";
export import IngestSqlTextRequest = IngestSqlTextRequest.IngestSqlTextRequest;
import * as ListDatabaseInsightsRequest from "./list-database-insights-request";
export import ListDatabaseInsightsRequest = ListDatabaseInsightsRequest.ListDatabaseInsightsRequest;
import * as ListSqlPlansRequest from "./list-sql-plans-request";
export import ListSqlPlansRequest = ListSqlPlansRequest.ListSqlPlansRequest;
import * as ListSqlSearchesRequest from "./list-sql-searches-request";
export import ListSqlSearchesRequest = ListSqlSearchesRequest.ListSqlSearchesRequest;
import * as ListSqlTextsRequest from "./list-sql-texts-request";
export import ListSqlTextsRequest = ListSqlTextsRequest.ListSqlTextsRequest;
import * as SummarizeDatabaseInsightResourceCapacityTrendRequest from "./summarize-database-insight-resource-capacity-trend-request";
export import SummarizeDatabaseInsightResourceCapacityTrendRequest = SummarizeDatabaseInsightResourceCapacityTrendRequest.SummarizeDatabaseInsightResourceCapacityTrendRequest;
import * as SummarizeDatabaseInsightResourceForecastTrendRequest from "./summarize-database-insight-resource-forecast-trend-request";
export import SummarizeDatabaseInsightResourceForecastTrendRequest = SummarizeDatabaseInsightResourceForecastTrendRequest.SummarizeDatabaseInsightResourceForecastTrendRequest;
import * as SummarizeDatabaseInsightResourceStatisticsRequest from "./summarize-database-insight-resource-statistics-request";
export import SummarizeDatabaseInsightResourceStatisticsRequest = SummarizeDatabaseInsightResourceStatisticsRequest.SummarizeDatabaseInsightResourceStatisticsRequest;
import * as SummarizeDatabaseInsightResourceUsageRequest from "./summarize-database-insight-resource-usage-request";
export import SummarizeDatabaseInsightResourceUsageRequest = SummarizeDatabaseInsightResourceUsageRequest.SummarizeDatabaseInsightResourceUsageRequest;
import * as SummarizeDatabaseInsightResourceUsageTrendRequest from "./summarize-database-insight-resource-usage-trend-request";
export import SummarizeDatabaseInsightResourceUsageTrendRequest = SummarizeDatabaseInsightResourceUsageTrendRequest.SummarizeDatabaseInsightResourceUsageTrendRequest;
import * as SummarizeDatabaseInsightResourceUtilizationInsightRequest from "./summarize-database-insight-resource-utilization-insight-request";
export import SummarizeDatabaseInsightResourceUtilizationInsightRequest = SummarizeDatabaseInsightResourceUtilizationInsightRequest.SummarizeDatabaseInsightResourceUtilizationInsightRequest;
import * as SummarizeSqlInsightsRequest from "./summarize-sql-insights-request";
export import SummarizeSqlInsightsRequest = SummarizeSqlInsightsRequest.SummarizeSqlInsightsRequest;
import * as SummarizeSqlPlanInsightsRequest from "./summarize-sql-plan-insights-request";
export import SummarizeSqlPlanInsightsRequest = SummarizeSqlPlanInsightsRequest.SummarizeSqlPlanInsightsRequest;
import * as SummarizeSqlResponseTimeDistributionsRequest from "./summarize-sql-response-time-distributions-request";
export import SummarizeSqlResponseTimeDistributionsRequest = SummarizeSqlResponseTimeDistributionsRequest.SummarizeSqlResponseTimeDistributionsRequest;
import * as SummarizeSqlStatisticsRequest from "./summarize-sql-statistics-request";
export import SummarizeSqlStatisticsRequest = SummarizeSqlStatisticsRequest.SummarizeSqlStatisticsRequest;
import * as SummarizeSqlStatisticsTimeSeriesRequest from "./summarize-sql-statistics-time-series-request";
export import SummarizeSqlStatisticsTimeSeriesRequest = SummarizeSqlStatisticsTimeSeriesRequest.SummarizeSqlStatisticsTimeSeriesRequest;
import * as SummarizeSqlStatisticsTimeSeriesByPlanRequest from "./summarize-sql-statistics-time-series-by-plan-request";
export import SummarizeSqlStatisticsTimeSeriesByPlanRequest = SummarizeSqlStatisticsTimeSeriesByPlanRequest.SummarizeSqlStatisticsTimeSeriesByPlanRequest;
