/**
 * Cloud Advisor API
 * APIs for managing Cloud Advisor. Cloud Advisor provides recommendations that help you maximize cost savings and improve the security posture of your tenancy.
 * OpenAPI spec version: 20200606
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details about bulk recommendation actions.
 */
export interface BulkApplyRecommendationsDetails {
    /**
     * The unique OCIDs of the resource actions that recommendations are applied to.
     */
    "resourceActionIds": Array<string>;
    /**
     * The current status of the recommendation.
     */
    "status": model.Status;
    /**
      * The date and time the current status will change. The format is defined by RFC3339.
  * <p>
  For example, \"The current `postponed` status of the resource action will end and change to `pending` on this
  * date and time.\"
  *
      */
    "timeStatusEnd"?: Date;
}
export declare namespace BulkApplyRecommendationsDetails {
    function getJsonObj(obj: BulkApplyRecommendationsDetails): object;
}
