/**
 * OS Management API
 * API for the OS Management service. Use these API operations for working
with Managed instances and Managed instance groups.

 * OpenAPI spec version: 20190801
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Basic information about a Scheduled Job
 */
export interface ScheduledJobSummary {
    /**
     * OCID for the Scheduled Job
     */
    "id": string;
    /**
     * Scheduled Job name
     */
    "displayName": string;
    /**
     * OCID for the Compartment
     */
    "compartmentId"?: string;
    /**
     * the type of scheduling this Scheduled Job follows
     */
    "scheduleType"?: model.ScheduleTypes;
    /**
     * the time/date of the next scheduled execution of this Scheduled Job
     */
    "timeNextExecution"?: Date;
    /**
     * the time/date of the last execution of this Scheduled Job
     */
    "timeLastExecution"?: Date;
    /**
     * the list of managed instances this scheduled job operates on (mutually exclusive with managedInstanceGroups)
     */
    "managedInstances"?: Array<model.Id>;
    /**
     * the list of managed instance groups this scheduled job operates on (mutually exclusive with managedInstances)
     */
    "managedInstanceGroups"?: Array<model.Id>;
    /**
     * the type of operation this Scheduled Job performs
     */
    "operationType"?: model.OperationTypes;
    /**
     * The current state of the Scheduled Job.
     */
    "lifecycleState"?: model.LifecycleStates;
    /**
     * Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
     * Example: `{\"bar-key\": \"value\"}`
     *
     */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
     * Defined tags for this resource. Each key is predefined and scoped to a namespace.
     * Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`
     *
     */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
    /**
     * The Operating System type of the managed instance.
     */
    "osFamily"?: model.OsFamilies;
}
export declare namespace ScheduledJobSummary {
    function getJsonObj(obj: ScheduledJobSummary): object;
}
