/**
 * Resource Manager API
 * API for the Resource Manager service.
Use this API to install, configure, and manage resources via the "infrastructure-as-code" model.
For more information, see
[Overview of Resource Manager](/iaas/Content/ResourceManager/Concepts/resourcemanager.htm).

 * OpenAPI spec version: 20180917
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * The details for detecting drift in a stack
 *
 */
export interface DetectStackDriftDetails {
    /**
     * The list of resources in the specified stack to detect drift for. Each resource is identified by a resource address,
     * which is a case-insensitive string derived from the resource type and name specified in the stack's Terraform configuration plus an optional index.
     * For example, the resource address for the fourth Compute instance with the name \"test_instance\" is oci_core_instance.test_instance[3].
     * For more details and examples of resource addresses, see the Terraform documentation at [Resource spec](https://www.terraform.io/docs/internals/resource-addressing.html#examples).
     *
     */
    "resourceAddresses"?: Array<string>;
}
export declare namespace DetectStackDriftDetails {
    function getJsonObj(obj: DetectStackDriftDetails): object;
}
