/**
 * Resource Manager API
 * API for the Resource Manager service.
Use this API to install, configure, and manage resources via the "infrastructure-as-code" model.
For more information, see
[Overview of Resource Manager](/iaas/Content/ResourceManager/Concepts/resourcemanager.htm).

 * OpenAPI spec version: 20180917
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Log entry for an operation resulting from a job's execution.
 */
export interface LogEntry {
    /**
     * Specifies the log type for the log entry.
     */
    "type"?: LogEntry.Type;
    /**
     * Specifies the severity level of the log entry.
     */
    "level"?: LogEntry.Level;
    /**
     * The date and time of the log entry.
     * Format is defined by RFC3339.
     * Example: `2020-01-25T21:10:29.600Z`
     *
     */
    "timestamp"?: Date;
    /**
     * The log entry value.
     */
    "message"?: string;
}
export declare namespace LogEntry {
    enum Type {
        TerraformConsole = "TERRAFORM_CONSOLE",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    enum Level {
        Trace = "TRACE",
        Debug = "DEBUG",
        Info = "INFO",
        Warn = "WARN",
        Error = "ERROR",
        Fatal = "FATAL",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: LogEntry): object;
}
