/**
 * Search Service API
 * Search for resources in your cloud network.
 * OpenAPI spec version: 20180409
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Defines a type of resource that you can find with a search or query.
 */
export interface ResourceType {
    /**
     * The unique name of the resource type, which matches the value returned as part of the ResourceSummary object.
     *
     */
    "name": string;
    /**
     * List of all the fields and their value type that are indexed for querying.
     *
     */
    "fields": Array<model.QueryableFieldDescription>;
}
export declare namespace ResourceType {
    function getJsonObj(obj: ResourceType): object;
}
