/**
 * Service Connector Hub API
 * Use the Service Connector Hub API to transfer data between services in Oracle Cloud Infrastructure.
For more information about Service Connector Hub, see
[Service Connector Hub Overview](/iaas/Content/service-connector-hub/overview.htm).

 * OpenAPI spec version: 20200909
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The metric and metric namespace used for the Monitoring target.
 *
 */
export interface MonitoringTargetDetails extends model.TargetDetails {
    /**
     * The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment containing the metric.
     *
     */
    "compartmentId": string;
    /**
      * The namespace of the metric.
  * <p>
  Example: `oci_computeagent`
  *
      */
    "metricNamespace": string;
    /**
      * The name of the metric.
  * <p>
  Example: `CpuUtilization`
  *
      */
    "metric": string;
    "kind": string;
}
export declare namespace MonitoringTargetDetails {
    function getJsonObj(obj: MonitoringTargetDetails, isParentJsonObj?: boolean): object;
    const kind = "monitoring";
}
