/**
 * Service Connector Hub API
 * Use the Service Connector Hub API to transfer data between services in Oracle Cloud Infrastructure.
For more information about Service Connector Hub, see
[Service Connector Hub Overview](/iaas/Content/service-connector-hub/overview.htm).

 * OpenAPI spec version: 20200909
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The configuration details for updating a service connector.
 *
 */
export interface UpdateServiceConnectorDetails {
    /**
     * A user-friendly name. It does not have to be unique, and it is changeable.
     * Avoid entering confidential information.
     *
     */
    "displayName"?: string;
    /**
     * The description of the resource. Avoid entering confidential information.
     *
     */
    "description"?: string;
    "source"?: model.LoggingSourceDetails;
    /**
     * The list of the tasks.
     *
     */
    "tasks"?: Array<model.TaskDetails>;
    "target"?: model.NotificationsTargetDetails | model.ObjectStorageTargetDetails | model.MonitoringTargetDetails | model.FunctionsTargetDetails | model.LoggingAnalyticsTargetDetails | model.StreamingTargetDetails;
    /**
     * Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
     * Example: `{\"bar-key\": \"value\"}`
     *
     */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
     * Defined tags for this resource. Each key is predefined and scoped to a namespace.
     * Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`
     *
     */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
}
export declare namespace UpdateServiceConnectorDetails {
    function getJsonObj(obj: UpdateServiceConnectorDetails): object;
}
