/**
 * Streaming Service API
 * The API for the Streaming Service.
 * OpenAPI spec version: 20180418
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Represents the current state of a consumer group, including partition reservations and committed offsets.
 *
 */
export interface Group {
    /**
     * The streamId for which the group exists.
     */
    "streamId": string;
    /**
     * The name of the consumer group.
     */
    "groupName": string;
    /**
     * An array of the partition reservations of a group.
     */
    "reservations"?: Array<model.PartitionReservation>;
}
export declare namespace Group {
    function getJsonObj(obj: Group): object;
}
