/**
 * Streaming Service API
 * The API for the Streaming Service.
 * OpenAPI spec version: 20180418
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Settings for the Kafka compatibility layer.
 */
export interface KafkaSettings {
    /**
     * Bootstrap servers.
     */
    "bootstrapServers"?: string;
    /**
     * Enable auto creation of topic on the server.
     */
    "autoCreateTopicsEnable"?: boolean;
    /**
     * The number of hours to keep a log file before deleting it (in hours). Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "logRetentionHours"?: number;
    /**
     * The default number of log partitions per topic. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "numPartitions"?: number;
}
export declare namespace KafkaSettings {
    function getJsonObj(obj: KafkaSettings): object;
}
