/**
 * Streaming Service API
 * The API for the Streaming Service.
 * OpenAPI spec version: 20180418
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Optional settings if the stream pool is private.
 */
export interface PrivateEndpointSettings {
    /**
     * The subnet id from which the private stream pool can be accessed.
     * Trying to access the streams from another network location will result in an error.
     *
     */
    "subnetId"?: string;
    /**
     * The private IP associated with the stream pool in the associated subnetId.
     * The stream pool's FQDN resolves to that IP and should be used - instead of the private IP - in order to not trigger any TLS issues.
     *
     */
    "privateEndpointIp"?: string;
    /**
     * The optional list of network security groups that are associated with the private endpoint of the stream pool.
     */
    "nsgIds"?: Array<string>;
}
export declare namespace PrivateEndpointSettings {
    function getJsonObj(obj: PrivateEndpointSettings): object;
}
