/**
 * Streaming Service API
 * The API for the Streaming Service.
 * OpenAPI spec version: 20180418
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The response to a {@link #putMessages(PutMessagesRequest) putMessages} request. It indicates the number
 * of failed messages as well as an array of results for successful and failed messages.
 *
 */
export interface PutMessagesResult {
    /**
     * The number of messages that failed to be added to the stream. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "failures": number;
    /**
     * An array of items representing the result of each message.
     * The order is guaranteed to be the same as in the `PutMessagesDetails` object.
     * If a message was successfully appended to the stream, the entry includes the `offset`, `partition`, and `timestamp`.
     * If a message failed to be appended to the stream, the entry includes the `error` and `errorMessage`.
     *
     */
    "entries": Array<model.PutMessagesResultEntry>;
}
export declare namespace PutMessagesResult {
    function getJsonObj(obj: PutMessagesResult): object;
}
