/**
 * Streaming Service API
 * The API for the Streaming Service.
 * OpenAPI spec version: 20180418
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as serviceRequests from "./request";
import * as serviceResponses from "./response";
import * as models from "./model";
import { StreamAdminClient } from "./client";
export declare class StreamAdminWaiter {
    private client;
    private readonly config?;
    constructor(client: StreamAdminClient, config?: Partial<import("oci-common/lib/waiter").WaiterConfigurationDetails> | undefined);
    /**
     * Waits forConnectHarness till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetConnectHarnessResponse | null (null in case of 404 response)
     */
    forConnectHarness(request: serviceRequests.GetConnectHarnessRequest, ...targetStates: models.ConnectHarness.LifecycleState[]): Promise<serviceResponses.GetConnectHarnessResponse | null>;
    /**
     * Waits forStream till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetStreamResponse | null (null in case of 404 response)
     */
    forStream(request: serviceRequests.GetStreamRequest, ...targetStates: models.Stream.LifecycleState[]): Promise<serviceResponses.GetStreamResponse | null>;
    /**
     * Waits forStreamPool till it reaches any of the provided states
     *
     * @param request the request to send
     * @param targetStates the desired states to wait for. The waiter will return once the resource reaches any of the provided states
     * @return response returns GetStreamPoolResponse | null (null in case of 404 response)
     */
    forStreamPool(request: serviceRequests.GetStreamPoolRequest, ...targetStates: models.StreamPool.LifecycleState[]): Promise<serviceResponses.GetStreamPoolResponse | null>;
}
