/**
 *
 *
 * OpenAPI spec version: 20181116
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import common = require("oci-common");
/**
 * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/1.15.1/waas/ListRecommendations.ts.html |here} to see how to use ListRecommendationsRequest.
 */
export interface ListRecommendationsRequest extends common.BaseRequest {
    /**
     * The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the WAAS policy.
     */
    "waasPolicyId": string;
    /**
     * The unique Oracle-assigned identifier for the request. If you need to contact Oracle about a particular request, please provide the request ID.
     */
    "opcRequestId"?: string;
    /**
     * A filter that matches recommended protection rules based on the selected action. If unspecified, rules with any action type are returned.
     */
    "recommendedAction"?: ListRecommendationsRequest.RecommendedAction;
    /**
     * The maximum number of items to return in a paginated call. If unspecified, defaults to `10`.
     */
    "limit"?: number;
    /**
     * The value of the `opc-next-page` response header from the previous paginated call.
     */
    "page"?: string;
}
export declare namespace ListRecommendationsRequest {
    enum RecommendedAction {
        Detect = "DETECT",
        Block = "BLOCK"
    }
}
