/*
 A JavaScript implementation of the SHA family of hashes, as
 defined in FIPS PUB 180-4 and FIPS PUB 202, as well as the corresponding
 HMAC implementation as defined in FIPS PUB 198a

 Copyright 2008-2020 Brian Turek, 1998-2009 Paul Johnston & Contributors
 Distributed under the BSD License
 See http://caligatio.github.com/jsSHA/ for more information
*/
'use strict';(function(J){function r(d,b,c){var g=0,a=[],h=0,f,m,k,e,l,p,q,t,w=!1,n=[],u=[],v,r=!1;c=c||{};f=c.encoding||"UTF8";v=c.numRounds||1;if(v!==parseInt(v,10)||1>v)throw Error("numRounds must a integer >= 1");if("SHA-1"===d)l=512,p=A,q=K,e=160,t=function(a){return a.slice()};else throw Error("Chosen SHA variant is not supported");k=B(b,f);m=x(d);this.setHMACKey=function(a,b,h){var c;if(!0===w)throw Error("HMAC key already set");if(!0===r)throw Error("Cannot set HMAC key after calling update");
f=(h||{}).encoding||"UTF8";b=B(b,f)(a);a=b.binLen;b=b.value;c=l>>>3;h=c/4-1;for(c<a/8&&(b=q(b,a,0,x(d),e));b.length<=h;)b.push(0);for(a=0;a<=h;a+=1)n[a]=b[a]^909522486,u[a]=b[a]^1549556828;m=p(n,m);g=l;w=!0};this.update=function(b){var e,f,c,d=0,q=l>>>5;e=k(b,a,h);b=e.binLen;f=e.value;e=b>>>5;for(c=0;c<e;c+=q)d+l<=b&&(m=p(f.slice(c,c+q),m),d+=l);g+=d;a=f.slice(d>>>5);h=b%l;r=!0};this.getHash=function(b,f){var c,k,l,p;if(!0===w)throw Error("Cannot call getHash after setting HMAC key");l=C(f);switch(b){case "HEX":c=
function(a){return D(a,e,l)};break;case "B64":c=function(a){return E(a,e,l)};break;case "BYTES":c=function(a){return F(a,e)};break;case "ARRAYBUFFER":try{k=new ArrayBuffer(0)}catch(z){throw Error("ARRAYBUFFER not supported by this environment");}c=function(a){return G(a,e)};break;case "UINT8ARRAY":try{k=new Uint8Array(0)}catch(z){throw Error("UINT8ARRAY not supported by this environment");}c=function(a){return H(a,e)};break;default:throw Error("format must be HEX, B64, BYTES, ARRAYBUFFER, or UINT8ARRAY");
}p=q(a.slice(),h,g,t(m),e);for(k=1;k<v;k+=1)p=q(p,e,0,x(d),e);return c(p)};this.getHMAC=function(b,c){var f,k,n,r;if(!1===w)throw Error("Cannot call getHMAC without first setting HMAC key");n=C(c);switch(b){case "HEX":f=function(a){return D(a,e,n)};break;case "B64":f=function(a){return E(a,e,n)};break;case "BYTES":f=function(a){return F(a,e)};break;case "ARRAYBUFFER":try{f=new ArrayBuffer(0)}catch(z){throw Error("ARRAYBUFFER not supported by this environment");}f=function(a){return G(a,e)};break;
case "UINT8ARRAY":try{f=new Uint8Array(0)}catch(z){throw Error("UINT8ARRAY not supported by this environment");}f=function(a){return H(a,e)};break;default:throw Error("outputFormat must be HEX, B64, BYTES, ARRAYBUFFER, or UINT8ARRAY");}k=q(a.slice(),h,g,t(m),e);r=p(u,x(d));r=q(k,e,l,r,e);return f(r)}}function I(d,b,c){var g,a,h,f;b=b||[0];c=c||0;a=c>>>3;for(g=0;g<d.length;g+=1)f=g+a,h=f>>>2,b.length<=h&&b.push(0),b[h]|=d[g]<<8*(3+f%4*-1);return{value:b,binLen:8*d.length+c}}function D(d,b,c){var g=
"";b/=8;var a,h;for(a=0;a<b;a+=1)h=d[a>>>2]>>>8*(3+a%4*-1),g+="0123456789abcdef".charAt(h>>>4&15)+"0123456789abcdef".charAt(h&15);return c.outputUpper?g.toUpperCase():g}function E(d,b,c){var g="",a=b/8,h,f,m;for(h=0;h<a;h+=3)for(f=h+1<a?d[h+1>>>2]:0,m=h+2<a?d[h+2>>>2]:0,m=(d[h>>>2]>>>8*(3+h%4*-1)&255)<<16|(f>>>8*(3+(h+1)%4*-1)&255)<<8|m>>>8*(3+(h+2)%4*-1)&255,f=0;4>f;f+=1)8*h+6*f<=b?g+="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charAt(m>>>6*(3-f)&63):g+=c.b64Pad;return g}function F(d,
b){var c="",g=b/8,a,h;for(a=0;a<g;a+=1)h=d[a>>>2]>>>8*(3+a%4*-1)&255,c+=String.fromCharCode(h);return c}function G(d,b){var c=b/8,g,a=new ArrayBuffer(c),h;h=new Uint8Array(a);for(g=0;g<c;g+=1)h[g]=d[g>>>2]>>>8*(3+g%4*-1)&255;return a}function H(d,b){var c=b/8,g,a=new Uint8Array(c);for(g=0;g<c;g+=1)a[g]=d[g>>>2]>>>8*(3+g%4*-1)&255;return a}function C(d){var b={outputUpper:!1,b64Pad:"=",shakeLen:-1};d=d||{};b.outputUpper=d.outputUpper||!1;!0===d.hasOwnProperty("b64Pad")&&(b.b64Pad=d.b64Pad);if("boolean"!==
typeof b.outputUpper)throw Error("Invalid outputUpper formatting option");if("string"!==typeof b.b64Pad)throw Error("Invalid b64Pad formatting option");return b}function B(d,b){var c;switch(b){case "UTF8":case "UTF16BE":case "UTF16LE":break;default:throw Error("encoding must be UTF8, UTF16BE, or UTF16LE");}switch(d){case "HEX":c=function(b,a,h){var f=b.length,c,d,e,l,p;if(0!==f%2)throw Error("String of HEX type must be in byte increments");a=a||[0];h=h||0;p=h>>>3;for(c=0;c<f;c+=2){d=parseInt(b.substr(c,
2),16);if(isNaN(d))throw Error("String of HEX type contains invalid characters");l=(c>>>1)+p;for(e=l>>>2;a.length<=e;)a.push(0);a[e]|=d<<8*(3+l%4*-1)}return{value:a,binLen:4*f+h}};break;case "TEXT":c=function(g,a,c){var f,d,k=0,e,l,p,q,t,n;a=a||[0];c=c||0;p=c>>>3;if("UTF8"===b)for(n=3,e=0;e<g.length;e+=1)for(f=g.charCodeAt(e),d=[],128>f?d.push(f):2048>f?(d.push(192|f>>>6),d.push(128|f&63)):55296>f||57344<=f?d.push(224|f>>>12,128|f>>>6&63,128|f&63):(e+=1,f=65536+((f&1023)<<10|g.charCodeAt(e)&1023),
d.push(240|f>>>18,128|f>>>12&63,128|f>>>6&63,128|f&63)),l=0;l<d.length;l+=1){t=k+p;for(q=t>>>2;a.length<=q;)a.push(0);a[q]|=d[l]<<8*(n+t%4*-1);k+=1}else if("UTF16BE"===b||"UTF16LE"===b)for(n=2,d="UTF16LE"===b&&!0||"UTF16LE"!==b&&!1,e=0;e<g.length;e+=1){f=g.charCodeAt(e);!0===d&&(l=f&255,f=l<<8|f>>>8);t=k+p;for(q=t>>>2;a.length<=q;)a.push(0);a[q]|=f<<8*(n+t%4*-1);k+=2}return{value:a,binLen:8*k+c}};break;case "B64":c=function(b,a,c){var f=0,d,k,e,l,p,q,n;if(-1===b.search(/^[a-zA-Z0-9=+\/]+$/))throw Error("Invalid character in base-64 string");
k=b.indexOf("=");b=b.replace(/\=/g,"");if(-1!==k&&k<b.length)throw Error("Invalid '=' found in base-64 string");a=a||[0];c=c||0;q=c>>>3;for(k=0;k<b.length;k+=4){p=b.substr(k,4);for(e=l=0;e<p.length;e+=1)d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".indexOf(p.charAt(e)),l|=d<<18-6*e;for(e=0;e<p.length-1;e+=1){n=f+q;for(d=n>>>2;a.length<=d;)a.push(0);a[d]|=(l>>>16-8*e&255)<<8*(3+n%4*-1);f+=1}}return{value:a,binLen:8*f+c}};break;case "BYTES":c=function(b,a,c){var d,m,k,e,l;a=a||
[0];c=c||0;k=c>>>3;for(m=0;m<b.length;m+=1)d=b.charCodeAt(m),l=m+k,e=l>>>2,a.length<=e&&a.push(0),a[e]|=d<<8*(3+l%4*-1);return{value:a,binLen:8*b.length+c}};break;case "ARRAYBUFFER":try{c=new ArrayBuffer(0)}catch(g){throw Error("ARRAYBUFFER not supported by this environment");}c=function(b,a,c){return I(new Uint8Array(b),a,c)};break;case "UINT8ARRAY":try{c=new Uint8Array(0)}catch(g){throw Error("UINT8ARRAY not supported by this environment");}c=function(b,a,c){return I(b,a,c)};break;default:throw Error("format must be HEX, TEXT, B64, BYTES, ARRAYBUFFER, or UINT8ARRAY");
}return c}function n(d,b){return d<<b|d>>>32-b}function u(d,b){var c=(d&65535)+(b&65535);return((d>>>16)+(b>>>16)+(c>>>16)&65535)<<16|c&65535}function y(d,b,c,g,a){var h=(d&65535)+(b&65535)+(c&65535)+(g&65535)+(a&65535);return((d>>>16)+(b>>>16)+(c>>>16)+(g>>>16)+(a>>>16)+(h>>>16)&65535)<<16|h&65535}function x(d){var b=[];if("SHA-1"===d)b=[1732584193,4023233417,2562383102,271733878,3285377520];else throw Error("No SHA variants supported");return b}function A(d,b){var c=[],g,a,h,f,m,k,e;g=b[0];a=b[1];
h=b[2];f=b[3];m=b[4];for(e=0;80>e;e+=1)c[e]=16>e?d[e]:n(c[e-3]^c[e-8]^c[e-14]^c[e-16],1),k=20>e?y(n(g,5),a&h^~a&f,m,1518500249,c[e]):40>e?y(n(g,5),a^h^f,m,1859775393,c[e]):60>e?y(n(g,5),a&h^a&f^h&f,m,2400959708,c[e]):y(n(g,5),a^h^f,m,3395469782,c[e]),m=f,f=h,h=n(a,30),a=g,g=k;b[0]=u(g,b[0]);b[1]=u(a,b[1]);b[2]=u(h,b[2]);b[3]=u(f,b[3]);b[4]=u(m,b[4]);return b}function K(d,b,c,g){var a;for(a=(b+65>>>9<<4)+15;d.length<=a;)d.push(0);d[b>>>5]|=128<<24-b%32;b+=c;d[a]=b&4294967295;d[a-1]=b/4294967296|0;
b=d.length;for(a=0;a<b;a+=16)g=A(d.slice(a,a+16),g);return g}"function"===typeof define&&define.amd?define(function(){return r}):"undefined"!==typeof exports?("undefined"!==typeof module&&module.exports&&(module.exports=r),exports=r):J.jsSHA=r})(this);
